2021-01-27  Brian C. Lane  <bcl@redhat.com>

	version 3.4
	* NEWS: Record release date.

	NEWS: Mention the non-public gnulib commit

2021-01-26  Brian C. Lane  <bcl@redhat.com>

	cfg.mk: disable submodule checks to work around broken upstream gnulib

	Include local gnulib change to version-etc.c date

2021-01-18  Brian C. Lane  <bcl@redhat.com>

	maint: Update copyright statements to 2021
	By running make update-copyright

	README-release: Add information for updating the Translation Project

2020-12-14  Brian C. Lane  <bcl@redhat.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 3.3.52
	* NEWS: Record release date.

2020-12-11  Brian C. Lane  <bcl@redhat.com>

	libparted/fs: Add ./lib to include search path

	libparted: Check for NULL flag_name in ped_partition_flag_get_by_name
	strcasecmp parameters cannot be NULL according to gcc -Wanalyzer-null-argument

	po/POTFILES.in: Remove xstrtol-error.c
	Appears to no longer be needed, results in an error when running make
	check syntax-check.

	maint: Update copyright statements to 2020
	By running make update-copyright

	configure.ac (AC_PREREQ): Require 2.64

	maint: Bump library REVISION number for release

	maint: Update bootstrap script from latest gnulib

	maint: Update to latest gnulib

2020-12-04  Brian C. Lane  <bcl@redhat.com>

	labels/bsd.c: Drop alpha_bootblock_checksum from bsd_probe
	Thanks to Alpine Linux for catching this. In commit
	a5f69f396713ab8ac1e57458cbb9af552d2c1659 I change label to actually
	point to the label and failed to pass the new s0 to
	alpha_bootblock_checksum() instead of label. So it was writing the
	so-called checksum off the end of the 512b sector buffer.

	bug: https://gitlab.alpinelinux.org/alpine/aports/-/issues/12161
	upstream report: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=45026

2020-11-20  Brian C. Lane  <bcl@redhat.com>

	libparted/fs: Fix GCC warnings suggesting pure for PED_ASSERT functions
	There was some question about whether or not pure should be used for
	functions with PED_ASSERT (or exit) in them. It should be fine, since
	the values checked by the ASSERT are passed to the function directly.
	Behavior should be exactly the same for the same inputs.

	libparted: Remove disabled code

	fs/r/hfs: Remove disabled code

	fs/r/fat: Remove disabled code

	hfs/reloc_plus: Fix gcc 10 warnings about cast alignment

	hfs/reloc: Fix gcc 10 warnings about cast alignment

	ui: Fix gcc 10 warning about snprintf truncating an int
	Double the storage to 20 bytes.

	ui: Fix command_line_get_disk_flag
	It was using PedPartitionFlag instead of PedDiskFlag when walking the
	available flags.

	ped_assert: Fix incorrect exception option
	PED_EXCEPTION_FATAL is a type, not an option. A PED_EXCEPTION_BUG should
	always select CANCEL.

	ufs:  Fix gcc 10 warnings about cast alignment

	ntfs:  Fix gcc 10 warnings about cast alignment

	nilfs2: Fix gcc 10 warnings about cast alignment

	ext2: Fix gcc 10 warnings about cast alignment

	hfs/hfs: Fix gcc 10 warnings about cast alignment

	hfs/advfs_plus: Fix gcc 10 warnings about cast alignment

	hfs/advfs: Fix gcc 10 warnings about cast alignment

	hfs: Fix gcc 10 bounds check warning
	binfo is actually a list of structs that cannot be known until runtime,
	so use a variable length array.

	tests: Fix unsigned warning in duplicate.c

	linux: Fix gcc complains about signed sccanf variables

	dos: Fix gcc complaints when using boot_code pointer

	bsd: Fix gcc complaints when using boot_code pointer

2020-11-20  Shin'ichiro Kawasaki  <kawasaki@juno.dti.ne.jp>

	libparted: Fix warnings from GCC 8 -Wsuggest-attribute=const
	As GCC 8 suggests, add 'const' attribute to six functions. After adding
	const attributes, GCC suggested two more functions to add const
	attributes. Add const attributes to those functions also. In total, add
	const attributes to 8 functions.

	I read code of the functions and confirmed they are const: they examine
	only their arguments and have no effect other than return value.

2020-11-20  Shin'ichiro Kawasaki  <kawasaki@juno.dti.ne.jp>

	libparted: Fix warnings from GCC 8 -Wsuggest-attribute=pure
	As GCC 8 suggests, add 'pure' attribute to 17 functions. After adding
	pure attributes, GCC suggested three more functions to add pure
	attributes. Add pure attribute to those functions also. In total, add
	pure attributes to 20 functions.

	I read code of the functions and confirmed the 20 functions are pure:
	they have no effect except the return value, and their return value
	depend only on the parameters and/or global variables.

2020-11-05  Shin'ichiro Kawasaki  <kawasaki@juno.dti.ne.jp>

	libparted: Avoid a GCC warning for unused functions
	libparted/fs/r/hfs/hfs.c has a '#if 0' block. The block refers two
	functions hfsplus_clobber() and hfs_clobber(). It have GCC report a
	warning below.

	  CC       r/hfs/hfs.lo
	r/hfs/hfs.c:343:1: warning: 'hfsplus_clobber' defined but not used [-Wunused-function]
	  343 | hfsplus_clobber (PedGeometry* geom)
	      | ^~~~~~~~~~~~~~~

	To avoid the warning, add two more '#if 0' to disable the two functions.

2020-11-05  Shin'ichiro Kawasaki  <kawasaki@juno.dti.ne.jp>

	libparted: Fix warnings from GCC's -Wimplicit-fallthrough
	Two case statements have intentional fall-throughs but do not have
	comments to note it. GCC detects and warns those case statements. To
	avoid the warning, add fall-through comments.

2020-11-05  Shin'ichiro Kawasaki  <kawasaki@juno.dti.ne.jp>

	libparted: Fix warnings from GCC 8 -Wunused-variable and -Warray-bounds
	GCC 8 reports two warnings as follows.

	r/fat/bootsector.c: In function 'fat_boot_sector_set_boot_code':
	r/fat/bootsector.c:274:15: warning: unused variable 'fs_info' [-Wunused-variable]
	  FatSpecific* fs_info = FAT_SPECIFIC (fs);
	               ^~~~~~~
	In function 'memcpy',
	    inlined from 'fat_boot_sector_set_boot_code' at r/fat/bootsector.c:283:2:
	/usr/include/bits/string_fortified.h:34:10: warning: '__builtin_memcpy' forming offset [126, 128] is out of the bounds [0, 125] [-Warray-bounds]
	   return __builtin___memcpy_chk (__dest, __src, __len, __bos0 (__dest));
	          ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	To avoid the warnings, remove the unused variable. Use strcpy in place of
	memcpy checking copy length.

2020-11-05  Shin'ichiro Kawasaki  <kawasaki@juno.dti.ne.jp>

	libparted: Fix a GCC warning -Wunused-but-set-variable
	GCC warns that a variable 'prealloc' defined for _generic_affs_probe() in
	fs/amiga/affs.c is set but its value is never used.

	  CC       amiga/affs.lo
	amiga/affs.c: In function '_generic_affs_probe':
	amiga/affs.c:54:35: warning: variable 'prealloc' set but not used [-Wunused-but-set-variable]
	   54 |  int blocksize = 1, reserved = 2, prealloc = 0;
	      |                                   ^~~~~~~~
	Remove the variable for simplicity and to avoid the warning.

2020-11-05  Brian C. Lane  <bcl@redhat.com>

	tests: Update all the dmsetup tests to use ENABLE_DEVICE_MAPPER

2020-11-05  Joe Slater  <joe.slater@windriver.com>

	t6001-psep: modify device manage support detection
	Use the method other tests use -- test an environment variable.

2020-11-05  Petr Lautrbach  <plautrba@redhat.com>

	Do not link to libsepol or libselinux
	Given that there's no code which would use it there's no reason to link
	to libsepol or libselinux even when they are available.

2020-09-01  Brian C. Lane  <bcl@redhat.com>

	tests: Add a test for resizepart on a busy partition
	This makes sure that the resizepart on a busy partition with the size on
	the cmdline will work.

2020-08-31  Brian C. Lane  <bcl@redhat.com>

	parted: Preserve resizepart End when prompted for busy partition
	Resizing busy partitions is allowed, but the user is prompted, which
	erases the cmdline. It is annoying to have to re-end the ending location
	after answering Yes. This saves the word and pushes it back onto the
	cmdline after the user agrees to resize the busy partition.

2020-05-04  Romain Perier  <romain.perier@gmail.com>

	tests: Add f2fs to the fs probe test

	Add support for the F2FS filesystem
	This adds a basic support for the Flash-Friendly File System. So
	we can manipulate the file system by using the PedFileSystem API and we
	can do basic device probing for autodetecting the current fs.

2020-03-09  Max Campbell  <max@0m.ax>

	Removed reference to ped_file_system_create
	Removed a reference to the removed function ped_file_system_create in
	the docs for ped_file_system_clobber.

2019-12-20  Brian C. Lane  <bcl@redhat.com>

	NEWS: Add bls_boot to new features

	libparted: Add support for bls_boot to GPT disks
	This sets the partition GUID to bc13c2ff-59e6-4262-a352-b275fd6f7172 to
	indicate that the partition is a Boot Loader Specification compatible
	/boot partition.

	libparted: Add support for MSDOS partition type bls_boot (0xea)
	This type is used by the Boot Loader Specification to identify a
	compatible /boot boot partition.

2019-12-20  Alper Nebi Yasak  <alpernebiyasak@gmail.com>

	libparted: Add ChromeOS Kernel partition flag
	This adds a GPT-only partition type flag, chromeos_kernel, for use on
	Chrome OS machines, with GUID FE3A2A5D-4F32-41A7-B725-ACCC3285A309.

	The firmware/bootloader in these machines relies on special images being
	written to partitions of this type. Among multiple such partitions, it
	decides which one it will boot from based on the GUID-specific partition
	attributes. This patch is not intended to and does not manipulate these
	bits.

	Google refers to these partitions as "ChromeOS kernel" partitions. They
	also define partitions for rootfs, firmware, and a reserved one; but
	these are not necessary for the boot flow and are not included here.

	Relevant ChromiumOS documentation:
	https://www.chromium.org/chromium-os/chromiumos-design-docs/disk-format

2019-12-16  Brian C. Lane  <bcl@redhat.com>

	Fix end_input usage in do_resizepart
	It needs to be set to NULL, since it may not get set by the call to
	command_line_get_sector

	tests: Test incomplete resizepart command

2019-10-11  Brian C. Lane  <bcl@redhat.com>

	maint: Add note about gpg key selection for gnupload

	Switch gpt-header-move and msdos-overlap to python3
	python2 is EOL on January 1, 2020 so it is time to switch to python3.

2019-10-10  Brian C. Lane  <bcl@redhat.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 3.3
	* NEWS: Record release date.

	NEWS: Note the fix for the s390 bug

2019-09-30  Viktor Mihajlovski  <mihajlov@linux.ibm.com>

	libparted/s390: Re-enabled virtio-attached DASD heuristics
	DASDs attached to KVM guest as virtio-blk devices are only handled
	properly, if the unique DASD geometry is detected. Commit id
	61dd3d4c5eb782eb43caa95342e63727db3f8281 has prevented proper geometry
	detection. Fixed by making sure that HDIO_GETGEO takes precedence
	on s390[x].

2019-08-21  Brian C. Lane  <bcl@redhat.com>

	README-release: Add link to upload registration page
	Without this you cannot use gnupload to send the new release tarball to
	the ftp servers.

2019-08-12  Brian C. Lane  <bcl@redhat.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 3.2.153
	* NEWS: Record release date.

	maint: Move NEWS template to line 3

	maint: Update copyright statements to 2019
	By running make update-copyright

	maint: Bump library REVISION number for release

	maint: Update bootstrap script from latest gnulib

	maint: Update to latest gnulib

2019-08-09  Brian C. Lane  <bcl@redhat.com>

	libparted: Fix bug in bsd.c alpha_bootblock_checksum
	I flubbed this in e35af6cbc43f5b279e6f0d65ccc904b1ac6c63d2 by trying to
	switch to using a pointer and ended up writing off the end. Switch the
	loop in alpha_bootblock_checksum back to use [i] index. It's easier
	to read anyway.

	doc: Create po directory if missing
	When running 'make distcheck' the directory tree it uses is created
	without the po directory. Create it if it is missing.

	dist-check.mk: Remove empty .deps directories
	Borrowed from coreutils commits 373ba16f332d and 40434e566e52

	Turn off c_prohibit_gnu_make_extensions

	po: Add argmatch.h

	bsd.c: Rewrite disklabel code to prevent gcc warnings
	Constructing a pointer into a char array results in warnings about casting
	changing alignment. This changes how the boot sector is handled by adding the
	label to BSDDiskData with the correct offset (64 bytes).

	Add gcc malloc attribute to ped_alloc and ped_calloc

2019-08-09  Shin'ichiro Kawasaki  <kawasaki@juno.dti.ne.jp>

	libparted: Replace abs() with llabs()
	GCC 9 fails to compile a few C source files which call abs() function.
	An example of the error messages was as follows:

	  CC       dos.lo
	dos.c: In function '_best_solution':
	dos.c:1773:13: error: absolute value function 'abs' given an argument of type 'long long int' but has parameter of type 'int' which may cause truncation of value [-Werror=absolute-value]
	 1773 |   a_delta = abs (part->geom.start - a->start);
	      |             ^~~
	dos.c:1774:13: error: absolute value function 'abs' given an argument of type 'long long int' but has parameter of type 'int' which may cause truncation of value [-Werror=absolute-value]
	 1774 |   b_delta = abs (part->geom.start - b->start);
	      |             ^~~
	cc1: all warnings being treated as errors

	To avoid the errors, replace abs() function calls with llabs().

2019-08-09  Brian C. Lane  <bcl@redhat.com>

	sun.c: Aligned _SunRawLabel to 16bit boundary

	gpt.c: Drop cast of efi_guid_t to unsigned char *
	This confuses gcc, making it think the uuid_t is unaligned when it really comes
	from a efi_guid_t entry in _GPTDiskData.

	gpt.c: Align _GPTDiskData to 8 byte boundary

	dvh.c: Use memcpy instead of strncpy
	The strings are short, so using memcpy isn't much slower (if at all).  This
	fixes gcc complaining about strncpy possibly copying a non-terminated string.

2019-08-09  Shin'ichiro Kawasaki  <kawasaki@juno.dti.ne.jp>

	include/parted/unit.in.h: Specify const attribute to ped_unit_get_name()
	GCC 8 fails to compile libparted/unit.c with an error:

	  CC       unit.lo
	unit.c:155:1: error: function might be candidate for attribute 'const' [-Werror=suggest-attribute=const]
	 ped_unit_get_name (PedUnit unit)
	 ^~~~~~~~~~~~~~~~~
	  CC       disk.lo
	cc1: all warnings being treated as errors

	Const attribute is required for the function ped_unit_get_name() because
	its return value is not affected by program status. To avoid the build
	failure, change attribute of the function from pure to const.

2019-08-09  Shin'ichiro Kawasaki  <kawasaki@juno.dti.ne.jp>

	libparted/labels/pt-tools.c: Fix gperf generated function attribute
	GCC 8 fails to compile libparted/labels/pt-tools.c with an error:

	  CC       pt-tools.lo
	In file included from pt-tools.c:114:
	pt-tools.c: In function 'pt_limit_lookup':
	pt-limit.gperf:78:1: error: function might be candidate for attribute 'pure' [-Werror=suggest-attribute=pure]
	cc1: all warnings being treated as errors

	"Pure" attribute is required for the function pt_limit_lookup() because
	it does not change program status other than its return value.

	To avoid the build failure, add _GL_ATTRIBUTE_PURE to the function.
	The attribute cannot be added in libparted/gperf/pt-limit.c because it
	is generated by gperf during the build process. Instead, add the
	attribute in libparted/gperf/pt-tools.c which includes the generated
	function.

2019-08-09  Shin'ichiro Kawasaki  <kawasaki@juno.dti.ne.jp>

	configure.ac: Check ABI against ABI version 2
	GCC 8 fails to compile libparted/labels/aix.c with an error:

	  CC       aix.lo
	cc1: error: -Wabi won't warn about anything [-Werror=abi]
	cc1: note: -Wabi warns about differences from the most up-to-date ABI, which is
	also used by default
	cc1: note: use e.g. -Wabi=11 to warn about changes from GCC 7
	cc1: all warnings being treated as errors
	make[4]: *** [Makefile:1250: aix.lo] Error 1

	To avoid the build failure, specify ABI version 2 to check ABI change
	from GCC 4.9.

2019-08-09  Brian C. Lane  <bcl@redhat.com>

	Adjust the gcc warnings to recognize FALLTHROUGH

	dos.c: Fix cast alignment error in maybe_FAT

	atari.c: Align the AtariRawTable on a 16bit boundary
	The casts to uint16_t need to know that this will be aligned. The struct is
	actually 512 bytes, so it normally does end up aligned. This just makes sure
	the compiler knows it and stops warning about the casts.

	Change 'time stamp' to 'timestamp'
	Caught by make syntax-check

	Fix double semi-colons
	Caught by make syntax-check

	Update syntax-check NEWS hash to cover 3.2 release notes.

	Fix syntax-check complaints about tests

	Remove trailing whitespace
	Caught by make syntax-check

	Remove unnecessary if before free checks
	Caught by make syntax-check

2019-08-09  Brian C. Lane  <bcl@redhat.com>

	configure.ac: Remove default -Werror flag
	Warnings as errors does not make sense with the current state of the
	codebase and it is making it difficult to do new releases.

	We should *show* the warnings, and handle them as time permits, but they
	should not block building a new release.

2019-08-09  Brian C. Lane  <bcl@redhat.com>

	README-release: Updating the release instructions

2019-08-05  A. Wilcox  <AWilcox@Wilcox-Tech.com>

	libparted: Fix endian bug in bsd.c
	You have to add 1 *before* doing the endian conversion, not after.

2019-07-15  Max Staudt  <max@enpas.org>

	libparted/fs/amiga/affs.c: Remove printf() to avoid confusion
	Currently, the affs code in libparted prints a debug line to stdout when
	an Amiga FFS partition is probed. This confuses tools that parse stdout.

	A prominent example is the partitioner (partman) in Debian's installer,
	which parses stdout from a tool (parted_devices) that uses libparted to
	scan the system's block devices. As of now, Debian cannot be installed
	on a typical Amiga:

	  https://lists.debian.org/debian-68k/2019/07/msg00015.html

	This patch removes this unexpected printf().

	Cc: glaubitz@debian.org

2019-04-09  Michael Small  <smallm@sdf.org>

	Tests case for sigsegv when false nilfs2 superblock detected.

2019-04-09  Michael Small  <smallm@sdf.org>

	Avoid sigsegv in case 2nd nilfs2 superblock magic accidently found.
	1. is_valid_nilfs_sb: make sure the subtraction bytes - sumoff - 4
	won't give a negative number. That as the len argument to
	__efi_crc32() would give a very large number for the latter's for
	loop limit, since len is unsigned long.

	2. nilfs2_probe: Read and allocate enough sectors to hold a
	struct nilfs2_super_block.  is_valid_nilfs_sb() will be passing
	up to 1024 bytes to __efi_crc32(). If only one 512 byte sector
	had been allocated with alloca and read from disk that would cause
	reads off the the end of the stack even if bytes were more than
	sumoff - 4.

2019-02-11  Brian C. Lane  <bcl@redhat.com>

	Fix align-check help output

2019-01-31  Hans-Joachim Baader  <baader@gmx.net>

	Added support for Windows recovery partition (WINRE) on MBR
	Windows 10 uses a recovery partition which is sometimes marked with
	partition type 0x27 on MBR systems. It wasn't possible to handle such
	a partition with parted. Therefore the partition type PARTITION_MSFT_RECOVERY
	is now used properly also on MBR when the flag msftres is set.

2019-01-31  Brian C. Lane  <bcl@redhat.com>

	parted: Remove PED_ASSERT from ped_partition_set_name
	Asserts should only check logic, not wrap functions with side-effects.
	When compiled with --disable-debug this causes the name field of mkpart
	to be ignored.

2019-01-30  Brian C. Lane  <bcl@redhat.com>

	docs: Update GNU License version in parted .text files

2018-10-16  dann frazier  <dann.frazier@canonical.com>

	Read NVMe model names from sysfs
	parted currently shows the same generic model name for all NVMe devices:

	  # parted /dev/nvme0n1 -s print | grep Model
	  Model: NVMe Device (nvme)

	If the model information is available in sysfs, display that instead:

	  # parted /dev/nvme0n1 -s print | grep Model
	  Model: THNSN5512GPU7 NVMe TOSHIBA 512GB (nvme)

2018-10-16  dann frazier  <dann.frazier@canonical.com>

	Fix warnings from GCC 7's -Wimplicit-fallthrough
	All of these locations appear to have intentional fallthroughs. Add
	comments that GCC will detect to mute warnings w/ -Wimplicit-fallthrough.

2018-10-16  dann frazier  <dann.frazier@canonical.com>

	ped_unit_get_name: Resolve conflicting attributes 'const' and 'pure'
	The const and pure attributes conflict:

	  error: ignoring attribute 'const' because it conflicts with attribute 'pure' [-Werror=attributes]

	pure functions may access global memory, const functions may not.
	ped_unit_get_name() accesses non-local variable unit_names, so drop const.

2018-10-16  Brian C. Lane  <bcl@redhat.com>

	Add udf to t1700-probe-fs and to the manpage
	If mkfs.udf is installed this will test to make sure that the filesystem
	is detected.

2018-10-16  Pali Rohár  <pali.rohar@gmail.com>

	libparted: Add support for MBR id, GPT GUID and detection of UDF filesystem
	This is needed for libparted based applications (like Gparted) to correctly
	choose MBR id and GPT GUID for UDF filesystem. MBR id for UDF is 0x07 and
	GPT GUID is Microsoft Basic Data, see why: https://serverfault.com/a/829172

	Without registering a new libparted fs code it is not possible to assign
	MBR id or GPT GUID.

	Detection of UDF filesystem is done by checking presence of UDF VSD (NSR02
	or NSR03 identifier) and UDF AVDP at expected locations (blocks 256, -257,
	-1, 512).

2018-10-16  Simon Xu  <xu.simon@oracle.com>

	Fix potential command line buffer overflow
	parted terminates with 'stack smashing detected' when fed with a long command
	line argument, and segfaults when the argument is long enough:

	root # /sbin/parted /dev/sda $(perl -e 'print "a"x265')
	*** stack smashing detected ***: /sbin/parted terminated
	...
	Aborted

	root # /sbin/parted /dev/sda $(perl -e 'print "a"x328')
	*** stack smashing detected ***: /sbin/parted terminated
	...
	Command History:
	Segmentation fault

	parted should be able to detect it and exit with error and usage messages.
	This also makes command line buffer overflow exploit more possible.  Fix it by
	adding length check in the condition of the for loop where command line
	arguments are copied.

2018-08-22  Brian C. Lane  <bcl@redhat.com>

	t6100-mdraid-partitions: Use v0.90 metadata for the test
	Newer metadata types use more disk space, causing the test to fail.

2018-08-22  Brian C. Lane  <bcl@redhat.com>

	parted.c: Make sure dev_name is freed
	If there was a problem with ped_device_get or ped_device_open it would not be freed.

	Related: rhbz#1602652

2018-08-22  Brian C. Lane  <bcl@redhat.com>

	parted.c: Always free peek_word
	If command_line_get_fs_type failed it would never free it, so put a free
	in both branches of the if.

	Related: rhbz#1602652

2018-08-22  Brian C. Lane  <bcl@redhat.com>

	Fix the length of several strncpy calls
	These need to be 1 less than the allocated size of the buffer, strncpy
	will fill shorter strings with zeros, but there needs to be room for at
	least one 0x00 at the end if the string is the same length as the buffer
	and has no terminating 0x00.

	Related: rhbz#1602652

2018-08-22  Brian C. Lane  <bcl@redhat.com>

	Modify gpt-header-move and msdos-overlap to work with py2 or py3
	Distributions are starting to remove python2 and only use python3.
	Modify these test scripts so that they will work with either python 2.7
	or python 3.X

2018-08-22  Ulrich Müller  <ulm@gentoo.org>

	libparted: Fix ending CHS address in PMBR.
	According to the UEFI specification version 2.7, Section 5.2.3,
	Table 16, the ending CHS address in the protective MBR should be set
	to 0xFFFFFF. This also agrees with the behaviour of fdisk from
	util-linux-2.32.

2018-06-12  Phillip Susi  <psusi@ubuntu.com>

	Fix atari label false positives
	The atari label gets false positives easily, so probe it after
	all other labels have said no.

2018-06-05  Phillip Susi  <psusi@ubuntu.com>

	Lift 512 byte restriction on fat resize
	As Colin Watson pointed out way back in 2014, when I removed the
	512 byte sector size restriction from the fs recognition code,
	I missed the same from the fat resize code.

2018-06-05  Colin Watson  <cjwatson@ubuntu.com>

	build: Remove unused traces of dynamic loading
	Now that file system operations have been removed from libparted,
	libreiserfs is no longer used.  Remove references to it, along with the
	dynamic loading build infrastructure which was only used for
	libreiserfs.

2018-06-05  Phillip Susi  <psusi@ubuntu.com>

	Fix resizepart iec unit end sector
	Fix resizepart to adjust the end to be -1 sector when using iec
	power of 2 units so that the next partition can start immediately
	following the new end, just like mkpart does.

2018-06-05  Niklas Hambüchen  <mail@nh2.me>

	mkpart: Allow negative start value when FS-TYPE is not given
	The manual had long documented that negative values are
	allowed for both start and end values, but until now negative
	start values were rejected if FS-TYPE was not given.

	Example:

	  # parted --script -a optimal /dev/loop0 -- mklabel gpt mkpart primary ext4 -5MiB 100%
	  (succeeds)

	  # parted --script -a optimal /dev/loop0 -- mklabel gpt mkpart primary -5MiB 100%
	  parted: invalid token: -5MiB
	  Error: Expecting a file system type.

	This commit fixes the latter error.
	The issue was an insufficient lookahead in command line parsing,
	looking only for digits when skipping over FS-TYPE.
	The fix is including the minus '-' in the lookahead.

	Originally reported as Debian bug #880035:

	  "parted: fails to use negative start value for 'mkpart' command without specyfying FS-TYPE"
	  https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=880035

2018-06-05  Phillip Susi  <psusi@ubuntu.com>

	Fix set and disk_set to not crash when no flags are supported
	Loop labels and file images support no flags.  set and disk_set
	would prompt for a flag and accept any string since the list of
	flags was empty, then fail to look up an actual flag value, then
	throw an exception with a null string for the name of the flag,
	which would bug.

2018-05-07  Phillip Susi  <psusi@ubuntu.com>

	tests: fix t6100-mdraid-partitions
	The test was failing because it didn't wait for the md device
	to appear after creating it.

	Fix make check
	Make check failed due to some warnings treated as errors.  One was
	caused by a warning that a function could have the noreturn attribute.
	It seems that this had previously been disabled but gcc has changed
	the flag from -Wmissing-noreturn to -Wsuggest-attribute=noreturn.  The
	recently added volser.c test also caused a few warnings when not
	compiled on s390x because most of the functions were no used, so #if
	those out as well.

2018-04-04  Richard W.M. Jones  <rjones@redhat.com>

	linux: Include <sys/sysmacros.h> for major() macro.
	Since glibc 2.27 this header is required.

2017-12-19  Sebastian Parschauer  <sparschauer@suse.de>

	Add support for NVDIMM devices
	Recognize NVDIMM devices, so that "parted -s /dev/pmem7 p" now
	prints "Model: NVDIMM Device (pmem)" instead of
	"Model: Unknown (unknown)".

	In order for a device to be recognized as NVDIMM, it has to
	have a 'blkext' major number. But since this major can be
	used also by other device types, we also check that the device
	path contains 'pmem' as a substring.

	* NEWS: Mention the change
	* include/parted/device.h.in(PedDeviceType): Add PED_DEVICE_PMEM
	* libparted/arch/linux.c(_device_probe_type): Recognize NVDIMM devices.
	* libparted/arch/linux.c(linux_new): Handle NVDIMM devices.
	* parted/parted.c(do_print): Add "pmem" to list of transports.

2017-12-19  Arnout Vandecappelle (Essensium/Mind)  <arnout@mind.be>

	libparted/labels: link with libiconv if needed
	gpt.c uses iconv so it should link with it. Otherwise, on platforms
	where libiconv is a separate library, we get a link failure of parted:

	    CCLD     parted
	  ../libparted/.libs/libparted.so: undefined reference to `libiconv'
	  ../libparted/.libs/libparted.so: undefined reference to `libiconv_open'
	  ../libparted/.libs/libparted.so: undefined reference to `libiconv_close'

	Since iconv functionality is needed unconditionally (not only when
	gettext is enabled), AM_ICONV needs to be added to configure.ac.

2017-07-31  Brian C. Lane  <bcl@redhat.com>

	atari.c: Drop xlocale.h (#1476934)
	glibc no longer includes this header. locale.h should work just fine.

2017-06-06  Brian C. Lane  <bcl@redhat.com>

	libparted: Fix udev cookie leak in _dm_resize_partition
	Add a NEWS entry.

2017-05-25  Brian C. Lane  <bcl@redhat.com>

	libparted: Fix udev cookie leak in _dm_resize_partition
	The function is setting udev cookies, but not using them when waiting
	for the task. This results in leaked cookies, which can eventually
	exhaust the available number of semaphores.

	'dmsetup udevcookies' will show a cookie remaining afterwards, and 'ipcs -s'
	will show the semaphores in use.

	Also simplified the exit so that the task is always destroyed and memory
	is all freed in the same path.

	Resolves: rhbz#1455564

2017-05-02  Brian C. Lane  <bcl@redhat.com>

	tests/t1701-rescue-fs wait for the device to appear.
	After mkpart it needs to wait for the new partition to appear.

2017-05-02  Brian C. Lane  <bcl@redhat.com>

	Increase timeout for rmmod scsi_debug and make it a framework failure
	On some hardware scsi_debug can take longer to remove. If this fails it
	inevitably results in the next test failing since it cannot load
	scsi_debug.

	Increse the timeout to 40 loops (8 seconds), and if it hits the limit
	without succeeding call framework_failure_

2017-05-01  Wang Dong  <dongdwdw@linux.vnet.ibm.com>

	libparted/dasd: add test cases for the new fdasd functions
	The test case uses a temporary file in libparted/tests under
	Check framwork.It can be issued by "make check" in the test dir.

	libparted/dasd: add an exception for changing DASD-LDL partition table
	The partition table of DASD-LDL device with the dasd disk label
	should not be changed according to its character in Linux.
	When the user tries to modify the partition table, an exception
	will be raised to inform user of this character.

	libpartd/dasd: improve flag processing for DASD-LDL
	DASD-LDL does not support flag now, so all the flags are
	unavailable to it.

2017-05-01  Wang Dong  <dongdwdw@linux.vnet.ibm.com>

	parted/ui: remove unneccesary information of command line
	When some command fails, the information still exists in
	command_line buffer. When in command mode or interactive mode,
	if an interactive exception prompts, the remained information
	will be processed as option from user. This will raise some other
	information or even unexpected results. So before getting option
	input from user, clean the command line buffer.

	Example: When the disk label is invalid and user tries to make
		 new partition on the device with command like,
		 mkpart 0 50%. Then parted will raise an exception
		 telling an invalid disk label found and whether to correct it.
		 But at this time 0 as the input of mkpart will be
		 considered as the option input for the exception(yes/no).
		 So one more exception will raised with error information.

2017-05-01  Wang Dong  <dongdwdw@linux.vnet.ibm.com>

	parted: check the name of partition first when to name a partition
	The previous function works well for the labels supporting naming
	partition, but not for these which don't. If the disk label does not
	support partition naming, two exceptions will be raised. Even after the first
	error indicates it does not support name, parted yet asks user for
	name in iteractive mode.

	First check if the disk label supports partition naming and if it
	does, it will continue; otherwise, it will stop and raise an
	exception.

2017-05-01  Sebastian Parschauer  <sparschauer@suse.de>

	Add support for RAM drives
	Recognize RAM drives, so "parted -s /dev/ram0 p" now prints
	"RAM Drive (brd)" instead of "Model: Unknown (unknown)".

	In order for a device to be recognized as RAM drive, it has to
	have major number 1. Also the BLKFLSBUF ioctl shouldn't be used
	on RAM drives as it is used to zero the device.

	* NEWS: Mention the change
	* include/parted/device.h.in(PedDeviceType): Add PED_DEVICE_RAM.
	* libparted/arch/linux.c(RAM_MAJOR): New define.
	* libparted/arch/linux.c(_device_probe_type): Recognize RAM drives.
	* libparted/arch/linux.c(linux_new): Handle RAM drives.
	* libparted/arch/linux.c(_flush_cache): Skip RAM drives.
	* parted/parted.c(do_print): Add "brd" to list of transports.

2017-05-01  Wang Dong  <dongdwdw@linux.vnet.ibm.com>

	clean the disk information when commands fail in interactive mode.
	parted always reads disk information to memory before any
	operations. The disk that user operates is actually
	a copy of real one in memory. When the information in memory
	is changed, it will commit the memory to device to update the
	disk information.

	Once the disk information is read, parted will never re-read it
	again unless another device is loaded or the device is re-read.
	Above work has been done in commit 7eac058 (parted: don't reload
	partition table on every command)

	Each command of parted always commits the memory when it succeeds.
	Then the disk information on device and in memory are the same.
	But when it fails, they might be different. User will be confused
	by this, and sometimes get undesired result with the contaminated
	memory. This memory should be cleaned if some command fails.
	Then the command followed will re-read the disk.

2017-05-01  Wang Dong  <dongdwdw@linux.vnet.ibm.com>

	parted: fix wrong error label jump in mkpart
	When the user makes a new partition, if parted fails to add the
	partition to disk, it jumps to wrong error label. In this
	situation, this new partition actually is not a node in disk
	data structure. But in the wrong error label, it pretends this
	is a node and removes it as a list node, leading to other
	partition in this disk deleted. This might lead to a memory leak.
	Because if there are other partitions, it just removes them from
	list without releasing the resource. And this also leads to different
	disk information between memory and device. This is confusing.

	But when the new partition is added to disk successfully and if
	any operations followed fail, this partition should be removed from
	disk and destroyed.

2017-05-01  Wang Dong  <dongdwdw@linux.vnet.ibm.com>

	parted: fix crash due to improper partition number input
	When the user makes a new partition, if parted fails to add the
	partition to disk, it jumps to wrong error label. In this
	situation, this new partition actually is not a node in disk
	data structure. But in the wrong error label, it pretends this
	is a node and removes it as a list node, leading to other
	partition in this disk deleted. This might lead to a memory leak.
	Because if there are other partitions, it just removes them from
	list without releasing the resource. And this also leads to different
	disk information between memory and device. This is confusing.

	But when the new partition is added to disk successfully and if
	any operations followed fail, this partition should be removed from
	disk and destroyed.

2017-04-17  Phillip Susi  <psusi@ubuntu.com>

	Fix crash when localized
	The _() macro is only for translating string literals.  It was
	incorrectly applied to a runtime string representing the name
	of a partition and this sometimes caused a gettext crash.

2017-01-19  Sebastian Rasmussen  <sebras@gmail.com>

	libparted: Fix typo in hfs error message

2016-12-22  Laurent Vivier  <laurent@vivier.eu>

	libparted: Fix MacOS boot support
	boot_region_length (or BootSize in the MacOS dialect) is the length
	of the driver code in the driver partition. This length is used
	to compute the checksum of the driver.

	libparted updates this value by setting the whole size of the partition
	without computing the checksum of the driver using this size.

	As the checksum is wrong, the driver is broken and cannot be loaded
	by the MacOS ROM, and thus the disk is not bootable anymore.

	Moreover, parted try to update the driver list and makes it disappear.

	As parted is not able to insert a driver in a partition,
	the driver is generally inserted by the Apple HD Tool,
	this patch removes the line updating the driver size.

	We also simplify the driver list scan and fix endianess use.

	This has been tested... and it works, now.

	I have updated a bootable disk with parted on x86_64 and
	then been able to boot it (again) on a Mac LC III.

2016-12-22  John Paul Adrian Glaubitz  <glaubitz@physik.fu-berlin.de>

	libparted: Add support for atari partition tables

	libparted:tests: Move get_sector_size() to common.c
	Moving get_sector_size() from disk.c to common.c allows
	us to use it in _implemented_disk_label() to test for
	512-byte sectors. This change is required to be able to
	enable this test for atari partition tables for which
	support is added in a follow-up patch.

2016-12-22  Brian C. Lane  <bcl@redhat.com>

	tests: Update t0220 and t0280 for the swap flag.

2016-12-22  Arvin Schnell  <aschnell@suse.com>

	libparted: set swap flag on GPT partitions
	The filesystem type is still detected as befor, but now setting the
	'swap' flag will set the partition GUID to PARTITION_SWAP_GUID.

2016-12-22  Wang Dong  <dongdwdw@linux.vnet.ibm.com>

	libparted/dasd: add test cases for the new fdasd functions
	The test case uses a temporary file in libparted/tests under
	Check framwork. It can be issued by "make check" in the test dir.

2016-12-22  Wang Dong  <dongdwdw@linux.vnet.ibm.com>

	libparted/dasd: add new fdasd functions
	Introduce a set of new functions from the fdasd utility of the s390-tools
	to keep the code base in parted and s390-tools in sync.

	These new functions are:
	  fdasd_check_volser():  validate the volser input
	  fdasd_get_volser():    get volume serial (volser)
	  fdasd_change_volser(): change volser with string
	  fdasd_reuse_vtoc():    re-create vtoc labels based on the existing vtoc

2016-12-22  Wang Dong  <dongdwdw@linux.vnet.ibm.com>

	libparted/dasd: update and improve fdasd functions
	Update the fdasd_anchor_t data structure and the fdasd_cleanup()
	function. Also correct vtoc_changed and vlabel_changed accounting
	because they are important to rewrite vtoc to save the changes.

	Wang Dong <dongdwdw@linux.vnet.ibm.com>
	Hendrik Brueckner <brueckner@linux.vnet.ibm.com>

2016-12-22  Wang Dong  <dongdwdw@linux.vnet.ibm.com>

	libparted/dasd: unify vtoc handling for cdl/ldl
	Merge volume label cdl and ldl. It is convenient to manipulate
	the same structure. Also remove unused arguments in the functions.

2016-12-22  Sebastian Parschauer  <sparschauer@suse.de>

	libparted: Don't warn if no HDIO_GET_IDENTITY ioctl
	Fully virtualized Xen VMs (HVM) use Linux IDE devices which don't
	support the HDIO_GET_IDENTITY ioctl. EINVAL is returned, a warning
	is printed and the device model is set to "Generic IDE" in that
	case. The problem is seeing the warning all the time. So drop it
	for this case.

2016-12-22  Petr Uzel  <petr.uzel@suse.cz>

	libparted: Fix starting CHS in protective MBR
	The CHS address for protective partition start in protective MBR
	should be 0/0/2, according to UEFI spec (v2.6, section 5.2.1).

	* libparted/labels/gpt.c (_write_pmbr): Fix starting CHS address

	Reported by Steffen Winterfeldt in https://bugzilla.suse.com/969165

2016-12-22  Brian C. Lane  <bcl@redhat.com>

	tests: Stop timing t9040 (#1172675)
	parted doesn't have any control over how long this takes, there is no
	reason to consider this a parted bug if it takes longer than expected.

	Resolves: rhbz#1172675

2016-12-22  Brian C. Lane  <bcl@redhat.com>

	partprobe: Open the device once for probing
	Previously there were 3 open/close pairs for the device, which may
	result in triggering extra udev actions. Instead, open it once at the
	start of process_dev and close it at the end.

	tests: Set optimal blocks to 64 for scsi_debug devices
	The Linux kernel 4.5 changed the optimal blocks count from 64 to 1024
	This causes tests using scsi_debug devices to fail because of alignment
	issues. Set the opt_blks to 64 so that we have consistent behavior
	across kernels.

2016-12-22  Brian C. Lane  <bcl@redhat.com>

	doc: Add information about quoting
	Some shells (bash) will strip off the " so it needs to be
	wrapped in '' to prevent it. eg.

	parted -s ./disk.img mkpart '"EFI System Partition"' 1M 500M

2016-12-22  Brian C. Lane  <bcl@redhat.com>

	doc: Cleanup mkpart manpage entry (#1183077)

2016-12-22  Brian C. Lane  <bcl@redhat.com>

	tests: Fix t1700 failing on a host with a 4k xfs filesystem (#1260664)
	The problem is that mkfs.xfs won't work if the file it is trying to
	create is on a filesystem with a sector size larger than the passed
	-ssize value. So a host with 4k disks (eg. s390) and the xfs filesystem
	will fail with the error message:
	    illegal sector size 512; hw sector is 4096

	Failures setting up the environment for the test aren't parted bugs.
	This stops treating mkfs and dd errors as test failures, skipping the fs
	and logging a warning.

	Related: rhbz#1260664

2016-12-22  Brian C. Lane  <bcl@redhat.com>

	tests: Add wait to t9042 (#1257415)
	Also make the new disklabel and first partition all in one step to
	prevent udev problems.

	Resolves: rhbz#1257415

2016-12-22  Brian C. Lane  <bcl@redhat.com>

	tests: Add udevadm settle to wait_for_ loop (#1260664)
	Sometimes the device will vanish after the wait_for_dev_to_appear exits.
	Add udevadm settle in an attempt to make sure the udev system is done
	flapping around and the device will stay in place.

	Related: rhbz#1260664

2016-10-04  Brian C. Lane  <bcl@redhat.com>

	tests: t3310-flags.sh skip pc98 when sector size != 512

2016-10-04  Mike Fleetwood  <mike.fleetwood@googlemail.com>

	tests: t3310-flags.sh: Add tests for remaining table types
	Add test of flags for remaining table types: aix, amiga, pc98, sun and
	loop.  Note that support of writing AIX tables is not yet implemented in
	parted and LOOP tables don't support partitions nor flags.

2016-10-04  Mike Fleetwood  <mike.fleetwood@googlemail.com>

	tests: t3310-flags.sh: Add test for dvh table flags
	DVH table reserves the first 4 MiB for the volume header information so
	move the created test partition to immediately after that.

	Exclude testing the boot flag as that can only be set on logical
	partitions and this test script only uses primary partitions so far.

2016-10-04  Mike Fleetwood  <mike.fleetwood@googlemail.com>

	tests: t3310-flags.sh: Add test for mac table flags
	MAC partition table reserves partition 1 for the partition map
	partition, so the created test partition will be number 2.  Adapt
	accordingly.

	Setting flags 'root' and 'swap' also sets the partition name to 'root'
	and 'swap' respectively, so no longer match the partition name in
	extract_flags().

	Don't test lvm and raid flags as they fail to be cleared with a single
	set off command.  See FIXME comment in the test for more details.

2016-10-04  Mike Fleetwood  <mike.fleetwood@googlemail.com>

	libparted: Remove commented local variable from bsd_partition_set_flag()

2016-10-04  Mike Fleetwood  <mike.fleetwood@googlemail.com>

	libparted: Fix to report success when setting lvm flag on bsd table
	bsd_partition_set_flag() was falling through in the lvm flag case and
	returning failure.  Fix this by adding missing return 1 (success) like
	for the other flags.

	Found as a result of this bug reported by Timo Riikonen:
	https://bugzilla.gnome.org/show_bug.cgi?id=769831

2016-10-04  Mike Fleetwood  <mike.fleetwood@googlemail.com>

	tests: t3310-flags.sh: Add test for bsd table flags

	tests: t3310-flags.sh: Stop excluding certain flags from being tested
	Also grep for whole words, grep -w, to avoid flag 'boot' being matched
	as a substring of flag 'legacy_boot'.

2016-10-04  Mike Fleetwood  <mike.fleetwood@googlemail.com>

	tests: t3310-flags.sh: Query libparted for all flags to be tested
	Replace scanning the documentation for an incomplete list of flags with
	querying libparted for the complete list of supported flags via the
	added helper print-flags.

	Correct $ME -> $ME_ in the warning messages.  Improve the warning
	messages by including the table type and flag name not correctly set or
	cleared.

	Plus minor changes:
	(1) use slightly longer variable name primary_or_name;
	(2) use longer test partition name PTNNAME; and
	(3) stop shortening parted unit command to u.

2016-09-30  Petr Uzel  <petr.uzel@suse.cz>

	libparted: only IEC units are treated as exact
	If the user specifies start/end of the partition as a unit,
	whose size happens to be power of two, we treat that as
	exact address with exact placement.

	Recently, commit 01900e056ec25083 added an exception for
	percent units.

	This logic however can fail also for cylinders, e.g. on DASD FBA disks,
	which report CHS=(*, 128, 16) geometry, hence once cylinder is 1 MiB.
	With cylinders as units, exact placement is not what the user wants.

	Instead of adding cylinders to the blacklist, let's instead
	whitelist units which should trigger exact placement.

	* libparted/unit.c (is_power_of_2): Remove now unused function.
	(ped_unit_parse_custom): Specify which units trigger exact placement.
	* NEWS (Bug Fixes): Mention this.

2016-09-30  Gareth Randall  <gareth.randall@virgin.net>

	docs: Improve partition description in parted.texi

2016-06-23  Petr Uzel  <petr.uzel@suse.cz>

	Add support for NVMe devices
	Recognize NVMe Devices, so "parted -s /dev/nvme0n1" now prints
	"NVMe Device (nvme)" instead of "Model: Unknown (unknown)".

	In order for a device to be recognized as NVMe, it has to
	have a 'blkext' major number. But since this major can be
	used also by other device types, we also check the device
	path contains 'nvme' as a substring.

	* NEWS: Mention the change
	* include/parted/device.h.in(PedDeviceType): Add PED_DEVICE_NVME
	* libparted/arch/linux.c(BLKEXT_MAJOR): New define.
	* libparted/arch/linux.c(_is_blkext_major): New function.
	* libparted/arch/linux.c(_device_probe_type): Recognize NVMe devices.
	* libparted/arch/linux.c(linux_new): Handle NVMe devices.
	* parted/parted.c(do_print): Add "nvme" to list of transports.

2016-06-23  Wang Dong  <dongdwdw@linux.vnet.ibm.com>

	libparted/dasd: correct the offset where the first partition begins
	The start point of first partition must start at least from the third
	track of DASD, due to the existence of metadata in the first two track.
	The previous constraint just sets all the device to be partitioned.
	So when the start point of the first partition start before the third
	track, (For example if it starts from.0) parted will exit abruptly.
	And this kind of job must be done with constraint explicitly.

	Then the constraint is modified to exclude the first two tracks and
	to make the first partition start from the third track by default.

	Reviewed-by: Viktor Mihajlovski <mihajlov@linux.vnet.ibm.com>

2016-05-06  Brian C. Lane  <bcl@redhat.com>

	libparted: Fix probing AIX disks on other arches
	Not a likely scenario, but make sure the magic check works everywhere.

2016-04-15  Brian C. Lane  <bcl@redhat.com>

	libparted: Remove fdasd geometry code from alloc_metadata (#1244833)
	commit db20944f changed how the trailing_metadata_end is calculated in
	dasd_alloc_metadata, removing the need for setting up the anchor struct.
	But dasd_alloc_metadata can be called in various contexts, and the
	arch_specific->fd may or may not be valid during these calls. This can
	result in unpredictable crashes when it uses a stale fd and tries to run
	the file image code in fdasd_get_geometry instead of the device code.

	The solution is to just drop the unneeded code, and to remember that
	arch_specific->fd should only be used when ped_device_open has first
	been called.

	Resolves: rhbz#1244833

2016-04-14  Phillip Susi  <psusi@ubuntu.com>

	Add NEWS entry for fat resize fix

2016-04-14  Gustavo Zacarias  <gustavo@zacarias.com.ar>

	bug#17883: [PATCH] configure.ac: uclinux is also linux
	uclinux is used in the tuple for some noMMU linux builds like Blackfin
	FLAT output, so accept it as linux too.

2016-04-14  Curtis Gedak  <gedakc@gmail.com>

	lib-fs-resize: Fix recognition of FAT file system after resizing
	When resizing a FAT partition, an extra boot_sector memory allocation
	was causing the original boot_sector information to be lost.  The
	resulting FAT file system was still recognized by GNU/Linux, but not
	recognized by the proprietary Windows operating system.

	The problem with Windows FAT32 recognition was introduced with:

	  Fix filesystem detection on non 512 byte sectors
	  80678bdd957cf49a9ccfc8b88ba3fb8b4c63fc12

	Fix by removing the extra boot_sector memory allocation.

	Note that since parted-3.0 another code path to the extra memory
	allocation of fat_create(...) via ped_file_system_create(...) is
	inaccessible.  In an effort to maintain the ability to re-instate the
	code, add a new boot_sector memory allocation where it is needed in
	the alternate code path.

	GNU bug report logs - #22266
	[libparted] jump instruction and boot code is corrupted with random
	bytes after fat is resized
	http://debbugs.gnu.org/cgi/bugreport.cgi?bug=22266

2016-04-12  Brian C. Lane  <bcl@redhat.com>

	parted: Display details of partition alignment failure (#726856)
	When alignment for a new partition fails it isn't always obvious why it
	failed. This adds printing the reason for the failure, in the form of:

	start % grain != offset

	This modifies align-check in interactive mode to print the alignment the
	error details if it isn't aligned. Script mode behavior is unchanged.

	Also cleanup pointer usage and handle asprintf failure by using a constant
	string in the error report - "unknown (malloc failure)".

2016-04-12  Brian C. Lane  <bcl@redhat.com>

	docs: Add list of filesystems for fs-type (#1311596)
	Add the most common filesystem types to the parted manpage.

	Resolves: rhbz#1311596

2016-04-12  Brian C. Lane  <bcl@redhat.com>

	Add libparted-fs-resize.pc
	Add a pkgconfig file for the filesystem resize library.

2016-04-10  Steven Lang  <Steven.Lang@hgst.com>

	Use disk geometry as basis for ext2 sector sizes.
	When creating the geom for probed ext2 based filesystems, the
	size was being reported in 512 byte sectors, regardless of what
	the actual sector size of the device is.

2016-04-10  Phillip Susi  <psusi@ubuntu.com>

	parted: fix the rescue command
	The rescue command often failed to locate a filesystem due to it
	leaving cylinder alignment on, which snapped the allowed bounds
	of the filesystem down to the next lower cylinder boundary,
	causing the detected filesystem to be rejected due to not fitting.

2016-03-18  David Cantrell  <dcantrell@redhat.com>

	Use BLKSSZGET to get device sector size in _device_probe_geometry()
	Seen on certain newer devices (such as >32G SDHC memory cards), the
	HDIO_GETGEO ioctl does not return useful information.  The libparted
	code records hardware and bios reported geometry information, but all of
	that is largely unusable these days.  The information is used in the
	PedConstraint code for aligning partitions.  The sector count is most
	useful.  Rather than only trying HDIO_GETGIO, first initialize the
	bios_geom fields to 0 and then use BLKSSZGET to capture the sector size.
	If that fails, try HDIO_GETGEO.  And if that fails, raise a warning and
	fall back on the library's default sector size macro.

	This problem showed up on Raspberry Pi devices where users were
	attempting to grow a partition to fill the SDHC card.  Using the
	optimal_aligned_constraint returned invalid geometry information
	(98703359 instead of 124735488 sectors).  The issue was reported here:

	    https://github.com/fedberry/fedberry/issues/8

	And to the pyparted project:

	    https://github.com/rhinstaller/pyparted/issues/25

	I've applied this patch locally to parted, rebuilt, and reinstalled it
	and it is working correctly for the problem SDHC cards.

2016-03-07  Mike Fleetwood  <mike.fleetwood@googlemail.com>

	tests: t3000-resize-fs.sh: Add very deep directory
	Create 500 deep directory tree, with longest name of 4000 characters, to
	the file system being resized to test the fix to prevent crash when
	resizing a FAT file system with such a long path.

2016-03-07  Mike Fleetwood  <mike.fleetwood@googlemail.com>

	lib-fs-resize: Prevent crash resizing FAT with very deep directories
	Resizing a FAT file system crashes in libparted/fs/r/fat/count.c
	flag_traverse_dir() if the length of any path name in the file system
	overflows the 512 byte file_name local buffer.  Increase buffer to 4096,
	PATH_MAX on Linux.

	Reported in
	https://bugzilla.gnome.org/show_bug.cgi?id=762448

2016-02-09  Viktor Mihajlovski  <mihajlov@linux.vnet.ibm.com>

	fdasd.c: Safeguard against geometry misprobing
	Fixes an issue with parted print being run against a logical
	volume realised by extents on a physical volume residing on
	a DASD.
	We must make sure that geometry, device blocksize and DASD
	attributes are present before we start format verifications
	If any of it is missing this is not a DASD.

2015-10-29  Colin Watson  <cjwatson@ubuntu.com>

	parted: fix build error on s390
	The preceding dasd probing patches have introduced a compile error
	when building with blkid support. Fixed by reordering function
	definitions.

2015-10-27  Viktor Mihajlovski  <mihajlov@linux.vnet.ibm.com>

	dasd: enhance device probing
	Probe for all device/transport types as every block device
	could be a DASD on s390.

	Since the calculation of the minimum and optimum alignment
	is different between DASDs and common fixed block disks
	we need a means other than dev->type == PED_DEVICE_DASD.
	For that purpose a static function _ped_device_like_dasd()
	offering a DASD detection heuristic has been added to
	arch/linux.c.

	By always providing arch-specific alignment functions the
	need for DASD-specific code could be removed from device.c.

	Observe fdasd_get_geometry return code for proper error
	handling.

	Remove the obsolete API check as we no longer require the
	DASD-specific IOCTLs.

	Acked-by: Stefan Haberland <stefan.haberland@de.ibm.com>

2015-10-27  Viktor Mihajlovski  <mihajlov@linux.vnet.ibm.com>

	fdasd: geometry handling updated from upstream s390-tools
	Remove the necessity for DASD-specific ioctls for partition handling.
	This allows to correctly handle DASD-backed virtio block devices.

	Note that this is necessary because virtio is just the transport.
	A DASD, even if provided via virtio, still has it's unique
	characteristics, which means that only traditional DASD partition
	table formats can be used (no MBR, GPT, or similar).

	Use bzero for initialization to make sure all struct members are
	properly cleared. Also changed partition list handling code to be
	more similar to upstream s390-tools fdasd.

	Further, enhanced error handling capabilities by providing a
	return code by fdasd_get_geometry.

	Code is largely backported from s390-tools project.

	Acked-by: Stefan Haberland <stefan.haberland@de.ibm.com>

2015-10-09  Brian C. Lane  <bcl@redhat.com>

	tests: Use wait_for_dev_to_ functions
	Recent changes to udev have made some long-standing problems appear more
	frequently. udev executes various actions when changes are made to
	devices. Sometimes this can result in device nodes not appearing
	immediately. Other times it can result in EBUSY being returned. This
	patch only addresses devices that are slow to appear/disappear.

	It is best to use the wait_for_dev_to_appear_ and
	wait_for_dev_to_disappear_ functions than to test for existance. These
	will loop and wait for up to 2 seconds for it to appear.

	This also changes t9041 to fail if mkfs doesn't work since using skip
	here may hide cases when the device node doesn't appear.

2015-10-09  Brian C. Lane  <bcl@redhat.com>

	libparted: Use read only when probing devices on linux (#1245144)
	When a device is opened for RW closing it can trigger other actions,
	like udev scanning it for partition changes. Use read only for the
	init_* methods and RW for actual changes to the device.

	This adds _device_open which takes mode flags as an argument and turns
	linux_open into a wrapper for it with RW_MODE.

	_device_open_ro is added to open the device with RD_MODE and increment
	the open_counter. This is used in the init_* functions.

	_device_close is a wrapper around linux_close that decrements the
	open_counter and is used in the init_* functions.

	All of these changes are self-contained with no external API changes.
	The only visible change in behavior is that when a new PedDevice is
	created the device is opened in RO_MODE instead of RW_MODE.

	Resolves: rhbz#1245144

2015-08-07  Brian C. Lane  <bcl@redhat.com>

	libparted: Fix misspelling in hfs exception string

2015-08-07  Brian C. Lane  <bcl@redhat.com>

	libparted: Stop converting . in sys path to /
	In _probe_sys_block it claimed that ! and . are replaced by / in sys
	paths, but according to the kernel code only ! is replaced (for cciss
	devices).

	This is now causing problems with libnvdimm devices, the details are
	here:

	https://git.kernel.org/cgit/linux/kernel/git/djbw/nvdimm.git/tree/Documentation/nvdimm/nvdimm.txt?h=libnvdimm-for-next

2015-08-05  Amarnath Valluri  <amarnath.valluri@intel.com>

	libparted: Fix possible memory leaks
	* libparted/fs/r/fat/resize.c(fat_convert_directory): Possible leak
	  of sub_old_dir_trav or sub_new_dir_trav in error case.
	* libparted/fs/r/fat/resize.c(fat_construct_converted_tree ): Possible
	  leak of new_trav_info or old_trav_info in error case.

2015-08-03  Amarnath Valluri  <amarnath.valluri@intel.com>

	libparted: Fix memory leaks
	* libparted/fs/r/hfs/hfs.c(hfsplus_resize): Don't leak embedded_geom
	  when volume resizing failed.
	* libparted/fs/fat/fat.c(fat_create): Don't leake fs in-case of
	  fat_write_clustor failuer.
	* libparted/arch/linux.c(_kernel_get_partition_start_and_length): Don't leak
	  dev_fd file descriptor.

	UI: Avoid memory leaks.
	* parted/ui.c(command_line_get_sector): Don't leak input string.
	* parted/ui.c(command_line_prompt_words): Don't leak _def string in
	  opt script mode.

2015-07-13  Brian C. Lane  <bcl@redhat.com>

	parted: Fix crash with name command and no disklabel (#1226067)
	A typo (the last I think) from commit 7eac058 wasn't properly checking
	the result of ped_disk_new so it could crash if there was no disklabel
	on the device.

2015-07-13  Alexander Todorov  <atodorov@redhat.com>

	Fwd: [PATCH 2/2] add verbose test documentation

	merge HACKING and README-hacking

2015-07-02  Sergei Antonov  <saproj@gmail.com>

	mac: copy partition type and name correctly
	Use strncpy() instead of strcpy() to copy partition name and type.
	This prevents possible buffer overflow, because the source string
	occupies up to 33 bytes with a terminating null.

	Static analysis tools complain about the code as it is now:
	  Function: _generate_raw_part
	  Destination buffer too small
	  string_overflow: You might overrun the 32 byte destination string
	  part_map_entry->type by writing 33 bytes from mac_part_data->system_name
	  (Destination buffer too small, line 933)

	Cc: Sabas Rosales, Blanca E <blanca.e.sabas.rosales@intel.com>

2015-06-26  Brian C. Lane  <bcl@redhat.com>

	libparted: BLKPG_RESIZE_PARTITION uses bytes, not sectors (#1135493)
	This results in the extended partition vanishing after adding another
	partition.

	Resolves: rhbz#1135493

2015-06-26  Brian C. Lane  <bcl@redhat.com>

	tests: Make sure the extended partition length is correct (#1135493)
	parted tells the kernel the wrong length when reporting a resize of an
	extended partition. Make sure the length is 2 for 512b sectors and 1
	sector for larger.

2015-06-24  Brian C. Lane  <bcl@redhat.com>

	doc: Fix url for LWN article
	Removed an extra http:// from it.

2015-06-24  Alexander Todorov  <atodorov@redhat.com>

	tests: Fall back to C.UTF-8 if no en_US.utf8 available
	Not all distributions (Fedora) have C.UTF-8 so first try en_US.utf8 and fall
	back to it. This may still fail if neither exist.

	* tests/t0251-gpt-unicode.sh: Test for en_US and fall back to C.UTF-8

2015-06-22  Felix Janda  <felix.janda@posteo.de>

	libparted/fs/xfs/platform_defs.h: Include <fcntl.h> for loff_t
	This is needed for compilation with musl libc

	Suggested-by: Travis Tilley <ttilley@gmail.com>

2015-06-22  Felix Janda  <felix.janda@posteo.de>

	libparted/arch/linux.c: Compile without ENABLE_DEVICE_MAPPER

2015-03-23  Brian C. Lane  <bcl@redhat.com>

	Update manpage NAME so whatis will work

2015-02-06  Brian C. Lane  <bcl@redhat.com>

	libparted: device mapper uses 512b sectors
	device mapper doesn't use the device's sector size when creating a
	table. It always uses 512b units. This causes partitions to be created
	8x smaller than expected on devices with 4906b sectors.

2015-02-05  Brian C. Lane  <bcl@redhat.com>

	tests: Add a test for device-mapper partition sizes
	device-mapper uses 512b sector units, not device specific sector sizes.
	This test ensures that the correct partition size is created, no matter
	what the device's sector size is.

2015-01-13  Phillip Susi  <psusi@ubuntu.com>

	parted: don't crash in disk_set when disk label not found
	Due to a typeo in commit 7eac058 "parted: don't reload partition
	table on every command", the disk_set command would crash if
	a disk label was not found.

2014-11-10  Brian C. Lane  <bcl@redhat.com>

	tests: Change minimum size to 256MiB
	btrfs on ppc64 wants 136MiB so expand the minimum temp filesystem size
	for the t1700-probe-fs test.

2014-10-27  Mike Fleetwood  <mike.fleetwood@googlemail.com>

	tests: t3000-resize-fs.sh: Add requirement on mkfs.vfat
	Add test skipping requirement on mkfs.vfat for the FAT32 and FAT16 file
	system resizing tests.  This matches existing test skipping requirement
	on mkfs.hfs for the hfs+ file system.

	* tests/t3000-resize-fs.sh: Also correct skip_test_ to skip_.
	* tests/t-lib-helpers.sh: Also update message for requirement of hfs.

2014-10-27  Mike Fleetwood  <mike.fleetwood@googlemail.com>

	tests: t3000-resize-fs.sh: Add FAT16 resizing test
	Add FAT16 resizing test so that we don't regress again.

2014-10-27  Mike Fleetwood  <mike.fleetwood@googlemail.com>

	lib-fs-resize: Prevent crash resizing FAT16 file systems
	Resizing FAT16 file system crashes in libparted/fs/r/fat/resize.c
	create_resize_context() because it was dereferencing NULL pointer
	fs_info->info_sector to copy the info_sector.

	Only FAT32 file systems have info_sector populated by fat_open() ->
	fat_info_sector_read().  FAT12 and FAT16 file systems don't have an
	info_sector so pointer fs_info->info_sector remains assigned NULL from
	fat_alloc().  When resizing a FAT file system create_resize_context()
	was always dereferencing fs_info->info_sector to memory copy the
	info_sector, hence it crashed for FAT12 and FAT16.

	Make create_resize_context() only copy the info_sector for FAT32 file
	systems.

	Reported by Christian Hesse in
	https://bugzilla.gnome.org/show_bug.cgi?id=735669

2014-09-20  Heiko Becker  <heirecka@exherbo.org>

	libparted: also link to UUID_LIBS
	* libparted/Makefile.am (libparted_la_LIBADD): Add UUID_LIBS.
	This fixes building parted with the gold linker.

2014-07-28  Phillip Susi  <psusi@ubuntu.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 3.2
	* NEWS: Record release date.

2014-07-27  Phillip Susi  <psusi@ubuntu.com>

	Bump library REVISION number for release

	tests: don't require en_US locale in t0251-gpt-unicode.sh
	Switch from en_US.UTF-8 to C.UTF-8 so the test does not fail on systems
	that do not have the en_US locale installed.

2014-06-23  Jim Meyering  <meyering@fb.com>

	maint: correct a POT-file updating rule
	* doc/C/Makefile.am (updatepo): If there is no po/$name.pot,
	create an empty one.  Reported by Philip Susi.

2014-06-15  Phillip Susi  <psusi@ubuntu.com>

	tests: fix t9020-alignment.sh
	This test was refering to print-alignment by absolute path, which
	broke building with a different object directory, causing
	make distcheck to fail.

	Document resizepart command

	parted: Add stub resize command for backward compatibility
	To make sure that older scripts trying to use the resize command do not
	accidentally run the new resizepart command by mistake, this undocumented
	stub command will throw an error if called.

	parted: Allow undocumented commands
	Have command_print_summary print nothing if the command summary is NULL.
	This allows for a command to be registered, but not documented in the
	output of help.

	parted: make _partition_warn_busy actually a warning instead of an error
	This function was throwing a PED_EXCEPTION_ERROR with only the
	PED_EXCEPTION_CANCEL option.  Converted to a PED_EXCEPTION_WARNING
	with the option to continue anyhow.

	libparted: Add support for partition resize
	When resizing a partition ( same partition number, same
	start sector, different end sector ), try to use the
	new BLKPG_RES_PARTITION request to update the kernel
	partition table with the new size.  Also handle resizing
	devmapper targets.

2014-06-15  Petr Uzel  <petr.uzel@suse.cz>

	tests: excersise resize command
	a lot of TODOs

	parted: add resizepart command
	Add resizepart command to resize ( change the end position ) an existing
	partition.  Note that it does nothing to a filesystem in the partition.

2014-06-15  Brian C. Lane  <bcl@redhat.com>

	Fix python test scripts for distribution
	make distcheck was failing because these scripts were not being
	included.

	Make them both executable and and add the path to the tests that use
	them. They also need to be included in the distribution so update
	Makefile.am

	* tests/Makefile.am: Add python test scripts
	* tests/gpt-header-move.py: rename to gpt-header-move and make it
	  executable
	* tests/msdos-overlap.py: rename to overlap.py
	* tests/t0282-gpt-move-backup.sh: add path to scripts and use new name
	* tests/t0283-overlap-partitions.sh: same

2014-06-15  Brian C. Lane  <bcl@redhat.com>

	tests: check name when duplicating
	Create a second partition with a name when supported by the disk label.
	Check to make sure that the duplicate has copied over the name. The goal
	with this was to try to catch the bug fixed by the previous commit but I
	was unable to make it fail. But this should improve our test coverage
	anyway.

	* tests/duplicate.c: Add a partition name test.

2014-06-15  Brian C. Lane  <bcl@redhat.com>

	libparted: Fix part dupe with empty name
	It was setting the original translated_name to 0, not the new copy.

	* libparted/labels/gpt.c (gpt_partition_duplicate): fix empty name

2014-05-28  Jim Meyering  <meyering@fb.com>

	tests: use test's "=" operator, not "=="
	* tests/t1700-probe-fs.sh: Avoid "make syntax-check" error: s/==/=/

	tests: avoid false-positive failure due to symlink
	* tests/t6000-dm.sh (sanitize): Helper function.
	Before this change, this test would fail due to difference between
	absolute name and symlink-including names in "parted print" output

	maint: fix "make syntax-check" nits
	* doc/parted.texi: Update copyright year to 2014.
	* tests/gpt-header-move.py: Remove empty line at EOF.
	* tests/t0281-gpt-grow.sh: Correct reversed args to compare.
	* tests/t0282-gpt-move-backup.sh: Likewise.
	* libparted/labels/gpt.c (gpt_partition_set_name): Change "Can not"
	to "failed to" in diagnostic.
	(gpt_partition_get_name): Likewise.
	* tests/t1102-loop-label.sh (dev): Remove trailing space in
	here document that creates expected output, and strip that
	same trailing space from actual output.
	* libparted/fs/jfs/jfs.c: Do not cast alloca return value.
	* libparted/fs/reiserfs/reiserfs.c: Likewise.
	* libparted/fs/xfs/xfs.c: Likewise.

2014-05-27  Brian C. Lane  <bcl@redhat.com>

	tests: Use mkfs.xfs to create files (#1101112)
	On s390 there is a bug with mkfs.xfs and pre-existing files. Work around
	it by creating the file directly with mkfs.xfs. This also works on other
	arches.

	* tests/t1700-probe-fs.sh: Check for xfs and use direct file creation
	* tests/t4100-dvh-partition-limits.sh: Use mkfs.xfs -dfile
	* tests/t4100-msdos-partition-limits.sh: Use mkfs.xfs -dfile

2014-05-27  Brian C. Lane  <bcl@redhat.com>

	tests: Add ntfs vfat hfsplus to t1700 probe test
	Add some new filesystems to test. Adjust how mkfs.* tests, since some of
	them don't support -V, and add fsname so that the printed filesystem
	name doesn't have to match the type.

	* tests/t1700-probe-fs.sh: Add new filesystems to test

2014-05-25  Jim Meyering  <meyering@fb.com>

	maint: run "make update-copyright"

	maint: remove doubled word: s/on on/on/
	* NEWS: Remove doubled-word detected by "make syntax-check".

	gnulib: update submodule to latest
	* gnulib: Update module to latest.
	* bootstrap: Update from gnulib.

2014-05-25  Sergei Antonov  <saproj@gmail.com>

	libparted: mac: support sector size > 512 correctly
	This patch fixes several problems found when trying to do Apple
	Partition Map on a 4K-sector iPod. The problems happened because of
	unneeded conversion between physical sectors and 512-byte units.
	For devices with sector 512 the conversion did no harm, for others it did.

	List of problems (all are gone with the patch):

	* Partition in OS X, connect to Linux, run "parted <dev> print".
	  "Error: Can't have a partition outside the disk!" is shown.
	  Every partition is displayed 8 times (4k/512) bigger its real size.

	* Exec "mktable mac", connect to OS X.
	  The drive's partitioning scheme is not recognized.

	* mkpart creates partitions 8 times (4k/512) smaller than requested.

2014-05-22  Phillip Susi  <psusi@ubuntu.com>

	tests: test loop labels
	Verify previous fixes to loop labels.

	libparted: don't trash filesystem when writing loop label
	If you deleted the fake partition on a loop label, loop_write() would write
	the loop signature to the device, zeroing out all other bytes in the first
	sector.  When the disk contained an ext[234] filesystem and was using 2k
	sectors, this would trash the super block residing in the 1-2kb part of the
	sector causing the disk to become unrecognized.  Instead, read the existing
	sector and only modify the first few bytes that contain the loop label.

	libparted: give correct partition device name on loop labels
	ped_partition_get_path() was returning "/dev/foo1" instead of
	"/dev/foo" on loop labels.  This caused gparted to run tools like mkfs on
	a device node that did not actually exist.

	partprobe: do not skip loop labels
	Partprobe was not syncing loop labels.  This resulted it failing to remove
	existing partitions when switching to a loop label.

	libparted: don't create partition on loop label
	The loop label represents an unpartitioned disk, but creates
	a dummy partition to represent the whole disk.  This dummy partition
	was actually being loaded into the kernel.  Don't do that.

2014-05-22  Phillip Susi  <psusi@ubuntu.com>

	libparted: fix loop labels to not vanish
	The loop label type was using the existence of a partition as a proxy for
	a filesystem being detected, and loop_write() would try to write a loop
	signature if there was no filesystem, and erase it if there was.  Because
	of this, creating a partition without writing a filesystem to it caused
	loop_write to erase the loop label.

	There seems to be no reason to bother erasing the loop label if it is still
	present along with a filesystem signature, so don't bother with this, and
	actually check to see if a filesystem is detected in the partition rather
	than using the existence of a partition to decide if writing the loop
	signature is needed.  Finally, since there is no way to preserve the
	existence of a partition with no filesystem in it, have loop_read() always
	create a partition, even if no filesystem is detected.

2014-05-22  Phillip Susi  <psusi@ubuntu.com>

	libparted: remove all old partitions, even if new label allows less
	We were limiting partition sync operations to the lesser number allowed
	by the device, or the label.  This meant that when creating a new label
	over an old label that had more partitions than the new one allows, the
	higher partitions would not be removed.  Use the greater of the two values
	for the remove pass, and the lesser for the add.

	libparted: remove old partitions *first* before adding new ones
	"libparted: avoid disturbing partitions" put the remove of the old
	partition in second pass.  If you simultaneously removed partitions 1
	and 2, and created a new partition #1 that overlapped the previous second
	partition, the sync would fail because it would try to create the new,
	larger partition #1 before removing the old partition #2.

	libparted: don't detect fat and ntfs boot sectors as dos MBR
	fat and ntfs boot sectors are very similar to an MBR so if you had one of
	these filesystems on an unpartitioned disk, parted detected them as a dos
	partition table.  Have the dos label code call the fat and ntfs filesystem
	probes and if they recognize the sector ( their tests are more stringent )
	then don't claim it as a dos label.

2014-05-22  Phillip Susi  <psusi@ubuntu.com>

	parted: don't reload partition table on every command
	gpt was using a static local variable to suppress repeatedly reporting
	an error if you chose to ignore it.  This is incorrect as the variable is
	global to all disks, and ignoring the error on one should not suppress its
	reporting on another.  Moving the flag to the PedDisk object made it
	effectively useless because parted was destroying the PedDisk and reloading
	the partition table on every command.

	Parted has been reworked to cache the PedDisk once loaded, and only discard
	it when changing disks, or creating a new disklabel.

2014-05-22  Phillip Susi  <psusi@ubuntu.com>

	libparted: fix fat resize
	The changes to fix filesystem detection on non 512 byte sector sizes broke
	fat filesystem resizing.

2014-05-19  Brian C. Lane  <bcl@redhat.com>

	GPT strings are UCS-2LE not UTF-16
	There was a problem using UTF-16, it was writing the Byte Order Mark
	before the string which caused problems with older versions of parted
	reading the partition name. The test was skipping these 2 bytes when
	checking the written string.

	* libparted/labels/gpt.c: Switch to UCS-2LE for GPT Partition names
	* tests/t0251-gpt-unicode.sh: Update the test

2014-04-29  Brian C. Lane  <bcl@redhat.com>

	Update NEWS with new DASD features.
	* NEWS: New DASD support

2014-04-29  Petr Uzel  <petr.uzel@suse.cz>

	dasd: avoid usage of uninitialized data
	In ped_partition_new(), disk_specific data of PedPartition
	structure is allocated (via dasd_partition_new()). This
	data is later used uninitialized in dasd_partition_set_system().

	* libparted/labels/dasd.c (dasd_partition_new):
	Zero out allocated disk_specific data.

2014-04-29  Nageswara R Sastry  <rnsastry@linux.vnet.ibm.com>

	libparted: mklabel to support EDEV DASD
	Fixed Block Access (FBA) DASDs are mainframe-specific disk devices
	which are layed out as a sequence of 512-byte sectors. This patch adds
	support for mklabel to properly handle FBA devices.

	libparted: Avoid dasd as default disk type while probe
	This patch avoids setting 'dasd' as a default disk type for
	'disk image file' at the time of probe.

	libparted: mklabel to support EAV DASD
	Extended Address Volume (EAV) DASDs are ECKD DASDs with more than
	65520 cylinders. This patch adds support for mklabel to properly
	handle unformatted EAV DASDs.

2014-04-29  Nageswara R Sastry  <rnsastry@linux.vnet.ibm.com>

	libparted: add support for EAV DASD partitions
	Extended Address Volume (EAV) DASDs are ECKD DASDs with more than
	65520 cylinders. This patch adds support for recognizing and
	modifying partitions on EAV DASDs to Parted. The changes are
	based on the EAV support added to version 1.8.1 [1] of the
	s390-tools package.

	[1] http://www.ibm.com/developerworks/linux/linux390/s390-tools-1.8.1.html

2014-04-29  Nageswara R Sastry  <rnsastry@linux.vnet.ibm.com>

	libparted: add support for implicit FBA DASD partitions
	Fixed Block Access (FBA) DASDs are mainframe-specific disk devices
	which are layed out as a sequence of 512-byte sectors. In contrast
	to ECKD DASDs, these disks do not require formatting and resemble
	the LBA layout of non-mainframe disks. Despite this resemblance,
	the Linux kernel applies special handling during partition detection
	for FBA DASDs, resulting in a single, immutable partition being
	reported.

	While actual FBA DASD hardware is no longer available, the z/VM
	hypervisor can simulate FBA DASD disks, backed by either ECKD or
	SCSI devices.

	This patch adds support for recognizing FBA DASD partitions
	to parted.

2014-04-18  Phillip Susi  <psusi@ubuntu.com>

	Fix filesystem detection on non 512 byte sectors
	Enable probing for filesystems with non 512 byte sectors, and fix up each
	filesystem to correctly handle that.  Remove unused field from the fs type
	structure listing acceptable sector sizes.

	tests: fix t2310-dos-extended-2-sector-min-offset.sh
	This test was ignoring the requested sector size and always using
	512 bytes per sector.  Fix it to use the requested sector size.

	tests: fix t1700
	bb181a7e: "tests: Use force for xfs in t1700 and a larger file" caused
	the previous filesystem signatures to be left in the image file
	causing mkfs.nilfs2 to complain that there is already an xfs filesystem
	there, and hang the test suite waiting for an answer to proceed or not.
	Remove the file between filesystems so it is recreated cleanly again.

	libparted: remove last_usable_if_grown
	Commit 3398e82a: "libparted: Use common function to calculate PTE sectors"
	removed usage of the last_usable_if_grown variable, resulting in an error
	because it is now unused but still defined.

2014-04-17  Brian C. Lane  <bcl@redhat.com>

	tests: t1700 change count to seek
	Fix a typo when changing to sparse images.

	* tests/t1700-probe-fs.sh: count should be seek.

2014-04-16  Brian C. Lane  <bcl@redhat.com>

	tests: Use force for xfs in t1700 and a larger file
	Also use sparse files that are (with 512B blocks) 128M so that they are
	large enough for all the filesystems.

	* tests/t1700-probe-fs.sh: Make changes.

2014-04-10  Ming Liu  <ming.liu@windriver.com>

	libparted: fix several integer overflows with dvh labels
	Integer overflows was found in libparted/labels/dvh.c, while attemptting
	assign unsigned int values to int types in some places.

	Defined by unsigned int instead.

	* libparted/labels/dvh.h: Change int to unsigned int

2014-04-10  Brian C. Lane  <bcl@redhat.com>

	testing: Use little-endian packing in gpt tests
	Fix gpt-header-move.py and gpt-header-munge to use little endian when
	packing and unpacking. This allows us to turn the t0210 and t0211 tests
	back on for big-endian systems.

	* tests/gpt-header-move.py: Use little endian for pack/unpack
	* tests/gpt-header-munge: Same
	* tests/t-lib-helpers.sh: Add requires_64bit_ that checks for x86_64 and ppc64
	* tests/t0210-gpt-resized-partition-entry-array.sh: Remove x86_64 test
	* tests/t0211-gpt-rewrite-header.sh: Same

2014-04-08  Brian C. Lane  <bcl@redhat.com>

	tests: Use msdos-overlap to setup t0283
	xxd isn't present in minimal build systems, as it is part of vim. Change
	to using a simple python script to mangle the msdos disklabel for the
	test.

	* tests/msdos-overlap.py: New file
	* tests/t0283-overlap-partitions.sh: Use msdos-overlap.py

2014-04-08  Brian C. Lane  <bcl@redhat.com>

	tests: Add emit_superuser_warning for gpt tests
	When parted runs without script mode it will print a warning about not
	being superuser. Add the library call to add this to expected output
	from the tests.

	* tests/t0281-gpt-grow.sh: Add emit_superuser_warning
	* tests/t0282-gpt-move-backup.sh: Add emit_superuser_warning
	* tests/t0283-overlap-partitions.sh: Add emit_superuser_warning

2014-04-08  Brian C. Lane  <bcl@redhat.com>

	libparted: Use common function to calculate PTE sectors
	Use _ptes_sectors in _parse_header's calculation to determine if the
	disk has been grown.

	* libparted/labels/gpt.c (_parse_header): use _ptes_sectors

2014-04-08  Brian C. Lane  <bcl@redhat.com>

	libparted: Fix check for backup header location
	Add a couple of helper functions for calculating the partition table
	entry size (in sectors) and for guessing the end of the disk based on
	the LastUsableLBA and the Partition Table Entry size.

	The backup header should be either at the end of the disk, or at what
	the primary header thinks is the end of the disk. Prompt to fix the
	backup header if it is located any other place.

	* libparted/labels/gpt.c (_ptes_sectors): New function
	  (_hdr_disk_end): New function
	  (gpt_read): Use new function to test for pri's idea of end of disk

2014-03-05  Gustavo Zacarias  <gustavo@zacarias.com.ar>

	ui: switch to new-style readline typedef
	The CPPFunction typedef (among others) have been deprecated in favour of
	specific prototyped typedefs since readline 4.2 (circa 2001).
	It's been working since because compatibility typedefs have been in
	place until they where removed in the recent readline 6.3 release.
	Switch to the new style to avoid build breakage.

2014-03-05  Phillip Susi  <psusi@ubuntu.com>

	libparted: sync partitions > 16
	The linux partition sync code was hard coded to only flush
	the first 16 partitions.

2014-03-02  Phillip Susi  <psusi@ubuntu.com>

	libparted: don't require a system id string
	Historically the system ID field of a fat boot sector contains a
	string identifying the OS that formatted it.  It appears that some
	recent versions of Windows have stopped bothering with this.  Stop
	requiring this string to recognize fat as valid.

2014-03-02  Brian C. Lane  <bcl@redhat.com>

	tests: Restrict gpt-header-munge to little-endian systems
	gpt-header-munge uses perl to manipulate the gpt header for the test. It
	only works on 64 bit little-endian systems so restrict it to x86_64
	only.

	* tests/t0210-gpt-resized-partition-entry-array.sh: Skip if not x86_64
	* tests/t0211-gpt-rewrite-header.sh: Skip if not x86_64

2014-03-02  Brian C. Lane  <bcl@redhat.com>

	tests: Add btrfs and xfs to the fs probe test
	* tests/tests/t1700-probe-fs.sh: Add btrfs and xfs

2014-03-02  Brian C. Lane  <bcl@redhat.com>

	libparted: Recognize btrfs filesystem
	Add support for showing 'btrfs' in  the 'file system' column. Also
	allows the used to enter btrfs as the fs type. It doesn't really do
	anything -- just sets the partition type to linux.

	* NEWS (Changes in behavior): Mention it.
	* doc/parted.texti: Document btrfs fs.
	* (libparted/fs/Makefile.am): Add btrfs.c
	* (libparted/fs/btrfs/btrfs.c): Probe for btrfs
	* (libparted/libparted.c): Register btrfs

2014-03-02  Brian C. Lane  <bcl@redhat.com>

	libparted: Add UEFI System Partition flag.
	This adds support for the ESP partition type on MS-DOS. It also aliases
	it to the boot flag on GPT which sets the ESP GUID type.

	* NEWS (New Features): Mention it.
	* doc/C/parted.8: Document esp flag.
	* doc/parted.texti: Document esp flag.
	* include/parted/disk.in.h (_PedPartitionFlag): Add PED_PARTITION_ESP flag
	* libparted/disk.c (ped_partition_flag_get_name): Add esp flag
	* libparted/labels/dos.c (DosPartitionData): Likewise
	(raw_part_parse): Likewise
	(msdos_partition_new): Likewise
	(msdos_partition_duplicate): Likewise
	(msdos_partition_set_system): Likewise
	(clear_flags): Likewise
	(msdos_partition_set_flag): Likewise
	(msdos_partition_get_flag): Likewise
	(msdos_partition_is_flag_available): Likewise
	* libparted/labels/gpt.c (gpt_partition_set_flag): Add PED_PARTITION_ESP
	(gpt_partition_get_flag): Likewise
	(gpt_partition_is_flag_available): Likewise

2014-03-02  Brian C. Lane  <bcl@redhat.com>

	libparted: Add Intel Rapid Start Technology partition flag.
	This adds support for the irst partition type flag. Sets the type to
	0x84 on MS-DOS and D3BFE2DE-3DAF-11DF-BA-40-E3A556D89593 on GPT.

	* NEWS (New Features): Mention it.
	* doc/C/parted.8: Document irst flag.
	* doc/parted.texti: Document irst flag.
	* include/parted/disk.in.h (_PedPartitionFlag): Add PED_PARTITION_IRST flag
	* libparted/disk.c (ped_partition_flag_get_name): Add irst flag
	* libparted/labels/dos.c (DosPartitionData): Likewise
	(raw_part_parse): Likewise
	(msdos_partition_new): Likewise
	(msdos_partition_duplicate): Likewise
	(msdos_partition_set_system): Likewise
	(clear_flags): Likewise
	(msdos_partition_set_flag): Likewise
	(msdos_partition_get_flag): Likewise
	(msdos_partition_is_flag_available): Likewise
	* libparted/labels/gpt.c: Add PARTITION_IRST_GUID
	(GPTPartitionData): Add irst flag
	(_parse_part_entry): Likewise
	(gpt_partition_new): Likewise
	(gpt_partition_set_system): Likewise
	(gpt_partition_set_flag): Likewise
	(gpt_partition_get_flag): Likewise
	(gpt_partition_is_flag_available): Likewise

2014-03-02  Brian C. Lane  <bcl@redhat.com>

	tests: rewrite t6001 to use /dev/mapper
	This test began failing because using a private copy of /dev/mapper
	confuses the system. This fixes that and generally cleans up the test.

	tests/t6001.sh: update to use /dev/mapper directly

2014-03-02  Brian C. Lane  <bcl@redhat.com>

	libparted: don't canonicalize /dev/md/ paths (#872361)
	This is the same issue we have with /dev/mapper/ paths that was fixed in
	commit c1eb485b9fd8919e18f192d678bc52b0488e6ee0. When libparted
	is used to setup the device the symlink should be used to reference it,
	not the backing device name which could change.

	* libparted/device.c (ped_device_get): Don't canonicalize names
	  that start with "/dev/md/".

2014-03-02  Brian C. Lane  <bcl@redhat.com>

	tests: Make sure dm UUIDs are not erased
	* tests/t6005-dm-uuid.sh: Make sure dm UUIDs are not erased

	libparted: preserve the uuid on dm partitions (#832145)
	* libparted/arch/linux.c (_dm_add_partition): Set the uuid if there was
	  one.

2014-03-02  Brian C. Lane  <bcl@redhat.com>

	libparted: use dm_udev_wait (#698121)
	This is based on Peter Rajnoha's patch to use dm_udev_wait to
	synchronize with udev.

	This requires libdevmapper v1.02.39 and higher.

	mailing list thread:
	https://lists.gnu.org/archive/html/bug-parted/2010-09/msg00007.html

	* libparted/arch/linux.c (_dm_task_run_wait): New function
	(_is_dm_major): Add cookie and change call to _dm_task_run_wait
	(_is_dmraid_device): Same
	(_dm_is_part): Same
	(dm_canonical_path): Same
	(_dm_remove_partition): Same
	(_dm_get_partition_start_and_length): Same
	(_dm_add_partition): Same
	(linux_new): Enable udev sync support

2014-02-25  Brian C. Lane  <bcl@redhat.com>

	tests: test creating 20 device-mapper partitions (#803108)
	* tests/t6004-dm-many-partitions.sh: Make sure > 17 partitions appear in
	  device mapper.

	libparted: copy pmbr_boot when duplicating GPT disk
	* libparted/labels/gpt.c (gpt_duplicate): copy pmbr_boot flag

2014-02-24  Phillip Susi  <psusi@ubuntu.com>

	Fix help text for disk_{set,toggle}
	Fix the help text to show *disk* flags instead of partition flags.

2013-12-23  Phillip Susi  <psusi@ubuntu.com>

	bug#15591: [PATCH] libparted: handle i18n gpt partition names correctly
	gpt.c was simply truncating the UTF-16 characters stored
	in the partition name field to 8 bits.  This corrupted non
	ascii characters which later resulted in parted crashing in
	strlist.c trying to convert the now invalid multi byte
	characters to wchar.

	gpt.c will now properly convert the UTF-16 to the current
	locale encoding.

2013-11-23  Phillip Susi  <psusi@ubuntu.com>

	libparted: make sure not to treat percentages as exact
	If 1% of the drive size worked out ot be an even power of
	two, it would trigger the exact placement.  Add an exception
	for the percent units.

2013-11-23  Daniel Battaiola Kreling  <dbkreling@br.ibm.com>

	GPT: add support for PReP GUID
	PReP (PowerPC Reference Platform) boot partition is the first partition used in
	PowerPC platform for containing the bootable kernel or bootloader. The firmware
	searches for this partition and jumps to it for booting. So far no GUID was
	specified for this partition type and hence booting from GPT disk was not
	supported on this platform. A new GUID 9e1a2d38-c612-4316-aa26-8b49521e5a8b for
	PReP partition is proposed to be included in GPT.

2013-11-23  Phillip Susi  <psusi@ubuntu.com>

	Fix test compilation
	The tests were not being linked against libpthread but were using
	it, and recent versions of gcc refuse to implicitly pull it in.

	libparted: avoid disturbing partitions
	The partition sync logic was first removing all
	partitions, then trying to re-add them.  This resulted in many
	udev events triggering annoying behavior like auto mounting.
	Refactor the code to avoid removing and re-adding unmodified
	partitions.

	Revert "linux-commit: do not unnecessarily open partition device nodes"
	This reverts commit 2a6936fab4d4499a4b812dd330d3db50549029e0.  The commit
	disabled flushing the block buffer caches on the partition nodes to ensure
	cache consistency on 2.6 kernels, supposedly because this was no longer
	required.  It appears this was incorrect, and the caches DO still need
	flushed, otherwise a new fs written to the partition device does not show
	up in the disk device cache, causing parted to still identify the old fs.

	libparted: allow some common errors to be ignored
	Partitions that overlap or extend beyond the end of the disk are common
	errors that usually result in people having to use other tools to correct
	because parted refuses to operate when it sees them.  Change these errors
	to allow you to ignore them and use parted to correct the problem.

2013-11-23  Phillip Susi  <psusi@ubuntu.com>

	libparted: fix gpt end of disk handling
	There are two checks for problems with the end of disk.  The first checks
	to make sure that the backup gpt is actually at the end of the disk as it
	should be.  The second checks to see that the gpt's idea of where the disk
	ends is correct.  The handling of the backup gpt location was wrong because
	if you chose not to fix the error, then as soon as you made any changes the
	backup would be written to the end of the disk anyhow, only the previous
	backup would not be zeroed.

	This patch fixes the write path to put the backup gpt where the gpt says
	it goes, not where we think the disk ends.  This allows you to choose
	not to fix the problems, and the backup gpt will be written to the same
	place it was before, not the new end of disk.

2013-11-23  Phillip Susi  <psusi@ubuntu.com>

	libparted: handle logical partitions starting immediately after the EBR
	_blkpg_add_partition() set the length of the extended partition
	to 2 sectors to allow LILO to be installed there, beacuse the
	linux kernel does this.  If a logical partition used that second
	sector, adding it would fail beacuse of the overlap.  Now
	_blkpg_add_partition() will limit the length to only the first
	sector if the second is used by a logical partition.

	Previously parted did create the partition table, and after a
	reboot, the kernel would recognize the table, and happily create
	the extended partition as 2 sectors long, thus overlapping the
	logical partition, but when parted tried to recreate the same
	table with BLKPG, the kernel rightly rejected it.

2013-11-23  Phillip Susi  <psusi@ubuntu.com>

	gpt: Revert small device commits
	The following commit broke the position of the LastUsableLBA:

	48f236f9: gpt: permit "mklabel gpt" on a 67-sector device

	It introduced an off by one error, leaving LastUsableLBA pointing to
	the first sector of the backup partition table instead.

	This effectively reverts that commit, as well as adjusting the subsequent
	commits to instead use 68 sectors as the minimum length.  I believe
	this is the minimum legal size as at 67 sectors, there is no valid
	value for FirstUsableLBA and LastUsableLBA.

2013-11-23  Phillip Susi  <psusi@ubuntu.com>

	tests: t6003-dm-hide: don't hang on exception
	If the parted -l found any exceptions, it would print the prompt, which was
	redirected to the log, then hang waiting for input, which never came.  Use
	script mode to disable the prompts.

	parted: fix EOF and ctrl-c handling
	feof() seems to not detect EOF after readline() hits it, so parted went
	into an infinite loop prompting for input on EOF.  Change test to use the
	got_ctrl_c variable instead, which is set when readline hits EOF and
	returns NULL.  This also makes parted properly exit on ctrl-c.

2013-10-09  Jim Meyering  <meyering@fb.com>

	bootstrap: update to latest from gnulib

2013-10-09  Jonathan Liu  <net147@gmail.com>

	dos: improve MBR signature generation
	Using tv_usec in struct timeval from gettimeofday() doesn't provide
	enough precision to fill an unsigned 32-bit integer and isn't really
	random. It it always less than one million when using the GNU C library
	while an unsigned 32-bit integer ranges between 0 and 4294967295.

	In FAT filesystem creation, parted already uses a better random
	generator, so move that code into a common function and use it
	for MS-DOS MBR signature generation.

	* libparted/fs/r/fat/fat.c (_gen_new_serial_number): Remove.
	(fat_create): Use generate_random_uint32 instead of
	_gen_new_serial_number.
	* libparted/labels/dos.c (generate_random_id): Remove.
	(msdos_write): Use generate_random_uint32 instead of
	generate_random_id.
	* libparted/labels/misc.h (generate_random_uint32): New function.
	Created from _gen_new_serial_number in libparted/fs/r/fat/fat.c with
	additional check to avoid returning zero, which may be interpreted
	as no FAT serial number or no MBR signature.

2013-01-06  Jim Meyering  <jim@meyering.net>

	maint: avoid new warning/error with gcc-4.8.0 20130105
	* configure.ac (WERROR_CFLAGS): Disable -Wsuggest-attribute=format.
	It was suggesting to apply the gnu_printf attribute to vsnprintf.

	maint: update all copyright year number ranges
	Run "make update-copyright".

	build: update gnulib submodule to latest

2013-01-02  Jim Meyering  <jim@meyering.net>

	doc: 1MiB-alignment is not enough for cheap flash drives
	* doc/parted.texi: Add an example that aligns to 4GiB, and
	reference Arnd Bergman's LWN article.

2012-10-29  Jim Meyering  <jim@meyering.net>

	tests: make t6003-dm-hide work reliably on F17
	* tests/t6003-dm-hide.sh: Adjust to work reliably on Fedora 17.

2012-10-29  Phillip Susi  <psusi@ubuntu.com>

	libparted: don't probe every dm device in probe_all
	We were probing every dm device.  Only probe dmraid whole disk
	(non-partition) devices instead.  This removes the clutter of
	LVM logical volumes, and dmraid partitions from the list, which
	usually do not make sense to partition.

	* NEWS (Changes in behavior): Mention it.
	* libparted/arch/linux.c (_is_dmraid_device): New function.
	(_dm_is_part): Likewise.
	(_probe_dm_devices): Use the latter.
	* tests/t6003-dm-hide.sh: New test.
	* tests/Makefile.am (TESTS): Add it.

2012-10-29  Phillip Susi  <psusi@ubuntu.com>

	libparted: remove extraneous blkpg add partition ped exception
	_blkpg_add_partition was throwing an exception if it failed to add the
	new partition, in addition to _disk_sync_part_table throwing one, and
	then bailing out.  Instead of bailing out, just log the error for
	reporting later and continue.

	libparted: refactor device-mapper partition sync code
	The device-mapper partition sync code was still using the remove all
	partitions, then add new partitions method.  Refactor to use the same
	algorithm as regular disks: try to remove all, and ignore any that could
	not be removed but have not changed.

2012-10-23  Eric Blake  <eblake@redhat.com>

	build: default to --enable-gcc-warnings in a git tree
	Anyone building from cloned sources can be assumed to have a new
	enough environment, such that enabling gcc warnings by default will
	be useful.  Tarballs still default to no warnings, and the default
	can still be overridden with --disable-gcc-warnings.
	* configure.ac (gl_gcc_warnings): Set default based on environment.

2012-10-17  Brian C. Lane  <bcl@redhat.com>

	tests: cleanup losetup usage
	The unsafe_losetup_ function was failing because losetup didn't
	recognize that the 'private' /dev/loopX devices were the same as
	/dev/loopX, it would fail even if one was in use. Switch to using
	losetup --show which is a cleaner solution.
	Also use sparse file for loop_setup to save space.
	* tests/t-lvm.sh (unsafe_losetup_): Remove function.
	(loop_setup_): Use losetup's --show option instead.
	Use dd with /dev/null, not /dev/zero.
	* tests/t6001-psep.sh: Use loop_setup_ rather than losetup --show.

2012-10-17  Jim Meyering  <jim@meyering.net>

	maint: regenerate .po, .pot files

	maint: use $(AM_V_GEN) to cut down on build noise
	* doc/Makefile.am: Prefix each rule with $(AM_V_GEN).
	* doc/po4a.mk (dist_man_MANS): Likewise.

2012-10-16  Petr Uzel  <petr.uzel@suse.cz>

	partprobe: remove partitions when there is no partition table
	When partprobe detects no partition table on a device, it should
	tell the kernel to drop partitions on that device, but it did not.
	* parted/partprobe.c (process_dev): When ped_disk_probe fails,
	create a dummy (empty) partition table and use that.
	* NEWS (Bug fixes): Mention it.
	Addresses: https://bugzilla.novell.com/783419

2012-10-15  Petr Uzel  <petr.uzel@suse.cz>

	doc: update partprobe manpage
	* doc/C/partprobe.8: Add long options, REPORTING BUGS section
	and adjust DESCRIPTION section because it wasn't quite correct.

	partprobe: remove --no-update long option
	It was deprecated and scheduled for removal in 2009.
	* partprobe/partprobe.c (long_options): Remove "no-update" entry.

	build: .gitignore: ignore tests/fs-resize

2012-10-09  Jim Meyering  <meyering@redhat.com>

	build: do not rely on automake's AM_TESTS_ENVIRONMENT
	* tests/Makefile.am (TESTS_ENVIRONMENT): Rename from
	AM_TESTS_ENVIRONMENT, since it is not honored in automake-1.11.3
	after all.  This reverts commit v3.1-14-g2bd66d7.  For now, I'll
	leave the following commit that made bootstrap.conf require 1.11.2.
	Prompted by a report of test failure from Phillip Susi.

2012-10-09  Gilles Espinasse  <g.esp@free.fr>

	tests: t8001: do not rely on "modprobe loop"
	Remove 'rmmod loop' and 'modprobe loop max_part=7' commands.
	The latter command may fail after the first command has run,
	leaving the machine with no loop support.

	This happens on my chroot, because:
	- rmmod does not depend on the availability of the loop module,
	- modprobe fails, since the kernel compiled inside the chroot
	  is different from the running kernel.

	Instead, rely on t-lvm loop_setup_ to load the loop module, if required.

2012-10-09  Jim Meyering  <meyering@redhat.com>

	tests: improve test for partitionable loop devices
	* tests/init.cfg (require_partitionable_loop_device_): Skip
	when cat fails.

2012-10-06  Jim Meyering  <meyering@redhat.com>

	maint: fix an error in the preceding commit log
	Stefano Lattarini noticed an error in the log for
	commit v3.1-32-g478e472.  Arrange for that error
	to be fixed in the generated ChangeLog file.
	* build-aux/git-log-fix: New file.
	* Makefile.am (gen-ChangeLog): Adjust rule to use it.

	tests: stop using private "dev" directory for losetup
	Something about Fedora 17's losetup changed so that using a private
	dev directory no longer worked.  Now, simply use /dev/ directly.
	* tests/t-lvm.sh: Don't use $G_dev_.  Not needed, and actually
	caused the t6000-dm root-only test to fail on Fedora 17.
	Also, redirect less to /dev/null: that helps diagnose failure.

2012-10-03  Bob Beers  <bob.beers.gmail.com>  (tiny change)

	doc: libparted/disk.c: correct doxygen comment typo
	* libparted/disk.c: s/PedPartition/PedDisk/

2012-09-29  Jim Meyering  <meyering@redhat.com>

	tests: clean up tests
	Use warn_ and $ME_ in place of warn and $ME; remove definitions of
	the latter two.  Remove unused code.
	* tests/lvm-utils.sh: Remove file.  All functions were either unused
	or duplicated/better in t-lvm.sh.
	* tests/Makefile.am (EXTRA_DIST): Remove it.
	* tests/t-local.sh (scsi_debug_setup_): Use echo 1>&2, not warn_, to
	emit to log file only, not console.  The diagnostic it emitted (in
	verbose mode) was more "informational" than a warning.
	* tests/t9030-align-check.sh: Use warn_, not warn.
	* tests/t-lvm.sh: Likewise, and use fail_, not error (undefined!).
	* tests/t-lib-helpers.sh (device_mapper_required_): Use t-lvm.sh
	and an explicit lvm_init_root_dir_ in place of lvm-utils.sh.

2012-09-29  Roderick W. Smith  <rodsmith@rodsbooks.com>

	add support for a new Linux-specific GPT partition type code
	* NEWS: Describe the new Linux-specific partition type code
	and the new msftres flag that can be used to override this type
	code, should it be necessary.
	* doc/parted.texi: Describe of the new msftres flag.
	* include/parted/disk.in.h [_PedPartitionFlag]: Add
	PED_PARTITION_MSFT_DATA.
	* libparted/disk.c: Add check for PED_PARTITION_MSFT_DATA, with
	return of "msftdata", to ped_partition_flag_get_name()
	* libparted/labels/gpt.c (PARTITION_LINUX_DATA_GUID): Define.
	[_GPTPartitionData]: New member, "int msftdata".
	(_parse_part_entry): Set the msftdata flag if and only if the
	PARTITION_BASIC_DATA_GUID type code is in use;
	(gpt_partition_new): Use the PARTITION_LINUX_DATA_GUID
	type as the default type code
	(gpt_partition_set_system): Set the PARTITION_BASIC_DATA_GUID type
	code on partitions on which the msftdata flag is set and set
	PARTITION_LINUX_DATA_GUID as the type by default.
	Clear the msftdata flag in most tests in gpt_partition_set_flag()
	(gpt_partition_set_flag): Add test for PED_PARTITION_MSFT_DATA, which
	sets msftdata and other flags appropriately
	(gpt_partition_get_flag): Add test for the PED_PARTITION_MSFT_DATA
	item that returns the status of the msftdata flag
	(gpt_partition_is_flag_available): Add test for
	PED_PARTITION_MSFT_DATA item to
	* tests/t0220-gpt-msftres.sh: Accommodate the fact that now,
	partition table listings include "msftdata" for file systems
	of type NTFS and FAT*.
	For more discussion and justification, see
	http://thread.gmane.org/gmane.comp.gnu.parted.bugs/10456

2012-09-20  Jim Meyering  <meyering@redhat.com>

	tests: mac: exercise the just-fixed bug
	* tests/t0350-mac-PT-increases-sector-size.sh: New test.
	* tests/Makefile.am (TESTS): Add it.

2012-09-20  Brian C. Lane  <bcl@redhat.com>

	mac: don't let larger partition-table-specified block size evoke UB
	For example, in reading a MAC partition table on a 512-byte sector-size
	disk, _disk_analyse_block_size could find reason to ask if it's ok to
	increase that to e.g., 2048.  Upon a positive reply, we would read 2048
	bytes into a 512-byte buffer.

	* libparted/labels/mac.c (mac_read): If needed, reallocate "buf"
	to accommodate a new, larger sector size.
	* NEWS (Bug fixes): Mention it.

2012-09-20  Jim Meyering  <meyering@redhat.com>

	tests: avoid syntax-check failure for reversed compare args
	* tests/t0203-gpt-create-on-min-sized-device.sh: Reverse args,
	so that any diff output (upon failed test) looks sensible.

2012-09-12  Jim Meyering  <meyering@redhat.com>

	tests: show that small dev now evokes "mklabel gpt" diagnostic
	* tests/t0203-gpt-create-on-min-sized-device.sh: New test.
	* tests/Makefile.am (TESTS): Add it.

	gpt: when "mklabel gpt" fails, always provide a diagnostic
	* libparted/labels/gpt.c (gpt_alloc): When rejecting a device because
	it is too small, give a diagnostic, as is done in every other failure
	path through this function.

	gpt: permit "mklabel gpt" on a 67-sector device
	* libparted/labels/gpt.c (gpt_alloc): Correct checks in order to
	allow creation of a GPT partition table on a 67-sector device.
	The computation of the "data_end" sector number was one too low.
	Whereas there are two sectors at the beginning of the disk (pMBR
	and the GPT header sector), there is only one at the end: the
	backup GPT header.  That (67) is the size of the smallest GPT
	partition table, allowing for *no* partition table sectors.

	tests: update t7000-scripting.sh to avoid new FP
	* tests/t7000-scripting.sh: Use -34s as the endpoint, not -1s,
	to avoid a spurious difference.  Also, remove quoting artifacts.

2012-09-12  Davidlohr Bueso  <dave@gnu.org>

	gpt: require first_usable_LBA <= last_usable_LBA
	When verifying GPT header integrity, ensure that the
	first usable LBA is no larger than the last usable LBA.
	* libparted/labels/gpt.c (_header_is_valid): Reject a header
	with last_usable < first_usable.

2012-09-12  Jim Meyering  <meyering@redhat.com>

	tests: clarify a comment: _reading_ gpt tables on tiny devices
	* tests/t0203-gpt-tiny-device-abort.sh: Clarify.

	maint: remove unnecessary wcslen use
	* parted/strlist.c (gettext_to_wchar): Tighten up test for
	mbsrtowcs failure and remove unnecessary wcslen use.

2012-08-30  Stefano Lattarini  <stefano.lattarini@gmail.com>  (tiny change)

	maint: tighten per version requirement
	* bootstrap.conf ($buildreq): Require Perl >= 5.6 (not merely >= 5.5),
	because that's the minimal version required by modern Automake and
	Autoconf.

	maint: make Autoconf version requirement consistent
	* bootstrap.conf ($buildreq): Require Autoconf >= 2.63, not >= 2.61,
	for consistency with what is done in AC_INIT in configure.ac

2012-08-30  Stefano Lattarini  <stefano.lattarini@gmail.com>  (tiny change)

	build: require Automake >= 1.11.6
	Now that we use AM_TESTS_ENVIRONMENT, we should require at least
	Automake >= 1.11.2; but since all the Automake version until 1.11.5
	are vulnerable to CVE-2012-3386:

	    <https://lists.gnu.org/archive/html/automake/2012-07/msg00023.html>

	it's even better to require 1.11.6.

	* configure.ac (AM_INIT_AUTOMAKE): Bump version requirement to 1.11.6.
	* bootstrap.conf ($buildreq): Likewise.

2012-08-30  Stefano Lattarini  <stefano.lattarini@gmail.com>  (tiny change)

	tests: remove unused AM_TESTS_ENVIRONMENT entries
	Probably a copy&paste errors, likely from the TESTS_ENVIRONMENT
	definition in the 'tests/Makefile.am' in GNU coreutils.

	* tests/Makefile.am (AM_TESTS_ENVIRONMENT): Don't define nor export
	any of the variables PREFERABLY_POSIX_SHELL, REPLACE_GETCWD, CC,
	MAKE, PERL.

2012-08-30  Stefano Lattarini  <stefano.lattarini@gmail.com>  (tiny change)

	tests: prefer AM_TESTS_ENVIRONMENT over TESTS_ENVIRONMENT
	The latter should be reserved for user overrides.

	* tests/Makefile.am (TESTS_ENVIRONMENT): Rename ...
	(AM_TESTS_ENVIRONMENT): ... like this.

2012-08-30  Stefano Lattarini  <stefano.lattarini@gmail.com>  (tiny change)

	build: enable subdir-objects Automake option globally
	That option is enabled unconditionally in Automake-NG, and enabling
	it also for mainline Automake will help to ensure no unexpected
	incompatibilities is introduced in a potential port to Automake-NG.

	Moreover, if we have a source file 'sub/foo.c', having it compiled
	in 'sub/foo.o' rather than in 'foo.o' is undeniably cleaner and more
	natural.

	* configure.ac (AM_INIT_AUTOMAKE): Add 'subdir-objects'.
	* libparted/fs/Makefile.am (AUTOMAKE_OPTIONS): No need to declare
	'subdir-objects' explicitly now.

2012-08-30  Stefano Lattarini  <stefano.lattarini@gmail.com>  (tiny change)

	build: prefer pattern rules over suffix rules
	That is acceptable, because the GNU parted build system already
	requires GNU make anyway: the $(subst ...) built-in is used in the
	common recipe for the 'ss-1024', 'ss-2048' and 'ss-4096' targets
	in Makefile.am.

	* include/parted/Makefile.am (.in.h.h): Rename ...
	(%.h: %.in.h): ... as this pattern rule.
	(SUFFIXES): Delete, no more needed.

2012-08-30  Stefano Lattarini  <stefano.lattarini@gmail.com>  (tiny change)

	build: don't list files with unknown suffix in _SOURCES
	While this works with mainline Automake (which blindly treats source
	files with an unknown extension as if they were header files), it is
	undocumented (albeit admittedly unlikely to change).  Moreover, it no
	longer works with Automake-NG (and that's by design), so the use of
	such feature would make a port to Automake-NG more difficult.

	* libparted/labels/Makefile.am (liblabels_la_SOURCES): ... don't
	list 'pt-limit.gperf' here; rather ...
	(EXTRA_DIST): ... list 'pt-limit.c' and 'pt-limit.gperf' here.
	(EXTRA_DIST, BUILT_SOURCES): Enhance few comments.

2012-08-30  Stefano Lattarini  <stefano.lattarini@gmail.com>  (tiny change)

	build: prefer $(AM_CPPFLAGS) over $(INCLUDES)
	The latter is obsolete, and might be removed in future Automake versions.
	Moreover, it's already been removed in Automake-NG, so its use would make
	a port to Automake-NG more difficult.

	* parted/Makefile.am (INCLUDES): Rename ...
	(AM_CPPFLAGS): ... like this.
	* partprobe/Makefile.am: Likewise.
	* libparted/fs/Makefile.am: Likewise.
	* libparted/Makefile.am: Likewise.
	* libparted/labels/Makefile.am: Likewise.

2012-08-28  Jim Meyering  <meyering@redhat.com>

	build: update gnulib, bootstrap and init.sh

	maint: don't prohibit strncpy just yet
	* cfg.mk (local-checks-to-skip): Add sc_prohibit_strncpy,
	so that we do not yet enable the strncpy prohibition.
	There are many uses, and it will be a lot of work to remove
	all of them.

	maint: avoid new syntax-check failure re @xref
	* doc/parted.texi: Adjust @xref usage: it must be used only
	at start of sentence.
	* doc/parted-pt_BR.texi: Likewise.

2012-06-09  Jim Meyering  <meyering@redhat.com>

	tests: add a test to exercise just-fixed code
	* tests/print-max.c: Extend to provide coverage of
	ped_disk_get_max_supported_partition_count, too.
	* tests/t9021-maxima.sh (max_n_partitions): New function, with
	naively hard-coded max-number-of-partitions-per-partition-table-type
	values.
	Use it to ensure that each expected value matches the actual one.
	* cfg.mk: Exempt this test's use of error from the syntax-check
	for unmarked diagnostics.

2012-06-09  Richard W.M. Jones  <rjones@redhat.com>

	gpt: fix endianness bug in gpt_get_max_supported_partition_count
	* libparted/labels/gpt.c (gpt_get_max_supported_partition_count):
	Take endianness of pth->FirstUsableLBA into account (64-bit,
	little endian) when calculating the maximum number of partitions.
	* NEWS (Bug fixes): Mention it.

2012-03-26  Jim Meyering  <meyering@redhat.com>

	tests: remove bogus envvar setting from t0300-dos-on-gpt.sh
	* tests/t0300-dos-on-gpt.sh: Remove envvar setting that effectively
	disabled testing(only in this test) of simulated sector sizes smaller
	than 4KiB.
	Also, use a much smaller backing file.

2012-03-24  Brian C. Lane  <bcl@redhat.com>

	tests: add t0301-overwrite-gpt-pmbr.sh
	Make sure parted checks the PMBR before the GPT partition table.

	* NEWS: Update with new GPT behavior.
	* tests/overwrite-gpt-pmbr.sh: New test.
	* tests/Makefile.am (TESTS): Add it.

2012-03-24  Brian C. Lane  <bcl@redhat.com>

	libparted: check PMBR before GPT partition table
	The UEFI spec requires that a valid GPT disk label have a PMBR
	partition. This moves the PMBR check to before the GPT check,
	exiting gpt_probe with a 0 if the PMBR is not valid.

	The previous behavior would cause problems in the following situation:
	 1. format a disk as GPT
	 2. re-format it as MSDOS using tools that don't understand GPT

	Subsequent operations with parted would then complain about the invalid
	PMBR, but would not allow the disk to be used as an msdos disk. This
	change causes parted to recognize the msdos partition table.

	* libparted/labels/gpt.c (gpt_probe): Move _pmbr_is_valid test.
	Reported by Chris Murphy in http://bugzilla.redhat.com/805272

2012-03-02  Jim Meyering  <meyering@redhat.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 3.1
	* NEWS: Record release date.

	maint: bump library version to 2.0.0
	* libparted/Makefile.am (CURRENT): Increment, since I removed
	ped_realloc.

	maint: update README-release to reflect we now have two libraries
	* README-release: Two sets of library version triples to adjust.
	* bootstrap: Tiny fix from gnulib.

	lib-fs-resize: remove unused probe-related code
	* libparted/fs/r/hfs/probe.c: Remove probe-related functions.
	There are not used.
	* libparted/fs/r/fat/fat.c: Likewise.
	* libparted/fs/r/hfs/probe.h: ...and declarations.

2012-02-26  Jim Meyering  <meyering@redhat.com>

	libparted: avoid unwarranted failed assertion during mklabel
	This could happen when running "parted -s $dev mklabel $type" for
	nearly any $type, assuming the underlying disk's sector size is
	larger than 512 bytes.  This particular failure was noticed by
	running tests/t9050-partition-table-types.sh with a simulated
	sector size of 1024, as is done as part of a top-level "make check",
	but so far, this failure has shown up only on RHEL-6.2.
	That test attempts to exercise an ugly part of partition table
	creation: during creation, parted checks for an existing
	partition table by iterating through its list of known types and
	attempting to read the disk, looking for a preexisting table.
	Knowing this, the test takes all pairs of partition table types,
	<A,B> and first creates a type of type A, and then creates on top
	of that (erasing the original) a table of type B.
	* libparted/labels/mac.c (_disk_analyse_ghost_size): Remove bogus
	assertion.  If the number of the sector with a matching signature
	is too large, simply reject it by returning 0.
	* NEWS (Bug fixes): Mention this.

2012-02-25  Jim Meyering  <meyering@redhat.com>

	doc: improve NEWS
	* NEWS: Expand/adjust wording in two entries.

2012-02-21  Jim Meyering  <meyering@redhat.com>

	tests: sanitize PATH; do not discard mkswap output
	* tests/init.cfg (sanitize_path_): New function, from coreutils.
	Use it.
	* tests/t9050-partition-table-types.sh: Do not discard mkswap output
	and diagnostics.  This test would fail (e.g., on OpenSUSE 12.1), when
	run with PATH not including /sbin.  Reported by Bruno Haible.

2012-02-18  Jim Meyering  <meyering@redhat.com>

	tests: skip failing use of mkfs.hfs unless using newer, fixed version
	The old, segfaulting version does not recognize the -v option, while
	the new one does.  Use that to skip the test when it seems that
	fsck.hfs is broken.
	* tests/t3000-resize-fs.sh: Skip part of this root-only test
	when fsck.hfs is the always-segfaulting version.

	build,test: update gnulib, bootstrap and init.sh
	* bootstrap: Update.
	* tests/init.sh: Update.
	* gnulib: Update.
	* doc/po4a.mk: Updating gnulib pulls in newer syntax-check rules,
	including one that rejects @lower_case@ variables in Makefiles.
	Fix the sole violation: s/@mandir@/$(mandir)/

	build: avoid non-srcdir build failure
	* libparted/fs/Makefile.am: s!fsresize.sym!$(srcdir)/fsresize.sym!

2012-02-10  Jim Meyering  <meyering@redhat.com>

	maint: placate syntax-check wrt tests/fs-resize.c
	* tests/fs-resize.c (main): Remove unused #includes.
	Do use set_program_name, to placate syntax-check.

	doc: mention HFS+/FAT file system resizing in NEWS
	* NEWS (New features): Mention it.

	tests: test FAT and HFS file system resizing
	* tests/t3000-resize-fs.sh: New test.
	* tests/Makefile.am (TESTS): Add it.
	(check_PROGRAMS): Add fs-resize.
	(fs_resize_LDADD): Define, so it links with both libraries.

2012-02-10  Christoph Hellwig  <hch@lst.de>

	tests: add FS-resize test driver
	* tests/fs-resize.c: New file, to test FAT/HFS resizing.

2012-02-10  Jim Meyering  <meyering@redhat.com>

	lib-fs-resize: use linker script to expose only selected functions
	* libparted/fs/Makefile.am (libparted_fs_resize_la_LDFLAGS): Define.
	(EXTRA_DIST): Distribute the new file.
	(libparted_fs_resize_la_DEPENDENCIES): Make the library depend on it.
	* libparted/fs/fsresize.sym: New file.

	maint: remove r/hfs/DOC,HISTORY,TODO; add VERSION for new library

	lib-fs-resize: rewrite ped_file_system_clobber
	Before, it would probe for an existing file system type and then,
	according to what it found, call the corresponding <FS_TYPE>_clobber
	function.  Now that we have restored only HFS and FAT FS-writing
	support, only those few types have a corresponding _clobber function.
	We would obviously fail to clear common types of file systems, and even
	if we were to restore all previous _clobber functions, none of those
	were able to handle sector sizes larger than 512.  Not worth it.
	* libparted/fs/r/filesys.c: Include pt-tools.h.
	(MIN): Define.
	(ped_file_system_clobber): Rewrite not to use hfs*_clobber or
	fat_clobber.  Instead, simply clear the first three and last two
	sectors of the specified "device".
	* libparted/fs/Makefile.am (INCLUDES): Add
	-I$(top_srcdir)/libparted/labels for new use of a ptt_* function.

	lib-fs-resize: add wrappers for open,close,resize,get_resize_constraint
	* libparted/fs/r/filesys.c: Implement ped_file_system_resize,
	ped_file_system_open, ped_file_system_close and
	ped_file_system_get_resize_constraint.
	* libparted/fs/r/hfs/hfs.c: Give a few functions global scope,
	so we can use them from the above.
	* libparted/fs/Makefile.am: Use automake's subdir-objects option.
	This avoids conflicts with multiple *.o file names
	(e.g., fat.o), now that two directories provide that name.
	(AM_CFLAGS): Disable $(WERROR_CFLAGS), for now.

	maint: update copyrights in r/

2012-02-07  Jim Meyering  <meyering@redhat.com>

	lib-fs-resize: re-add HFS and FAT file-system-related code
	This just adds the code, without hooking it up yet.
	* po/POTFILES.in: Add all libparted/fs/r/**.c files.

	maint: remove now-unused fat-related functions
	* libparted/fs/fat/bootsector.c (fat_boot_sector_generate)
	(fat_boot_sector_write, fat_info_sector_write): Remove functions.
	(fat_boot_sector_set_boot_code): Likewise.
	* libparted/fs/fat/bootsector.h: Remove declarations.
	* libparted/fs/fat/fat.c (fat_set_frag_sectors, fat_free_buffers):
	Remove function.
	* libparted/fs/fat/fat.h: Remove declarations.

	tests: set PARTED_TEST_NAME, for valgrind
	* tests/Makefile.am (PARTED_TEST_NAME): Define.
	* tests/t0211-gpt-rewrite-header.sh: Clarify a comment.

	libparted: gpt: avoid heap-read-overrun when rewriting 9-PTE table
	Now that parted can rewrite a corrupt-or-misaligned 9-PTE table,
	we have to be careful to allocate space for slightly more data
	when the byte-count required for a PTE table is smaller than
	the whole number of sectors would imply.  I.e., when the PTE table
	size is not a multiple of the sector size, there is a fraction of
	that final sector for which we do not read data, but we do write.
	Ensure we have space for the buffer we'll write and that it is
	initialized (to 0's).
	* libparted/labels/gpt.c (gpt_write): Allocate the right amount of
	space.  Use calloc, not malloc+memset.

2012-02-03  Jim Meyering  <meyering@redhat.com>

	maint: adjust the URL that will appear in the generated announcement
	* cfg.mk (url_dir_list): Use this http://ftp.gnu.org/gnu/$(PACKAGE)
	for the first link listed in the generated announcement.
	announce-gen now provides the faster mirror link automatically.

	ui: rewrite disk_print_flags and partition_print_flags
	* parted/parted.c (disk_print_flags): Avoid NULL-dereference on
	failed malloc.  Use xrealloc, not ped_realloc.
	(partition_print_flags): Likewise; nearly identical code.

	tests: avoid relatively harmless new "make syntax-check" failure
	* tests/t0209-gpt-pmbr_boot.sh: Reverse compare arguments.

	libparted: remove ped_realloc, now unused
	* include/parted/parted.in.h (ped_realloc): Remove declaration.
	* libparted/libparted.c (ped_realloc): Remove definition.

2012-02-02  Brian C. Lane  <bcl@redhat.com>

	doc: update parted documentation
	* doc/parted.text: Add disk_set command.

	tests: add test for GPT PMBR pmbr_boot flag
	* tests/t0209-gpt-pmbr_boot.sh: New test
	* tests/Makefile.am: Add new test
	* NEWS: Add information about the GPT PMBR pmbr_boot flag

	tests: update tests for new disk flags output
	* tests/t0010-script-no-ctrl-chars.sh: Updated
	* tests/t0100-print.sh: Updated
	* tests/t0101-print-empty.sh: Updated
	* tests/t0220-gpt-msftres.sh: Updated
	* tests/t0250-gpt.sh: Updated
	* tests/t0280-gpt-corrupt.sh: Updated
	* tests/t2310-dos-extended-2-sector-min-offset.sh: Updated
	* tests/t4000-sun-raid-type.sh: Updated
	* tests/t4100-dvh-partition-limits.sh: Updated
	* tests/t4100-msdos-partition-limits.sh: Updated
	* tests/t4100-msdos-starting-sector.sh: Updated
	* tests/t4200-partprobe.sh: Updated
	* tests/t5000-tags.sh: Updated
	* tests/t6000-dm.sh: Updated
	* tests/t9040-many-partitions.sh: Updated
	* tests/t9041-undetected-in-use-16th-partition.sh: Updated

2012-02-02  Brian C. Lane  <bcl@redhat.com>

	parted: when printing, also print the new disk flags
	This adds a 'Disk Flags:' line the displays the active disk flags.
	In machine mode this is appended to the disk info line, after the
	device model.

	* parted/parted.c (disk_print_flags): New function
	(_print_disk_info): Add Disk Flags information.

2012-02-02  Matthew Garrett  <mjg@redhat.com>

	gpt: add commands to manipulate pMBR boot flag
	Some BIOS systems will only boot from GPT partitions if the boot flag is
	set on the protective MBR partition. This adds the ability to set this
	flag using the disk_set and disk_toggle commands.
	* include/parted/disk.in.h (_PedDiskFlag): Add PED_DISK_GPT_PMBR_BOOT
	* libparted/disk.c (ped_disk_flag_get_name): Add PED_DISK_GPT_PMBR_BOOT
	* libparted/labels/gpt.c (_GPTDiskData): Add pmbr_boot flag.
	(gpt_alloc): Init pmbr_boot to 0.
	(gpt_read_headers): Set pmbr_boot state from PMBR boot flag.
	(_write_pmbr): Add pmbr_boot flag and set PMBR boot flag from it.
	(gpt_write): Pass pmbr_boot flag through to _write_pmbr
	(gpt_disk_set_flag): New function
	(gpt_disk_is_flag_available): New function
	(gpt_disk_get_flag): New function
	(gpt_disk_ops): Add disk_set_flag, disk_get_flag, disk_is_flag_available
	* parted/parted.c (do_disk_set): New function
	(do_disk_toggle): New function
	(_init_commands): Add do_disk_set and do_disk_toggle
	* parted/ui.c (command_line_get_disk_flag): New function
	* parted/ui.h: Add command_line_get_disk_flag prototype.

2012-01-23  Jim Meyering  <meyering@redhat.com>

	tests: create 128 partitions also in the scsi-backed test
	* tests/t9040-many-partitions.sh: Tighten up: use less memory:
	1 sector per partition rather than 256.
	Exec parted just once, not once per partition.
	With that, we can increase the number of partitions to create
	from 60 (which used to take 2.5 minutes on an F12-era kernel)
	to the standard-GPT-header-imposed maximum of 128.
	Suggested by Phillip Susi.

	tests: exercise today's bug fix, creating a GPT table with 128 entries
	* tests/t0212-gpt-many-partitions.sh: New test.
	* tests/Makefile.am (TESTS): Add it.

	libparted: gpt: avoid invalid free with many (~100) partitions
	* parted/parted.c (do_print): Remove invalid free.
	Bug introduced via v1.8.8.1-19-gb56d69c.
	* NEWS (Bug fixes): Mention this.

2012-01-22  Jim Meyering  <meyering@redhat.com>

	tests: test for yesterday's bug fix
	* tests/Makefile.am (TESTS): Add it.
	* tests/t0211-gpt-rewrite-header.sh: New test.

	libparted: gpt: rewrite even a 9-partition-entry table properly
	The vast majority of GPT partition tables have 128 PTEs (partition
	table entries.  However, zfs-related ones have only 9, and when
	rewriting one (which can happen only in interactive mode), parted
	would fail to write the full PTE array whenever the PTE array size
	was not a multiple of the sector size.  This fixes the same type
	of bug as v3.0-45-gce85c51.
	* libparted/labels/gpt.c (gpt_write): When computing how many sectors
	to write for the PTE array, round up rather than truncating.  This
	matters only when n_PTEs * 128 is not a multiple of the sector size.
	For details on how to reproduce see the test or
	http://thread.gmane.org/gmane.comp.gnu.parted.bugs/10691/focus=10695
	* NEWS (Bug fixes): Mention it.

2012-01-21  Jim Meyering  <meyering@redhat.com>

	maint: clean-up preparing for bug fix
	* libparted/labels/gpt.c (gpt_write): Rename local:
	s/ptes_size/ptes_bytes/; declare as size_t, not "int".
	Move decls "down".

2012-01-19  Phillip Susi  <psusi@cfl.rr.com>

	libparted: raise dos partition limit from 16 to 64
	* NEWS (Bug fixes): Mention it.
	* libparted/labels/dos.c (MAX_TOTAL_PART): s/16/64/
	* tests/t9042-dos-partition-limit.sh: s/13/61/ (MAX_TOTAL_PART-3)
	(adjust/factor some of the logic - jmm)

2012-01-18  Phillip Susi  <psusi@cfl.rr.com>

	libparted: enforce dos partition limit
	The msdos partition table claimed a maximum partition count of 16
	but would allow you to go beyond that.  This resulted in the kernel
	not being informed of those partitions.  Corrected to enforce the
	limit.

	* NEWS (Bug fixes): Mention it.
	* libparted/labels/dos.c (next_primary): Return -1 upon failure.
	(next_logical): Stop no later than MAX_TOTAL_PART.
	Throw exception and return -1 upon failure.
	(msdos_partition_enumerate): Convert a negative partition number
	return value from either of the above two to failure (return 0).
	* tests/t9042-dos-partition-limit.sh: New file.
	* tests/Makefile.am (TESTS): Add it.

2012-01-13  Jim Meyering  <meyering@redhat.com>

	build: revert the recent "fix" to avoid make warnings about linux.lo
	It avoided the warning, but introduced a real problem
	when building from a clean directory.
	The real solution will have to wait, since it appears to
	depend on a fix in automake.

	This reverts commit a3c351c2d1cf2c0000bbc681959695c612bd19a0.

2012-01-13  Jim Meyering  <meyering@redhat.com>

	build: don't use -version for convenience libraries
	Don't use -release, either.  This avoids warnings from libtool.
	* libparted/fs/Makefile.am (libfs_la_LDFLAGS): Remove.

	build: use LT_INIT, to make bootstrap run libtoolize
	* configure.ac: Use LT_INIT, so that bootstrap runs libtoolize,
	which creates build-aux/ltmain.sh.

2012-01-12  Jim Meyering  <meyering@redhat.com>

	maint: remove useless BUILD_LINUX conditional
	* configure.ac (BUILD_LINUX): Don't set it.
	* libparted/Makefile.am (BUILD_LINUX): Remove useless use.

2012-01-12  Jim Meyering  <meyering@redhat.com>

	maint: avoid long-standing warnings from make:
	  Makefile:1274: warning: overriding recipe for target `linux.lo'
	  Makefile:1267: warning: ignoring old recipe for target `linux.lo'

	* libparted/Makefile.am (EXTRA_DIST): Rename from
	EXTRA_libparted_la_SOURCES.

2012-01-12  Jim Meyering  <meyering@redhat.com>

	libparted: provide a new convenience function: ptt_geom_clear_sectors
	* libparted/labels/pt-tools.c (ptt_geom_clear_sectors): New function.
	* libparted/labels/pt-tools.h: Declare it.

2012-01-11  Jim Meyering  <meyering@redhat.com>

	maint: remove "MAINTAINERCLEANFILES = Makefile.in" from Makefile.am's
	* debug/Makefile.am: As above.
	* debug/test/Makefile.am: Likewise.
	* doc/C/Makefile.am: Likewise.
	* doc/pt_BR/Makefile.am: Likewise.
	* include/Makefile.am: Likewise.
	* include/parted/Makefile.am: Likewise.
	* libparted/Makefile.am: Likewise.
	* libparted/fs/Makefile.am: Likewise.
	* libparted/tests/Makefile.am: Likewise.
	* partprobe/Makefile.am: Likewise.
	* doc/Makefile.am: Likewise, for mdate-sh and texinfo.tex.

2012-01-10  Keshav P R  <the.ridikulus.rat@gmail.com>

	build: insert -I$(top_builddir)/include before -I$(top_srcdir)/include
	everywhere, for those who perform non-srcdir builds from a pristine
	cloned directory.  There is no problem when building from a tarball,
	since that includes include/parted/*.h files under $(top_srcdir).
	* libparted/Makefile.am: Insert it.
	* libparted/fs/Makefile.am: Likewise.
	* libparted/labels/Makefile.am: Likewise.
	* libparted/tests/Makefile.am: Likewise.
	* parted/Makefile.am: Likewise.
	* partprobe/Makefile.am: Likewise.
	* tests/Makefile.am: Likewise.

2012-01-10  Jim Meyering  <meyering@redhat.com>

	build: .gitignore: ignore more

	maint: hoist libparted/fs/*/Makefile.am into parent Makefile.am
	There was no need to have a separate Makefile.am for each file system
	type, and a good reason *not* to do that (reduce duplication).
	* configure.ac (AC_OUTPUT): Remove Makefiles.
	* libparted/fs/Makefile.am (SUBDIRS): Remove.
	(EXTRA_DIST): List the two non-src files: hfs/DOC hfs/HISTORY.
	(libfs_la_SOURCES): Hoist file names to here from...
	* libparted/fs/amiga/Makefile.am: ...here.
	* libparted/fs/ext2/Makefile.am: Likewise.
	* libparted/fs/fat/Makefile.am: Likewise.
	* libparted/fs/hfs/Makefile.am: Likewise.
	* libparted/fs/jfs/Makefile.am: Likewise.
	* libparted/fs/linux_swap/Makefile.am: Likewise.
	* libparted/fs/nilfs2/Makefile.am: Likewise.
	* libparted/fs/ntfs/Makefile.am: Likewise.
	* libparted/fs/reiserfs/Makefile.am: Likewise.
	* libparted/fs/ufs/Makefile.am: Likewise.
	* libparted/fs/xfs/Makefile.am: Likewise.
	* libparted/fs/*/Makefile.am: Remove files.
	* libparted/fs/amiga/a-interface.c: Now that the .o files are all
	in the same place, rename from interface.c, to avoid collision with
	name of .o file from ext2/interface.c.

	build: correct my typo in preceding commit
	* configure.ac (AC_CONFIG_SRCDIR): Correct preceding commit.
	Keshav's patch was correct, but when I attempted to do the same
	thing manually I wrote .h.in rather than .in.h.

2012-01-10  Keshav P R  <the.ridikulus.rat@gmail.com>

	build: update AC_CONFIG_SRCDIR for non-srcdir-from-clone builds
	* configure.ac (AC_CONFIG_SRCDIR): List parted.h.in, rather than
	the now-generated parted.h, for those who run configure not from
	a distribution tarball, but from a non-srcdir build using a pristine
	clone.

2012-01-09  Jim Meyering  <meyering@redhat.com>

	maint: rename public .h files to .in.h
	Generate .h files from .in.h files, so that we can continue
	to use _GL_ATTRIBUTE_PURE and _GL_ATTRIBUTE_CONST in the primary
	sources, without including them in publicly-installed files.
	Each generated (and later installed) header file gets expansions
	of those macros.
	* include/parted/Makefile.am: New rules.
	* .gitignore: Ignore the generated files.
	* Makefile.am (SUBDIRS): Reorder so we build in include/ before
	libparted, i.e., so that we generate the .h files we'll need.

	parted.h: use _GL_ATTRIBUTE_CONST and _GL_ATTRIBUTE_PURE in VC'd files
	However, we will replace those strings with their expansions when
	installing them.
	* include/parted/parted.h: Revert part of commit v3.0-83-gd51bfc0.

	tests: root-only test would fail to remove its loop device
	* tests/t8001-loop-blkpg.sh: Ironically, when skipping this test,
	there was a race condition where in more than 7 out of 10 trials,
	this test's "losetup -d $dev" command would fail with "device in use".
	Hence, with enough testing, I would eventually use up all loop devices
	and start getting new test failures due to losetup *creation* failure.

	build: fix "make distcheck" failure
	Ever since "make distcheck" began using sudo (i.e., running "make check"
	as root, and then running it as non-root), the build-after-root would
	often fail due to some derived files being owned by root.
	This change adds a "chown -R $USER ." to restore order.
	* Makefile.am (root-check): Run "chown -R $USER ." after sudo run.
	(root_check): Rename variable from root-check, to avoid a warning
	from automake about non-POSIX variable.

	build: appease gcc's -Werror=suggest-attribute=pure
	* parted/strlist.c (wchar_strcasecmp): Add pure attribute; make static.
	(wchar_strncasecmp): Likewise.
	(wchar_strdup): Likewise.

2012-01-09  Jim Meyering  <meyering@redhat.com>

	build: update to latest from gnulib
	* bootstrap: Update.
	* tests/init.sh: Likewise.
	* gnulib: Update submodule to latest.

	maint: remove two generated files in doc/
	* doc/fdl.texi: Remove file from version control.  It is generated.
	* doc/gendocs_template: Likewise.
	* doc/parted.texi: Add @node ... before inclusion of fdl.texi,
	since fdl.texi dropped that part.
	* doc/parted-pt_BR.texi: Likewise.
	* doc/.gitignore: Update.

	build: accommodate newer bootstrap from gnulib
	* bootstrap.conf (gnulib_tool_option_extras): Add both --symlink
	and --makefile-name=gnulib.mk.  Remove stray use of $bt.
	* lib/Makefile.am: Initialize all of the following so that
	generated code in gnulib.mk may use += to append to those variables:
	AM_CFLAGS, AM_CPPFLAGS, BUILT_SOURCES, CLEANFILES, EXTRA_DIST,
	MAINTAINERCLEANFILES, MOSTLYCLEANDIRS, MOSTLYCLEANFILES, SUFFIXES,
	noinst_LTLIBRARIES.

2012-01-09  Jim Meyering  <meyering@redhat.com>

	libparted: gpt: a smaller device need not render both headers invalid
	Putting a valid GPT-labeled image on a smaller device, (i.e., one that
	truncates the backup GPT header, but that does not impact the primary
	one) should not render the primary header invalid.
	* libparted/labels/gpt.c (_header_is_valid): Do *not* reject a header
	when its last_usable value is larger than the device length.
	This reverts part of commit v3.0-10-g99f9c6a, "gpt: don't abort for a
	truncated GPT-formatted device".  With this change, running parted in
	interactive mode with such an image/device combination will recognize
	that only the backup header is corrupt, and will offer to correct it.
	Before, it would report that both headers were corrupt.
	* tests/t0203-gpt-shortened-device-primary-valid.sh: New file.
	* tests/Makefile.am (TESTS): Add it.

	gpt: eliminate four PED_ASSERT uses
	* libparted/labels/gpt.c (_parse_header): Convert a few PED_ASSERT
	uses to friendlier 'test-and-return-0's. Reported by Graham Markall
	in http://thread.gmane.org/gmane.comp.gnu.parted.bugs/10653

2012-01-08  Jim Meyering  <meyering@redhat.com>

	libparted: don't use _GL_ATTRIBUTE_CONST in public parted.h, ...
	Instead, use the bare __attribute__((__const__)).
	* include/parted/parted.h (__attribute): Define.
	(ped_get_version): Use open-coded __attribute.
	Prompted by a report from Keshav P R.

	tests: fix misleading mkpart usage
	Using "primary" is fine (and common) as a partition *type* for dos
	partition tables, but with a partition table of type GPT, it is
	downright misleading to specify the partition *name* as "primary".
	* tests/t0220-gpt-msftres.sh: Use "p-name" as partition name,
	rather than misleading "primary".
	* tests/t7000-scripting.sh: Likewise.

2012-01-05  Jim Meyering  <meyering@redhat.com>

	tests: skip loop-partitioning tests when ext_range is < 2
	* tests/init.cfg (require_partitionable_loop_device_): New function.
	* tests/t8001-loop-blkpg.sh: Use it.
	* tests/t8000-loop.sh: Use it.

	libparted: remove _blkpg_get_partition
	[I applied Phillip's initial patch, omitting both my adjustments
	and his own v2 changes.  This addresses both of those omissions. ]
	* libparted/arch/linux.c (_blkpg_get_partition): Remove function
	and sole use, per patch from Phillip Susi.
	(_kernel_get_partition_start_and_length): Adjust formatting,
	remove unnecessary test and correct a diagnostic.

2012-01-05  Phillip Susi  <psusi@cfl.rr.com>

	libparted: avoid the HDIO_GETGEO ioctl when possible
	We were using the long depreciated HDIO_GETGEO ioctl on the
	partition to get its start sector.  Use the new BLKPG_GET_PARTITION
	ioctl instead.  This allows for disks > 2TB and partitioned loop
	devices, which don't support HDIO_GETGEO.  As a fallback when
	BLKPG_GET_PARTITION fails or is not availible, try getting the
	values from sysfs, and finally use BLKGETSIZE64 and HDIO_GETGEO
	as a last resort.

	libparted: remove has_partitions check to allow loopback partitions
	Commit 1b766b69 added the _has_partitions function to check if a device
	was a loop device and if so, skip updating the kernel partition table
	because loop devices did not support partitions.  This function never
	worked anyway, and loop devices now (since linux 3.2) support
	partitions, so remove this crufty code.
	* libparted/arch/linux.c (_has_partitions): Remove function and
	all uses.

	libparted: remove _loop_get_partition_range
	Commit 1eb0cc30 added support for loop devices to be partitioned,
	but it only enabled that support if the kernel parameter max_part
	was non zero.  This parameter just reserves minor numbers for
	partitions in the traditional sequence that hard disks used.
	When it is zero, it is still possible to add partitions, they
	just will get minor numbers from another pool.  Removing this
	check allows partitions to be used on loop devices even when the
	loop module was not loaded with the max_part argument.
	* libparted/arch/linux.c (_loop_get_partition_range): Remove function
	and all uses.

2012-01-05  Jim Meyering  <meyering@redhat.com>

	tests: fix a bug in wait_for_dev_to_disappear_ helper function
	* tests/t-lib-helpers.sh (wait_for_dev_to_disappear_): Correct
	typo: missing expr in subshell.

2012-01-04  Phillip Susi  <phillsusi@gmail.com>

	libparted: linux: exclude floppy from device scan
	Floppies can't be partitioned anyhow, and some people have a
	misconfigured BIOS that thinks there is a floppy when there
	actually isn't, and trying to scan it causes hanging.

2012-01-03  Phillip Susi  <phillsusi@gmail.com>

	tests: try harder to clean up scsi_debug
	Tests were failing because the previous test gave up while trying to
	unload the scsi_debug module.  Try longer to remove it, and then throw
	in a call to udevadm settle for good measure.
	* tests/t-local.sh: Try harder to release resources here, rather than...
	* tests/t9040-many-partitions.sh: ...in this one test.
	* tests/t-local.sh (require_scsi_debug_module_): Now that
	cleanup requires "udevadm settle", add that requirement here:
	call require_udevadm_settle_.

2012-01-01  Jim Meyering  <meyering@redhat.com>

	maint: update all copyright year number ranges
	Run "make update-copyright".

2011-12-14  Phillip Susi  <psusi@cfl.rr.com>

	doc: add NEWS entry for "Add partition separator only when required"

2011-12-12  Phillip Susi  <psusi@cfl.rr.com>

	Add partition separator only when required
	Device mapper type should not automatically
	mean add 'p' before the partition number.  Fall back to
	adding it only if the previous character is a digit.
	This complies with kpartx behavior and linux behavior
	"since the dawn of time".

2011-12-03  Jim Meyering  <meyering@redhat.com>

	build: update gnulib submodule to latest

	build: address a new "noreturn" suggestion
	* parted/ui.h (help_msg): Declare as __noreturn__.

	build: configure.ac: use -Wno-format-nonliteral

	build: mark functions with "const" or "pure" attribute, per gcc warnings
	Use _GL_ATTRIBUTE_PURE or _GL_ATTRIBUTE_CONST.  Mark static functions at
	point of definition; extern ones at point of declaration.
	* include/parted/crc32.h:
	* include/parted/device.h: Likewise.
	* include/parted/disk.h: Likewise.
	* include/parted/exception.h: Likewise.
	* include/parted/filesys.h: Likewise.
	* include/parted/geom.h: Likewise.
	* include/parted/natmath.h: Likewise.
	* include/parted/parted.h: Likewise.
	* include/parted/unit.h: Likewise.
	* libparted/arch/linux.c: Likewise.
	* libparted/disk.c: Likewise.
	* libparted/exception.c: Likewise.
	* libparted/fs/amiga/amiga.h: Likewise.
	* libparted/labels/aix.c: Likewise.
	* libparted/labels/bsd.c: Likewise.
	* libparted/labels/dos.c: Likewise.
	* libparted/labels/dvh.c: Likewise.
	* libparted/labels/efi_crc32.c: Likewise.
	* libparted/labels/gpt.c: Likewise.
	* libparted/labels/mac.c: Likewise.
	* libparted/labels/pc98.c: Likewise.
	* libparted/labels/rdb.c: Likewise.
	* libparted/labels/sun.c: Likewise.
	* libparted/unit.c: Likewise.
	* parted/ui.c: Likewise.
	* parted/strlist.c: Likewise.
	* parted/strlist.h: Likewise.
	* libparted/tests/common.h (_implemented_disk_label): Mark as pure.
	* libparted/cs/natmath.c (extended_euclid): Mark as pure.

	build: avoid new float-to-double warnings
	* libparted/timer.c (ped_timer_new_nested): Mark literal floating point
	constants with "f" suffix, since they are compared against "float"s.
	* parted/parted.c (_timer_handler): Likewise.

	build: tweak how bootstrap manages ChangeLog
	* bootstrap.conf: Create ChangeLog only by touching it, so that
	it doesn't ever remove my in-use symlink (w/vc-dwim).

	tests: two more of these: use "compare exp out", not "compare out exp"
	* tests/t7000-scripting.sh: Reverse compare arguments.
	* tests/t2310-dos-extended-2-sector-min-offset.sh: Likewise.

2011-11-29  Jim Meyering  <meyering@redhat.com>

	tests: use "compare exp out", not "compare out exp"
	Likewise, when an empty file is expected, use "compare /dev/null out",
	not "compare out /dev/null". I.e., specify the expected/desired contents
	via the first file name.  Prompted by a suggestion from Bruno Haible
	in http://thread.gmane.org/gmane.comp.gnu.grep.bugs/4020/focus=29154

	Run these commands:

	    git grep -l -E 'compare [^ ]+ exp' \
	      |xargs perl -pi -e 's/\b(compare) (\S+) (exp\S*)/$1 $3 $2/'
	    git grep -l -E 'compare [^ ]+ /dev/null' \
	      |xargs perl -pi -e 's,\b(compare) (\S+) (/dev/null),$1 $3 $2,'

2011-11-27  Petr Uzel  <petr.uzel@suse.cz>

	tests: test for partitions on mdraid
	* tests/t6100-mdraid-partitions.sh: New file.
	* tests/Makefile.am: Run this test.

2011-11-26  Petr Uzel  <petr.uzel@suse.cz>

	libparted: use ext_range to find out largest possible partition
	Parted uses /sys/block/DEV/range file to find out how many partitions
	can the blockdevice hold and uses this number in its algorithm
	for informing the kernel about modified partitions. This works
	fine for most devices, however, it fails on partitionable MD arrays,
	because these have 1 in range file. Using ext_range should be safer
	and work for all devices.

	* libparted/arch/linux.c (_device_get_partition_range): Use
	/sys/block/DEV/ext_range instead of range sysfs file
	* NEWS: Mention the change.

	Addresses: http://bugzilla.novell.com/567652

2011-11-26  Petr Uzel  <petr.uzel@suse.cz>

	build: gitignore tests/duplicate
	.gitignore: Add tests/duplicate.

2011-11-11  Jim Meyering  <meyering@redhat.com>

	maint: a little defensive programming in a test script
	* tests/gpt-header-munge: Use "local *F;" to limit scope of
	file handles.

2011-11-10  Jim Meyering  <meyering@redhat.com>

	tests: skip a test if Perl's Digest::CRC module is not installed
	* tests/init.cfg (require_perl_digest_crc_): New function.
	* tests/t0210-gpt-resized-partition-entry-array.sh: Use it.
	Reported by Keshav P R in
	http://thread.gmane.org/gmane.comp.gnu.parted.bugs/10530/focus=10589

	tests: fix test for udevadm
	* tests/init.cfg (sector_size_): Fix syntax error in test invocation.

	maint: "make distcheck" now runs the root-only tests
	* Makefile.am (root-check): New overridable variable and rule.
	(distcheck-hook): Depend on it.

	build: update gnulib submodule to latest

	maint: adjust the URL that will appear in the generated announcement
	* cfg.mk (url_dir_list): Use this http://ftp.gnu.org/gnu/$(PACKAGE)
	for the first link listed in the generated announcement.
	announce-gen now provides the faster mirror link automatically.
	Remove now-unnecessary release-related URLs.

2011-11-06  Jim Meyering  <meyering@redhat.com>

	build: update gnulib submodule to latest

	build: stop distributing gzip'd releases;  xz is enough
	* configure.ac (AM_INIT_AUTOMAKE): Add no-dist-gzip.
	* NEWS (Build-related): Mention that we're dropping .tar.gz.

2011-11-05  Jim Meyering  <meyering@redhat.com>

	tests: exercise and document the HFS-probe bug fix
	Simply zeroing out the total_blocks and block_size members of the
	on-disk _HfsMasterDirectoryBlock would provoke a failed assertion
	any time parted tried to probe that partition.
	* tests/t2500-probe-corrupt-hfs.sh: New script.
	* tests/Makefile.am (TESTS): Add it.
	* NEWS (Bug fixes): Mention this.

2011-11-05  Brian C. Lane  <bcl@redhat.com>

	libparted: HFS/HFS+ probe: don't let a corrupt FS evoke failed assertion
	* libparted/fs/hfs/probe.c (hfsplus_probe): Add a check on the
	search value and reject it if it is negative.
	(hfsx_probe): Likewise.
	(hfs_and_wrapper_probe): Likewise.
	Reported by Flos Lonicerae in http://bugzilla.redhat.com/714758

2011-11-04  Brian C. Lane  <bcl@redhat.com>

	tests: t9030 wait for partition removal
	The removal of the partition may take enough time that the next
	mkpart will fail.  Wait for it to be removed.

	Remove scsi_debug size and set the end of the partition to 800s so that
	it will fit inside the default scsi_debug size of 8M, even when sector
	size is 4Kb. This prevents failures on machines with limited memory.

	* tests/t9030-align-check.sh: Wait for partition removal and use
	a smaller disk.

2011-11-04  Jim Meyering  <meyering@redhat.com>

	tests: add a helper function
	* tests/t-lib-helpers.sh (wait_for_dev_to_disappear_): New function.

	tests: exercise the "GPT vs other-sized partition entry arrays" fixes
	* tests/t0210-gpt-resized-partition-entry-array.sh: New file.
	* tests/Makefile.am (TESTS): Add it.
	(EXTRA_DIST): Add gpt-header-munge.

	tests: rewrite/complete GPT-munging perl script
	Rewrite and complete this script.
	It was incomplete and buggy.  Now it works.
	* tests/gpt-header-munge: Rename from ...
	* tests/perl-munge-9-PTE-table: ...this.

2011-11-03  Jim Meyering  <meyering@redhat.com>

	gpt: don't misbehave with e.g., a 9-entry partition array
	* libparted/labels/gpt.c (_generate_header): Correct size of
	partition array entries to round up to nearest multiple of
	sector size, so that we set gpt->PartitionEntryLBA correctly
	also when the number of partition entries is not a multiple
	of sector_size / 128.  Problem diagnosed by Robert Herndon
	in http://thread.gmane.org/gmane.comp.gnu.parted.bugs/10173.

2011-11-03  Robert Herndon  <Robert.Herndon@quantum.com>

	gpt: prepare for tables with n_partition_array_entries != 128
	* libparted/labels/gpt.c (gpt_read_PE_array): When computing the size
	of the partition array entry, use the value of "number of partition
	array entries" read from a GPT header, not the default of 128 that we
	use when creating new headers.  Details here:
	http://thread.gmane.org/gmane.comp.gnu.parted.bugs/10173

2011-11-03  Jim Meyering  <meyering@redhat.com>

	parted: exit nonzero for certain failures already diagnosed as "Error"
	* parted/parted.c (do_print): Do not exit successfully when issuing
	an error about an "unrecognised disk label" or when both GPT primary
	and backup tables are corrupted.
	* tests/t0101-print-empty.sh: Adjust expected exit code to match
	new behavior.
	* NEWS (Bug fixes): Mention this.

	tests: adjust a test to make its failure easier to diagnose
	* tests/t0203-gpt-tiny-device-abort.sh: When failing, also
	emit parted's diagnostics.

2011-11-02  Jim Meyering  <meyering@redhat.com>

	maint: correct two comments in gpt.c
	* libparted/labels/gpt.c (gpt_read_headers): Correct the comment.
	(_header_is_valid): Fix a harmless typo.

2011-11-02  Brian C. Lane  <bcl@redhat.com>

	tests: add new test to check ped_disk_duplicate
	* tests/duplicate.c: New test.
	* tests/t0501-duplicate.sh: New test program.
	* tests/Makefile.am (TEST): Add new test.
	(check_PROGRAMS): Add new test program.

	libparted: copy flags when duplicating GPT partitions
	* libparted/labels/gpt.c (gpt_partition_duplicate): Copy flags to new
	partition.
	* NEWS: Mention this fix.
	Reported by Chris Murphy in https://bugzilla.redhat.com/747497.

2011-11-02  Petr Uzel  <petr.uzel@suse.cz>

	tests: exercise the new feature
	* tests/t0208-mkpart-end-in-IEC.sh: New file.
	* tests/Makefile.am: Add it.

2011-11-02  Petr Uzel  <petr.uzel@suse.cz>

	parted: mkpart: DWIM for IEC ending sector numbers like 2MiB and 9GiB
	Before, if the user specified start and end in mkpart command using
	IEC units, parted created a partition that starts and ends exactly on
	these positions. With such behavior, it is impossible to create
	partitions as follows: 1MiB-2MiB, 2MiB-3MiB - parted would complain
	that it cannot create the second partition, because the first one
	occupied sectors 2048-4096 and the second one sectors 4096-3072,
	so they would overlap at sector 4096.

	With this patch, if the user uses IEC units to specify end of the
	partition, parted creates the partition which ends one sector before
	the specified position.

	See also
	https://lists.gnu.org/archive/html/bug-parted/2011-10/msg00009.html

	* parted/ui.c (command_line_get_sector): Add parameter to retrieve
	raw input from user.
	* parted/ui.h (command_line_get_sector): Adjust prototype of function.
	* parted/parted.c (_adjust_end_if_iec): New function.
	(_strip_trailing_spaces): New function.
	(_string_ends_with_iec_unit): New function.
	(do_mkpart): Call _adjust_end_if_iec(). Use new parameter of
	command_line_get_sector function.
	(do_rescue): Adjust call to command_line_get_sector.
	* bootstrap.conf (gnulib_modules): Add these: c-ctype, c-strcase.
	* tests/t0207-IEC-binary-notation.sh: Adjust to new semantics.
	* NEWS: Mention the changed behavior.

	Notable adjustments:
	- s/isspace/c_isblank/ so that parsing is locale-independent
	- avoid an array-bounds error:
	  * parted/parted.c (_strip_trailing_spaces): Don't deref str[-1]
	  for an empty string.

2011-10-19  Brian C. Lane  <bcl@redhat.com>

	tests: add tests for new pc98 signatures (#646053)
	 * tests/t2201-pc98-label-recog.sh: New file
	 * tests/Makefile.am: Add test

2011-10-19  Brian C. Lane  <bcl@redhat.com>

	libparted: make pc98 detection depend on signatures
	pc98 is not a common disk label. Change pc98_probe to only return true
	if one of the recognized signatures is present.
	Currently these include:

	IPL1
	Linux 98
	GRUB/98

	This prevents false-positive detection on msdos labeled disks.

	* libparted/labels/pc98.c (pc98_probe): Change to require signature
	(pc98_check_ipl_signature): Add more signatures
	(check_partition_consistency): Remove unused function
	Reported by Zach Carter in http://bugzilla.redhat.com/646053

2011-10-15  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: use more portable fd redirection in TESTS_ENVIRONMENT
	* tests/Makefile.am (TESTS_ENVIRONMENT): Redirection with `exec 9>&2'
	is not portable to various Korn shells, and to (at least) HP-UX 11
	/bin/sh.  Use a more portable idiom.
	See <http://thread.gmane.org/gmane.comp.gnu.coreutils.bugs/22488> for
	lots of discussion.

2011-10-15  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: TEST_ENVIRONMENT simplified and made more robust
	The test scripts in tests/ are shell scripts, so the current
	definition of TESTS_ENVIRONMENT, which adaptively run tests using
	either perl or the shell depending on their kind, is overkill.

	Moreover, this change is required in order for the testsuite to
	continue to work with the new testsuite harness that is planned
	to be introduced in Automake 1.12 (which, as of the writing date,
	is still under development and in late alpha state).

	See also related discussion on bug-coreutils:
	  <http://debbugs.gnu.org/cgi/bugreport.cgi?bug=8887>

	* tests/help-version: Moved ...
	* tests/help-version.sh: ... to this.
	* tests/Makefile.am (TESTS): Update.
	(TESTS_ENVIRONMENT): Remove definition of the `shell_or_perl_' shell
	function, which is not required anymore.
	(SH_LOG_COMPILER): New, define to `$(SHELL)'.

2011-10-14  Richard W.M. Jones  <rjones@redhat.com>

	tests: fix the tests for the case where stdout/stderr is different
	tests/t0000-basic.sh:
	 - More than one bogus ^M[[:space:]]*^M had to be removed, hence
	   use s,,,g sed expression.

	tests/t0203-gpt-tiny-device-abort.sh:
	 - Test was not expecting any output to stderr.  No longer true.

	tests/t1100-busy-label.sh:
	 - Another case of s,,,g as above.

	tests/t7000-scripting.sh:
	 - Only testing output to stdout.  Fold stdout & stderr together
	   and test both.
	 - Another case of s,,,g as above.

	Some root tests still fail even with these fixes.  The failures appear
	to be unrelated to these changes.

2011-10-14  Richard W.M. Jones  <rjones@redhat.com>

	parted: write a few errors and warnings to stderr instead of stdout

	parted: strlist print functions can now send output to any FILE *
	This changes the two strlist print functions so that instead of just
	sending output to stdout, they can send it to any FILE *.  Now the
	caller can send errors to stderr instead of stdout.

2011-10-12  Petr Uzel  <petr.uzel@suse.cz>

	parted: make a warning message more informative
	The following parted message is not very useful:

	  Error: You requested a partition from 2.00MiB to 3.00MiB.
	  The closest location we can manage is 2.00MiB to 3.00MiB.

	Improve the message by including exact geometry (in sectors):

	  ...requested a partition from 2.00MiB to 3.00MiB (sectors 2048..3072).
	  ... location we can manage is 2.00MiB to 3.00MiB (sectors 2049..3072).

	* parted/parted.c (do_mkpart): Include exact partition geometry in
	the warning message.
	* tests/t-lib-helpers.sh (normalize_part_diag_): Adapt to
	handle the new form of the diagnostic.
	* tests/t7000-scripting.sh: Adapt and change the name
	of a temporary file.

2011-10-03  Petr Uzel  <petr.uzel@suse.cz>

	doc: update manpage
	Remove documentation for removed commands, adjust general description to
	match parted's capabilities, add documentation for 'toggle' and
	'align-check' commands. Remove 'KNOWN ISSUES' section since it no longer
	applies.

	tests: verify that 'udevadm settle' is available
	* tests/init.cfg (require_udevadm_settle_): New function.
	* tests/t8001-loop-blkpg.sh: Call it.

2011-10-01  Petr Uzel  <petr.uzel@suse.cz>

	libparted: do not omit last sector when creating full-dev geometry
	Note that ped_constraint_solve_max() is currently not used anywhere.

	* libparted/cs/constraint.c (ped_constraint_solve_max): full_dev now
	really represents whole device.

2011-10-01  Petr Uzel  <petr.uzel@suse.cz>

	maint: unmark PedDeviceType as deprecated
	PedDeviceType was marked as deprecated before parted started using
	git. Since it proved to be useful to differentiate between different
	device types, and nobody seems interested in removing it from the API,
	let's clear the deprecated flag.

2011-10-01  Petr Uzel  <petr.uzel@suse.cz>

	libparted: do not call _device_get_partition_range() twice
	PED_MIN can evaluate its arguments twice.

	* libparted/arch/linux.c (_disk_sync_part_table): Call
	_device_get_partition_range() outside PED_MIN.

2011-10-01  Petr Uzel  <petr.uzel@suse.cz>

	libparted: optimize _disk_sync_part_table
	In _disk_sync_part_table, if the largest partition number (lpn) is 0,
	it does not make sense to go through the loops below.  Return
	immediately instead.
	* libparted/arch/linux.c (_disk_sync_part_table): Return immediately
	if lpn == 0.

	build: ignore more generated files

	parted: remove obsolete comments
	is_start_exact and is_end_exact were removed from the source.
	* parted/parted.c (constraint_from_start_end): Remove obsolete
	documentation of the function.

	libparted: check return value from ped_geometry_init
	If ped_geometry_init() failed in ped_disk_set_partition_geom(),
	then new_geom remains uninitialized, but still later used, which
	leads to unexpected results.
	* libparted/disk.c (ped_disk_set_partition_geom): Check return
	value from ped_geometry_init().

2011-09-30  Petr Uzel  <petr.uzel@suse.cz>

	tests: add test for partitionable loop devices
	* tests/t8001-loop-blkpg.sh: New file.
	* tests/Makefile.am: Add test.

2011-09-29  Petr Uzel  <petr.uzel@suse.cz>

	libparted: improve support for partitions on loopback devices
	Since linux-2.6.26, the kernel allows partitions on loopback devices.
	Implement support for this feature in parted.
	* libparted/arch/linux.c (_sysfs_int_entry_from_dev): New function.
	(_loop_get_partition_range): New function.
	(_device_get_partition_range): Add special handling for loop devices.
	* NEWS: Mention this change.

	libparted: differentiate between plain files and loop devices
	Stop using PED_DEVICE_FILE for loopback devices;
	loopback are significantly different from plain files.
	* include/parted/device.h (PedDeviceType): Add PED_DEVICE_LOOP.
	* libparted/arch/linux.c (_device_probe_type): Detect loopback device.
	* parted/parted.c (do_print): Add "loopback" to list of transports.

	dvh: factor out read_sector and use ptt_read_sector
	* libparted/labels/dvh.c (read_sector): Factor out this function.
	(dvh_probe): Use ptt_read_sector instead of read_sector.
	(dvh_read): Likewise.

2011-09-28  Jim Meyering  <meyering@redhat.com>

	build: update gnulib to latest; adapt use of _GL_ATTRIBUTE_FORMAT
	* libparted/arch/linux.c (_GL_ATTRIBUTE_FORMAT): Define here,
	now that it's no longer defined by gnulib.

	build: avoid new syntax-check failure
	* cfg.mk: Exempt libparted/arch/beos.c from the PATH_MAX check.
	I suspect that this is ok, because parted compiles only on systems
	that define PATH_MAX to something reasonable.

	doc: mention the origin of the other two bugs
	* NEWS: Mention that the other two bugs were introduced long ago.

	tests: test for the nilfs2 bug
	* tests/t4300-nilfs2-tiny.sh: New test.
	* tests/Makefile.am (TESTS): Add it.

	libparted: fix a bug in the nilfs2 probe function
	* libparted/fs/nilfs2/nilfs2.c (nilfs2_probe): Reject this partition
	if we get a negative sb2 offset.  Passing a negative offset to
	ped_geometry_read_alloc would evoke a failed assertion.
	Bug introduced by 2010-07-09 commit d463e7de.
	* NEWS: (Bug fixes): Mention it.
	Reported by Daniel Fandrich in
	http://thread.gmane.org/gmane.comp.gnu.parted.bugs/10466/focus=10472

2011-06-24  Jim Meyering  <meyering@redhat.com>

	gpt: don't abort for a truncated GPT-formatted device
	This fixes the problem two ways.  The first fix (via gpt_alloc)
	rejects any device that is too small, but it is insufficient.
	Choose a slightly larger truncated device with an otherwise intact
	primary GPT header and you can still trigger the failed assertion.
	To fix it in general, we make _header_is_valid detect the problem.
	* libparted/labels/gpt.c (gpt_alloc): Reject a device that is so
	small that there is no room for a single partition.
	(_header_is_valid): Validate LastUsableLBA here, as well, so that
	we now reject as invalid any GPT header that specifies a
	LastUsableLBA larger than the device size.
	Leave the assertion in _parse_header.
	* tests/t0203-gpt-tiny-device-abort.sh: Test for this.
	* tests/Makefile.am (TESTS): Add it.
	* NEWS: (Bug fixes): Mention it.
	Reported by Daniel Fandrich in
	http://thread.gmane.org/gmane.comp.gnu.parted.bugs/10466

	libparted: avoid invalid diagnostic in interactive mode
	* libparted/arch/linux.c (linux_read): In interactive mode,
	a truncated device with a preexisting GPT could evoke this:
	  Error: end of file while reading Success
	it should have been like this:
	  Error: end of file while reading /full/name/of/device
	Use %0.0s to discard the strerror argument.

2011-06-22  Brian C. Lane  <bcl@redhat.com>

	tests: add test for value less than 1
	* tests/t9023-value-lt-one.sh: New file.
	* tests/Makefile.am (TESTS): Add it.

	tests: add test for radius divide by 2 fix
	* tests/t9022-one-unit-snap.sh: New file.
	* tests/Makefile.am (TESTS): Add it.

2011-06-22  Brian C. Lane  <bcl@redhat.com>

	libparted: don't allow values less than 1 (#665496)
	When a value < 1 is used there is the possibility that the range can
	overlap sector 0. The user should use smaller units instead. 0 is a
	special case and is still allowed.

	* libparted/unit.c (ped_unit_parse_custom): Throw error if a value
	between 0 and 1 is used.

2011-06-22  Brian C. Lane  <bcl@redhat.com>

	libparted: fix snap radius so that it is using half (#665496)
	The snap radius didn't match the documentation, it has been using +/-
	unit size instead +/- 0.5 * unit (eg. 500KB for a MB unit). This caused
	problems when specifying 1MB, 1GB, etc. as a partition start or end
	resulting in partitions being created that were nowhere near the
	specified size.

	* libparted/unit.c (ped_unit_parse_custom): divide radius by 2
	This addresses http://bugzilla.redhat.com/665496

2011-06-10  Jim Meyering  <meyering@redhat.com>

	maint: prefer AC_PROG_LIBTOOL over slightly deprecated AM_PROG_LIBTOOL
	* configure.ac: Use AC_PROG_LIBTOOL rather than slightly deprecated
	AM_PROG_LIBTOOL.

2011-06-07  H. Peter Anvin  <hpa@zytor.com>

	libparted: simplify kernel version-parsing logic
	* libparted/arch/linux.c: (_get_linux_version): Simplify and add
	an assertion.

2011-06-06  Jim Meyering  <meyering@redhat.com>

	libparted: accommodate two-component linux version number like 3.0
	* libparted/arch/linux.c (_get_linux_version): Also accept 2-component
	version numbers.
	* NEWS: (Bug fixes): Mention it.
	Reported by Richard W.M. Jones.

2011-05-30  Jim Meyering  <meyering@redhat.com>

	post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 3.0
	* NEWS: Record release date.

	maint: placate coverity: don't ignore some return values
	* libparted/cs/constraint.c: Include <assert.h>.
	(ped_constraint_exact): Don't ignore ped_alignment_init's return
	value or that from ped_geometry_init.

	loop: avoid NULL dereference upon failure
	* libparted/labels/loop.c (loop_partition_duplicate): Don't dereference
	NULL upon failure.

	shared library version: increment major: 1.0.0
	* libparted/Makefile.am (CURRENT, REVISION): Update from 0.2.0 to 1.0.0,
	due to removed interfaces.

	build: update gnulib submodule to latest

2011-05-27  Jim Meyering  <meyering@redhat.com>

	doc: update NEWS
	* NEWS (Changes in behavior): Describe the change.
	(Bug fixes): Mention the leak fixes.

	doc: reflect removal of FS-related commands
	* README (WARNING): Say that all FS-manipulation code is now gone.
	* doc/parted.texi (Command explanations): Remove descriptions of and
	any examples or references to the following commands: check, cp,
	mkfs, mkpartfs, move, resize.

	build: remove configure-time options: --disable-fs, --enable-Werror
	* configure.ac: Remove support for --enable-fs and --disable-fs.
	Remove support for --enable-Werror and --disable-Werror.
	* README: Remove paragraph about --disable-fs and
	--enable-discovery-only.
	* libparted/libparted.c: Now that --disable-fs is gone (i.e.,
	ENABLE_FS would be always 1), remove its #ifdefs.

	tests: make t0220 more useful when it fails

	maint: update po/POTFILES.in
	* po/POTFILES.in: Remove file names, to reflect file deletions.

	doc: remove FS-related documentation and other stale bits
	* doc/parted.texi: Remove FS-related documentation and other
	stale bits.

	linux_swap: remove all-but-probe FS-related code

	xfs: remove all-but-probe FS-related code

	jfs: remove all-but-probe FS-related code

	ufs: remove all-but-probe FS-related code

	reiserfs: remove all-but-probe FS-related code

	hfs: remove all-but-probe FS-related code

	ntfs: remove all-but-probe FS-related code

	amiga: build with warning and error options
	* libparted/fs/amiga/Makefile.am (AM_CFLAGS): Add $(WARN_CFLAGS)
	and $(WERROR_CFLAGS).

	ext2: remove all-but-probe FS-related code

	fat: remove all-but-probe FS-related code

	remove all top-level FS-op code and the clearfat program

	UI: remove all file-system-aware sub-commands
	Note that we are removing the resize command, even though parted
	appears to be the only free tool that provides the ability to
	resize FAT16 and FAT32 file systems.
	* parted/parted.c (do_mkfs, do_cp, do_mkpartfs): Remove functions.
	(do_move, do_check, do_resize): Likewise.
	(_init_commands): Remove each command-definition clause.
	* parted/parted.c (_partition_warn_loss): Remove now-unused function.
	* include/parted/filesys.h: Remove declarations of now-removed
	FS-munging functions

	tests: t1100: show that adding a partition on a busy device succeeds
	* tests/t1100-busy-label.sh: Demonstrate that adding a partition
	succeeds, even when another on the same device is mounted (active).

	amiga: avoid NULL-deref-on-OOM and an error-path leak
	* libparted/labels/rdb.c (amiga_read): Don't dereference NULL on OOM.
	Don't leak a constraint when failing to add a partition.

	mac: avoid NULL-deref-on-OOM and an error-path leak
	* libparted/labels/mac.c (mac_read): Don't dereference NULL on OOM.
	Don't leak a constraint when failing to add a partition.

	sun: avoid NULL-deref-on-OOM and an error-path leak
	* libparted/labels/sun.c (sun_read): Don't dereference NULL on OOM.
	Don't leak a constraint when failing to add a partition.

	UI: avoid leak when interactive sector selection matches default
	* parted/ui.c (command_line_get_fs_type): Don't leak an input "word".

	UI: plug a leak
	* parted/ui.c (command_line_get_fs_type): Don't leak an FS type name
	string.

	bsd: avoid NULL-deref-on-OOM and an error-path leak
	* libparted/labels/bsd.c (bsd_read): Don't dereference NULL on OOM.
	Don't leak a constraint when failing to add a partition.

	linux: don't leak a FILE* upon /proc read failure
	* libparted/arch/linux.c (_probe_proc_partitions): Call fclose
	upon failure.

	linux: plug a file descriptor leak
	* libparted/arch/linux.c (read_device_sysfs_file): Don't leak a
	file descriptor.

	tests: t1100-busy-label: don't use mkpartfs; rework to use scsi_debug
	* tests/t1100-busy-label.sh: Remove one last use of mkpartfs.
	Use scsi_debug rather than requiring an explicitly-provided device.

2011-05-26  Jim Meyering  <meyering@redhat.com>

	maint: correct coverity-reported "suspicious sizeof"
	* parted/table.c (table_add_row): Use sizeof(*VAR), rather than
	erroneous sizeof(explicit_type) that just happened to be ok.

	maint: remove unreachable code
	* libparted/labels/sun.c (sun_partition_new): Remove unreachable stmt.
	* libparted/labels/pc98.c (pc98_partition_new): Likewise.

	build: update gnulib submodule to latest

2011-05-18  Jim Meyering  <meyering@redhat.com>

	post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 2.4
	* NEWS: Record release date.

	shared library version: increment REVISION
	* libparted/Makefile.am (REVISION): Increment, since there have
	been changes to the library, but no interface addition or removal.
	* README-release: Mention the shared-library version update procedure.

	build: update gnulib submodule to latest

	tests: avoid nasty FP-causing race condition
	* tests/t9040-many-partitions.sh: Remove all partitions before
	exiting -- otherwise, the rmmod-prompted removal of those many
	partitions would continue long after rmmod completion and the
	release of the scsi_debug lock, and thus partition-device removals
	provoked by this test would cause failure in the subsequent test,
	e.g., when the devices for partitions 14,15,16 have just been
	successfully created (verified that they exist), yet the next
	step -- to create a file system on one of them -- fails or is
	erroneously skipped because the device has been removed asynchronously.

	tests: add double quotes around another use of $VERBOSE
	* tests/t-local.sh (scsi_debug_setup_): Quote another $VERBOSE.

	build: list bc as a build-requirement
	* bootstrap.conf (buildreq): Also require "bc", since it's used
	in some of 'make check's tests.

2011-05-17  Jim Meyering  <meyering@redhat.com>

	tests: remove tests that are too FS-centric
	* tests/t2100-mkswap.sh: Likewise.
	* tests/t3000-resize-fs.sh: Remove file, now that all FS-ops are gone.
	* tests/Makefile.am (TESTS): Remove them here, too.

	linux: fix diagnostic about operating on very small file or device
	* libparted/arch/linux.c (init_file): Correct diagnostic.
	Parted would claim that a small-but-non-empty file has zero length.

	bfs: remove unused files

	tests: add double quotes around a use of $VERBOSE
	* tests/t-local.sh (scsi_debug_cleanup_): Add missing double quotes.

2011-05-12  Jim Meyering  <meyering@redhat.com>

	tests: avoid new, spurious test failure
	* tests/t9050-partition-table-types.sh: Use a "device size"
	that is large enough to accommodate 1KiB and 4KiB sectors.
	The original size, 3MiB was too small for a dvh partition
	with PARTED_SECTOR_SIZE=1024.  Increase it to 30MiB.

	tests: adapt t1101-busy-partition not to use mkpartfs
	* tests/t1101-busy-partition.sh: Use mkfs.vfat instead.

2011-05-10  Jim Meyering  <meyering@redhat.com>

	tests: write all pairs of partition table types
	* tests/t9050-partition-table-types.sh: New file.
	* tests/Makefile.am (TESTS): Add it.

	tests: add a NEWS entry and a test to exercise today's bug fix
	* tests/t9041-undetected-in-use-16th-partition: New file.
	* tests/Makefile.am (TESTS): Add it.
	* NEWS (Bug fixes): Describe it.

2011-05-10  Phillip Susi  <psusi@cfl.rr.com>

	linux: also detect "in-use" dmraid and scsi-Nth (N>=16) partitions
	Prior to this change, Parted would fail to detect any in-use
	partition on a dmraid disk, as well as any in-use partition
	numbered 16 or greater on a regular scsi disk.
	This was because assumptions were being made about the device node
	major/minor numbers and how they relate to the partition number.
	These assumptions are invalid for dmraid devices, and for normal
	disks with >= 16 partitions.
	* libparted/arch/linux.c (_partition_get_part_dev): Remove function.
	(_partition_is_mounted): Rewrite to use _partition_is_mounted_by_path
	instead of _by_dev.

2011-05-10  Jim Meyering  <meyering@redhat.com>

	build: update gnulib submodule to latest

	tests: avoid subtle shell semantics bug
	This bug was causing some root-only tests to be mistakenly skipped.
	This bash command will always exit successfully,
	i.e., the "return 1" will never happen:
	  bash -c 'f(){ local f=$(false)||return 1; return 0; }; f'
	That's because the assignment always succeeds, and that success
	is what determines the return value, not the $(...) command.
	This is very counter-intuitive, sigh.
	The work-around is to separate the declaration and assignment, as in
	local f; f=$(...) || ...
	* tests/t-local.sh (new_sdX_): Do that.
	(gpt_corrupt_primary_table_): Likewise.

	tests: minor fix; add/adjust comments
	* tests/t1101-busy-partition.sh: Don't ignore failed comparison.
	Add a comment.

2011-04-21  Brian C. Lane  <bcl@redhat.com>

	s390/dasd: avoid buffer overrun upon API mismatch diagnostic
	* libparted/labels/fdasd.c (fdasd_check_api_version): The static
	buffer for the error string was too small.  Double its length.
	This resolves http://bugzilla.redhat.com/693852

2011-04-20  Brian C. Lane  <bcl@redhat.com>

	linux: fix typo in comment: /path%d => /part%d
	* libparted/arch/linux.c (_device_get_part_path): Fix typo in comment.

2011-04-18  Jim Meyering  <meyering@redhat.com>

	linux: don't free invalid pointer upon asprintf failure
	* libparted/arch/linux.c (_device_get_part_path): When asprintf
	fails, it leaves its first argument in an undefined state, and
	hence that pointer must not be freed.  However, here, in two
	places we could potentially free an invalid pointer.  Use
	zasprintf; then the pointer is either NULL or allocated,
	and hence always freeable.

	linux: clean up device naming code (no semantic change)
	* libparted/arch/linux.c (zasprintf): New function.
	(_device_get_part_path): Clean up:
	Use size_t, not "int" for strlen-returned value.
	Combine mostly duplicate snprintf uses.
	Use zasprintf instead of malloc+snprintf.

	don't reference before start of buffer for short device name
	* libparted/arch/linux.c (_device_get_part_path): Avoid invalid
	reference to memory before dev->path when its length is 4 or less.

2011-04-14  Jim Meyering  <meyering@redhat.com>

	maint: s/can not/cannot/ in a comment and documentation
	Without this, a new "make syntax-check" rule would fail.
	* libparted/filesys.c: s/can not/cannot/
	* doc/parted-pt_BR.texi (BIOSes and Firmware): Likewise.

	tests: remove now-unused Makefile rule
	* libparted/tests/Makefile.am (old-init.sh): Remove obsolete rule.

	tests: improve t1101-busy-partition.sh
	* tests/t1101-busy-partition.sh: Fail hard upon timeout while
	waiting for device to appear.

	tests: make the tests in libparted/tests work properly once again
	Since switching to init.sh, the root-only tests did not clean up.
	* libparted/tests/Makefile.am (prereq): Always create a symlink
	to tests/init.sh.
	* tests/init.cfg: Source $abs_top_srcdir/tests-relative names,
	not $srcdir-relative names.  This way, it works also when run
	from libparted/tests/.
	* tests/t-local.sh: Likewise.

	tests: avoid a race condition in the scsi_debug-using tests
	* tests/t-local.sh (new_sdX_): New function.
	(scsi_debug_setup_): Use new_sdX_ to find the just-created device name,
	rather relying on the list of file names in /sys/block/sd* changing.
	Sometimes the list would not change, which would lead to tests failing
	with I/O errors when run in parallel.  Thanks to Brian Lane for the
	tip that /sys/block/sd*/device/model contains "scsi_debug" if there
	is a device created by our "modprobe scsi_debug" command.

2011-03-24  Jim Meyering  <meyering@redhat.com>

	make parted "do what I say" with IEC start and end values like 5GiB
	In a command like this,
	  parted -s -- $dev mklabel gpt mkpart P-NAME 4MB -34s
	parted interprets the "4MB" as merely a suggestion for the starting
	sector number.  It uses half of the MB-units value as a "radius"
	about the sector containing byte 4,000,000, and it may choose some
	other more appropriate sector, based on partition table or alignment
	constraints within the range 3,500,000B..4,500,000B.
	Before, parted handled IEC units, i.e., KiB, MiB, GiB, etc.,
	with identically "helpful" sloppiness, of course honoring the
	power-of-two semantics.
	Now, however if you use IEC units, i.e., KiB, MiB, GiB, etc.,
	the "radius" is taken to be zero, so parted uses precisely
	whatever multiple of a power of two you've specified.
	Hence, adjusting the example above to use MiB, rather than "MB",
	  parted -s -- $dev mklabel gpt mkpart P-NAME 4MiB -34s
	With this change, that is equivalent to the following:
	  parted -s -- $dev mklabel gpt mkpart P-NAME 4194304B -34s
	I.e., it uses the sector containing precisely that byte, and
	does not perform any "extra" adjustment.
	* libparted/unit.c (is_power_of_2): New function.
	(ped_unit_parse_custom): Use it to avoid interpreting a large
	input string as "sloppy" (i.e. large radius) when it uses IEC
	binary notation like 34KiB, 3GiB and 65TiB.
	* tests/t0207-IEC-binary-notation.sh: New test.
	* tests/Makefile.am (TESTS): Add it.
	* doc/parted.texi (unit): Describe the new behavior.
	* NEWS (Changes in behavior): Mention it here, too.

2011-03-20  Jim Meyering  <meyering@redhat.com>

	maint: stop using .x-sc_* files to list syntax-check exemptions
	Instead, use the new mechanism with which you merely use a
	variable (derived from the rule name) defined in cfg.mk to an ERE
	matching the exempted file names.
	* gnulib: Update to latest, to get maint.mk that implements this.
	* .x-sc_GPL_version: Remove file.
	* .x-sc_prohibit_always-defined_macros: Likewise.
	* Makefile.am (EXTRA_DIST): Remove them from here, too.
	* cfg.mk: Define variables to exempt the same files.

2011-03-16  Jim Meyering  <meyering@redhat.com>

	maint: rename a variable
	* libparted/labels/gpt.c (_header_is_valid): Rename a variable,
	and switch to more readable range-checking logic.

	gpt: avoid division by zero
	* libparted/labels/gpt.c (_header_is_valid): Reject as invalid if
	FirstUsableLBA < 3.
	(gpt_get_max_supported_partition_count): Ensure that we don't divide
	by zero: verify that the GPT header is valid before dividing by its
	"size of partition entry".  Under normal circumstances, the on-disk
	PE size field is reasonable because we have just written it.  However,
	there are two ways it can end up zero: we lose the race when some other
	process pokes a 4-byte 0 into just the right location between when
	we write it and when we re-read the value we're about to divide by.
	Then there's the case that I encountered: using an old USB (8MB) key,
	mklabel gpt failed due to division by zero.  The device reported no
	failure when writing the initial header, yet when reading back that
	very same sector (also successful), parted got all 0 bytes.
	* NEWS (Bug fixes): Mention it.

	build: enable compilation warnings also for new nilfs2 subdir
	* libparted/fs/nilfs2/Makefile.am (AM_CFLAGS): Define.

	nilfs2: remove unused nilfs2_clobber function
	* libparted/fs/nilfs2/nilfs2.c (nilfs2_clobber): Remove unused
	function.
	(nilfs2_ops) [clobber]: Always set to NULL.

	maint: avoid shadowing warning
	* parted/parted.c (do_mkpart): Rename inner added_ok to add_ok.

	build: don't let parted_CFLAGS override our AM_CFLAGS setting
	* parted/Makefile.am (parted_CFLAGS): Remove unused (and interfering)
	definition.

	maint: avoid new compiler warnings
	* parted/parted.c (do_print): Remove now-unused "error" label.
	(_print_disk_info): Use one more "const" attribute, to avoid
	compiler warnings.

2011-03-16  Petr Uzel  <petr.uzel@suse.cz>

	tests: do not fail if some utilities are missing
	* tests/t1700-probe-fs.sh: Skip the test if mkfs.ext3 or tune2fs
	is missing or is not in $PATH.

	tests: test 'parted print' with empty disk
	* tests/t0101-print-empty.sh: New test.
	* tests/Makefile.am: Add it.

2011-03-16  Petr Uzel  <petr.uzel@suse.cz>

	parted: rework 'parted print' so that it works with empty disk
	'parted $dev print' on a device without a partition table used to fail
	with an 'unrecognised disk label' error, without printing the following:
	disk model, transport, size, sector size, BIOS geometry
	all of which are available, and do not dependent on the partition table.

	With this patch, parted prints all of this information (BIOS geometry
	only if 'unit cyl' is specified) and reports success even if the disk
	does not have a valid partition table.

	As a side efect, 'parted $dev print devices/all/list' now prints
	information about all the devices, even if $dev does not have a
	partition table.

	* parted/parted.c (_print_disk_info): New function.
	(do_print): Do not immediately fail if the partition table is not
	recognized, but print disk information and report success instead.
	* NEWS (Changes in behavior): Mention it.

2011-03-16  Petr Uzel  <petr.uzel@suse.cz>

	parted: factor out disk geometry printing into separate function
	* parted/parted.c (_print_disk_geometry): New function.
	(do_print): Use _print_disk_geometry.

2011-03-05  Brian C. Lane  <bcl@redhat.com>

	Remove PED_ASSERT action argument
	The action argument was a leftover from when the PED_ASSERT macro was
	last changed. This removes that argument from the macro and from all
	occurrences of it.

2011-03-05  Brian C. Lane  <bcl@redhat.com>

	Remove PED_ASSERT from dos geometry checking
	The CHS geometry values are calculated based on the existing partition
	information. The values can't always be calculated, and the partition
	may be corrupt so instead of throwing an assertion just return 0 and
	carry on.

	I left the logic for the PED_ASSERT checks the same so that it is clear
	that the logic has not changed, it just returns 0 now.

	* libparted/labels/dos.c (probe_partition_for_geom): remove PED_ASSERT

2011-03-05  Jim Meyering  <meyering@redhat.com>

	tests: add a minimal nilfs2 test
	* tests/t1700-probe-fs.sh: Adapt to also test nilfs2.

2011-03-03  Jim Meyering  <meyering@redhat.com>

	tests: rename a test script, before extending it to handle nilfs
	* tests/t1700-probe-fs.sh: Rename from ...
	* tests/t1700-ext-probe.sh: ...this.
	* tests/Makefile.am (TESTS): Rename it here, too.

2011-02-26  Jiro SEKIBA  <jir@unicus.jp>

	libparted: add nilfs2 module
	* libparted/fs/nilfs2/Makefile.am: New file.
	* libparted/fs/nilfs2/nilfs2.c: New file.
	(is_valid_nilfs_sb, nilfs2_probe, nilfs2_clobber): New functions.
	(ped_file_system_nilfs2_init, ped_file_system_nilfs2_done): Likewise.
	(nilfs2_ops, nilfs2_type): Define.
	* libparted/fs/Makefile.am (SUBDIRS): Add nilfs2.
	* configure.ac (AC_OUTPUT): Add the new Makefile.
	* libparted/libparted.c: Declare and use the _init and _done functions.

	Add a new fs module to provide following:
	- probe nilfs2 filesystem partition
	- clobber nilfs2 filesystem partition

	The is_valid_nilfs_sb function came from the grub nilfs2 module,
	which is written by me and assigned to FSF.

2011-02-25  Jim Meyering  <meyering@redhat.com>

	maint: two files lacked a newline at EOF: add one to each
	* include/Makefile.am: Add newline at end of file.
	* libparted/fs/jfs/Makefile.am: Likewise.

	tests: t3310-flags: check all gpt boolean flags, too
	* tests/t3310-flags.sh: Check gpt as well as msdos flags.
	Parametrize mkpart usage.
	Accommodate gpt-induced difference in parted's print output
	GPT partitions have a name, while msdos ones do not.
	This also fixes the "on_and_off" perl flag extraction regexp,
	which before was using $1 with no corresponding () group.

	tests: prepare t3310-flags to check gpt boolean flags, too
	* tests/t3310-flags.sh: Put a loop around the body of the test,
	and factor out the partition table name.

	tests: remove useless commands
	* tests/t3310-flags.sh: Remove useless exp-manipulating commands.

2011-02-25  Brian C. Lane  <bcl@redhat.com>

	gpt: add legacy_boot partition flag
	Add support for the Legacy BIOS Bootable flag in the GPT
	Attribute field.  This is used by software like syslinux to
	determine which partition to boot when in BIOS mode.

	See Page 105, Table 19 Bit 2 of the UEFI Spec 2.3 book.

	* doc/C/parted.8: Document legacy_boot.
	* doc/parted.texi: Document legacy_boot.
	* include/parted/disk.h: Add PED_PARTITION_LEGACY_BOOT flag.
	* libparted/disk.c (ped_partition_flag_get_name): Add legacy_boot flag.
	* libparted/labels/gpt.c (_parse_part_entry):
	(_partition_generate_part_entry, gpt_partition_new):
	(gpt_partition_set_flag, gpt_partition_get_flag):
	(gpt_partition_is_flag_available): Add legacy_boot flag support.

2011-02-25  Brian C. Lane  <bcl@redhat.com>

	gpt: add partition attribute bits: NoBlockIOProtocol, LegacyBIOSBootable
	Add NoBlockIOProtocol and LegacyBIOSBootable flags to the GPT partition
	Attributes entry.

2011-02-25  Jim Meyering  <meyering@redhat.com>

	doc: regenerate partprobe .pot and .po files
	* doc/C/po/partprobe.8.pot: Slight syntax update induced by newer tool.
	* doc/pt_BR/partprobe.8.pt_BR.po: Likewise.

	tests: move test_description= variable to a comment
	test-lib.sh-based tests required a test_description= definition.
	When testing switched to init.sh, which by convention uses a brief
	comment on line 2 instead, some instances were not converted.
	* libparted/tests/t1000-label.sh: Put test description on line 2.
	Remove now-unused test_description= definition.
	* libparted/tests/t2000-disk.sh: Likewise.
	* tests/t0220-gpt-msftres.sh: Likewise.

2011-02-23  Jim Meyering  <meyering@redhat.com>

	s390: avoid warnings
	* libparted/labels/vtoc.c (vtoc_read_volume_label): Remove decl
	of unused var.
	* libparted/labels/fdasd.c (fdasd_valid_vtoc_pointer): Return
	a value also when successful.
	* libparted/labels/dasd.c (dasd_alloc_metadata): Initialize "part"
	to NULL solely to avoid a spurious used-uninitialized warning.

2011-02-23  Stephen Powell  <zlinuxman@wowway.com>

	doc: add NEWS entries for s390 fix and improvements

2011-02-23  Stephen Powell  <zlinuxman@wowway.com>

	s390: make DIAG driver work for FBA DASD with block size > 512
	In order to make the DIAG driver work for FBA DASD with a block
	size greater than 512, I had to make a rather awkward patch to
	C function vtoc_read_volume_label in libparted/labels/vtoc.c.
	The "right" logic would be "If this is an FBA DASD device
	using the DIAG driver, and the effective block size used by the
	DIAG driver is greater than 512, then do it this way.  Else,
	do it the normal way."  (Note that when using the FBA driver,
	the effective block size is always 512, regardless of the CMS
	logical block size stored in the volume label.  The DIAG driver,
	on the other hand, honors the CMS logical block size.)

	The problem is that the information needed to make that decision
	has not been provided to the routine (via the parameter list).
	So what I ended up doing is assuming the normal way, then if
	I don't find a recognized volume label header (VOL1, LNX1,
	or CMS1, in EBCDIC), then I assumed that it must be the special
	case.  So in the special case I end up doing an unnecessary
	read.  It's a kludge, but it works.

2011-02-23  Jim Meyering  <meyering@redhat.com>

	tests: new script to generate 9-pte-GPT-tables

	cleanup: use verify, not PED_ASSERT to check struct sizes
	* libparted/labels/gpt.c: Use compile-time "verify" rather than
	run-time PED_ASSERT to ensure struct sizes are as expected.

2011-02-23  Stephen Powell  <zlinuxman@wowway.com>

	s390: improve/correct DASD support
	The long title would be "corrections to partition size and location
	calculations for type 1 partitions for s390 dasd".

	This could be treated as two separate fixes, one to make corrections
	for LDL formatted disks and one to add support for CMS formatted
	disks.  I see CMS formatted disks as a variant of LDL formatted
	disks, with the additional twist that CMS formatted disks can
	be reserved or recomped, which LDL formatted disks cannot be.
	This affects the size and location of the partition.

	With these patches, parted matches the behavior of the Linux kernel
	in recognizing partitions on CMS- and LDL-formatted disks, as documented
	in the Linux kernel source code in routine fs/partitions/ibm.c.
	Calculation of the metadata has also been changed so that parted will
	show no free space on such a disk.  In some cases there are now two
	non-contiguous metadata extents: one at the beginning of the disk and
	one at the end.

	As before, parted only supports CKD DASD using the ECKD driver.
	FBA DASD and CKD DASD using the DIAG driver are still not supported.

	In my regression testing I have discovered some problems in the area
	of recognizing file system options.  However, since I can duplicate
	these errors on a version of parted which does not contain my changes,
	I have concluded that my changes did not cause this and therefore
	this is an unrelated bug.

2011-02-22  Jim Meyering  <meyering@redhat.com>

	maint: update from gnulib
	* bootstrap: Update from gnulib.
	* tests/init.sh: Likewise.
	* gnulib: Update submodule to latest.

	maint: update copyright year ranges to include 2011
	Run "make update-copyright".

	maint: update copyright date in parted.texi
	* doc/parted.texi: Update copyright date.

2010-12-30  Jim Meyering  <meyering@redhat.com>

	maint: don't hard-code bug-reporting address
	* libparted/exception.c (default_handler): Use PACKAGE_BUGREPORT
	rather than hard-coding bug-parted@...
	* libparted/labels/gpt.c (_parse_header) [DISCOVER_ONLY]: Don't
	mention the bug-reporting address explicitly, since ped_exception_throw
	is about to do just that.

2010-12-16  Jim Meyering  <meyering@redhat.com>

	maint: correct typos in HACKING
	* HACKING: Don't reference grep everywhere.  I copied grep's
	HACKING and forgot to s/grep/parted/ (slightly different for
	the repository, since it's at git.debian.org, not Savannah).
	2010-11-25  Jim Meyering  <meyering@redhat.com>

2010-12-15  Brian C. Lane  <bcl@redhat.com>

	default to 1MiB alignment when possible
	Change the linux_get_optimum_alignment() function to prefer
	aligning partitions to PED_DEFAULT_ALIGNMENT (1MiB), if possible.
	This helps tools like anaconda better support 4k sector drives.

	* include/parted/parted.h (PED_DEFAULT_ALIGNMENT): Define.
	* libparted/arch/linux.c (linux_get_optimum_alignment): Adjust.
	See comments for details.
	* libparted/device.c (ped_device_get_optimum_alignment): Use
	PED_DEFAULT_ALIGNMENT rather than hard-coded 1048576.
	* tests/t9020-alignment.sh: Adjust expectations to match new behavior.
	See http://bugzilla.redhat.com/618255 for details.

2010-11-22  Jim Meyering  <meyering@redhat.com>

	tests: don't rely on "lockfile" program
	* tests/t-local.sh (scsi_debug_acquire_lock_): Use mkdir, rather
	that lockfile.  The latter is not always available.
	(scsi_debug_lock_dir_): Rename, now that it's a dir.
	(scsi_debug_cleanup_): Remove it with rm -rf.
	Fix typo in diag: s/rrmod/rmmod/

	tests: remove vestiges of test-lib.sh
	* tests/t-lib-helpers.sh (require_mdadm_): Remove vestiges of
	test-lib.sh (aka uses of the "say" and "test_done" functions).
	(require_xfs_): Likewise.

	tests: avoid spurious failure
	* tests/t6000-dm.sh: Sanitize directory name, to avoid spurious
	failure due to e.g., mount-related differences.

2010-11-22  Brian C. Lane  <bcl@redhat.com>

	linux: remove DASD restriction on _disk_sync_part_table
	* libparted/arch/linux.c: Include <assert.h>.
	(linux_disk_commit): Assert that _have_blkpg returns true
	and don't skip _disk_sync_part_table for DASD devices.
	Otherwise, when creating a partition on a DASD device,
	new /dev/*[12...] device files would not be created.
	Also, remove obsolete comment about DevFS.
	For details, see http://bugzilla.redhat.com/651478
	and http://thread.gmane.org/gmane.comp.gnu.parted.bugs/10191

2010-11-21  Jim Meyering  <meyering@redhat.com>

	build: update gnulib submodule to latest
	avoid new syntax-check failures
	* .x-sc_cross_check_PATH_usage_in_tests: New file.
	* .x-sc_bindtextdomain: New file.

2010-11-20  Jim Meyering  <meyering@redhat.com>

	tests: adjust cleanup_ handler to work with init.sh
	* tests/init.cfg (cleanup_, cleanup_fn_, cleanup_final_): Define.
	* tests/t-local.sh (cleanup_final_): Use this to ensure that we
	always release the lock and run rmmod.  Overriding the trap did not
	do the job.
	* libparted/tests/t2100-zerolen.sh: Use cleanup_fn_, not cleanup_.
	* tests/t1100-busy-label.sh: Likewise.
	* tests/t1101-busy-partition.sh: Likewise.
	* tests/t4100-dvh-partition-limits.sh: Likewise.
	* tests/t4100-msdos-partition-limits.sh: Likewise.
	* tests/t6000-dm.sh: Likewise.
	* tests/t8000-loop.sh: Likewise.

	tests: t3000-resize-fs.sh: don't expect fs-op warning
	* tests/t3000-resize-fs.sh: Don't expect fs-op warning.
	The testing framework now suppresses it.

	tests: t-lvm.sh (lvm_init_root_dir_): Fix it to use $test_dir_

	tests: remove t-lib.sh
	* tests/t-lib.sh: Remove file.  No longer used.
	* tests/Makefile.am (EXTRA_DIST): Remove t-lib.sh.
	* tests/t-lib-helpers.sh: Don't mention this file name.
	* tests/t-local.sh: Likewise.

2010-11-20  Jim Meyering  <meyering@redhat.com>

	tests: switch from t-lib.sh to init.sh
	* tests/init.cfg: Source t-local.sh.
	* tests/t-local.sh: Replace trap so that we always run
	scsi_debug_cleanup_, regardless of the cleanup_ function.
	Replace each snippet like this:
	-if test "$VERBOSE" = yes; then
	-  set -x
	-  parted --version
	-fi
	-
	-: ${srcdir=.}
	-. $srcdir/t-lib.sh
	+. "${srcdir=.}/init.sh"; path_prepend_ ../parted

	Use this command (LHS elided, because it was too long):
	  git grep -l 'srcdir/t-lib.sh'|xargs perl -p0i -e \
	    's!...!. "\${srcdir=.}/init.sh"; path_prepend_ ../parted\n!'

	* tests/t3310-flags.sh: Adjust manually, since the snippet
	didn't quite match.

2010-11-20  Jim Meyering  <meyering@redhat.com>

	tests: remove test-lib.sh
	* tests/test-lib.sh: Remove file.  No longer used.
	* tests/Makefile.am (EXTRA_DIST): Remove test-lib.sh.
	(old-init.sh): Remove rule and associated uses.
	* tests/lvm-utils.sh (init_root_dir_): Switch to test_dir_,
	since that is now the only variable that remains.

	tests: remove fail=0 initializations
	Now, this is done in init.sh.

	tests: libparted/tests: use init.sh, not test-lib.sh

	tests: make lvm-utils.sh usable also from init.sh-using tests
	* tests/lvm-utils.sh: Use fail_, not error for diagnostics.
	The former also works in init.sh-using scripts.
	(init_root_dir_): Use test_dir_ if $test_dir_rand_ is not set.

	tests: new function required for t2100-zerolen.sh
	* tests/t-lib-helpers.sh (device_mapper_required_): New function.

	tests: convert t5000-tags.sh

	tests: t-lib-helpers.sh: don't discard require_dvhtool_ stderr/stdout

	tests: dvhtool: use skip_, not skip

	tests: t4200-partprobe.sh: convert

	tests: t-lib-helpers.sh (require_dvhtool_): New function.

	tests: convert t4000-sun-raid-type.sh

	tests: move more functions to t-lib-helpers.sh

	tests: convert t7000 to init.sh

	tests: t-lib-helpers: copy emit_superuser_warning from test-lib.sh

	tests: t0000: convert to use init.sh

	tests: convert t1101-busy-partition.sh
	* tests/t1101-busy-partition.sh: Convert from t-lib.sh to init.sh.

	tests: convert t4100-msdos-partition-limits.sh
	* tests/t4100-msdos-partition-limits.sh: Likewise.

	tests: convert t4100-dvh-partition-limits.sh to use init.sh
	* tests/t4100-dvh-partition-limits.sh: Convert.

	tests: convert t4100-msdos-starting-sector.sh
	* tests/t4100-msdos-starting-sector.sh: Use init.sh.

	tests: convert t0220 to use init.sh
	* tests/t0220-gpt-msftres.sh: Convert to use init.sh.

	tests: extract t-lib.sh functions for use via init.sh
	Currently there are three test frameworks in use:
	  - test-lib.sh: old, don't use this framework any more;
	      I found it too hard to use and debug.
	  - t-lib.sh: newer, I had converted most tests to use this
	  - init.sh: newest: successor of t-lib.sh, the master copy
	      of which now resides in gnulib. All new tests should use
	      this framework.
	* tests/t-lib-helpers.sh: New file, extracted from t-lib.sh,
	so that init.cfg can source these functions, too.
	* tests/t-lib.sh: Source it.
	* tests/init.cfg: Source it from here, too.
	* tests/Makefile.am (EXTRA_DIST): Add t-lib-helpers.sh.

	tests: remove unused function: skip_if_

	tests: global subst: s/skip_test_/skip_/
	git grep -l skip_test_|xargs perl -pi -e 's/skip_test_/skip_/'

	maint: remove unused test function
	* tests/t-lib.sh (require_built_): Remove unused function.
	It also happened to use skip_, which we're about to make a function.

	tests: avoid race condition in t3000-resize
	Without the 1-second sleep, this root-only test would
	fail about 50% of the time for me.
	* tests/t3000-resize-fs.sh (device_sectors_required): Sleep
	one more second after ${dev}1 appears, so that subsequent
	commands are more predictable.
	Split a long line.

	tests: t2100-mkswap.sh: convert to init.sh
	* tests/t2100-mkswap: Likewise.

	tests: convert t1100 to use init.sh
	* tests/t1100-busy-label.sh: Convert to use init.sh
	* tests/init.cfg (require_erasable_): New function, mostly
	copied from test-lib.sh.

	tests: init.cfg: copy envvar setings from testlib.sh:
	Unset TERM and CDPATH; sanitize LC_ALL, TZ, LANG, and set
	PARTED_SUPPRESS_FILE_SYSTEM_MANIPULATION_WARNING=1.
	* tests/t1101-busy-partition.sh: Expect no output, now that we set
	PARTED_SUPPRESS_FILE_SYSTEM_MANIPULATION_WARNING=1.

	maint: update init.sh and bootstrap from gnulib
	* tests/init.sh: Update from gnulib.
	* bootstrap: Likewise.

	doc: also mention KiB, MiB, GiB and TiB suffixes
	* doc/parted.texi (unit): Also mention KiB, MiB, GiB and TiB.

2010-11-17  Colin Watson  <cjwatson@ubuntu.com>

	libparted: ignore zero-length devices
	* bootstrap.conf (gnulib_modules): Add xstrtoll.
	* configure.ac: Create DYNAMIC_LOADING output variable.
	* libparted/arch/linux.c (_device_get_length): Return the value of
	PARTED_TEST_DEVICE_LENGTH if set in the environment, strictly for use by
	the test suite.
	(init_generic): If geometry probing fails because the device was
	zero-length, return quietly rather than throwing an exception.  This has
	been observed in the wild with cciss devices, and it's difficult for
	partitioners to tell the difference between that and more serious
	errors.
	* libparted/tests/Makefile.am (TESTS): Add t2100-zerolen.sh.
	(check_PROGRAMS): Add zerolen.
	(zerolen_SOURCES): Add.
	(TESTS_ENVIRONMENT): Add DYNAMIC_LOADING and ENABLE_DEVICE_MAPPER.
	* libparted/tests/t2100-zerolen.sh: New file.
	* libparted/tests/zerolen.c: New file.
	* tests/test-lib.sh (wait_for_dev_to_appear_): New function, copied from
	tests/t-local.sh.
	* NEWS (Bug fixes): Mention it.

2010-11-09  Jim Meyering  <meyering@redhat.com>

	dos: fix a bug affecting very small devices (smaller than 1 cylinder)
	This bug was introduced in commit c79d91ec, "dos: accommodate very
	small devices (useful for testing)".
	* libparted/labels/dos.c (_primary_constraint): The bug was to
	skip setting start_geom for small devices.  That led to a used-
	uninitialized bug in the subsequent ped_constraint_new call.
	The fix is to relax the constraint to use a starting sector of "1",
	if necessary.  Report and diagnosis by Jean-Christian de Rivaz in
	http://thread.gmane.org/gmane.comp.gnu.parted.bugs/10178
	* NEWS (Bug fixes): Mention it.

2010-10-10  Jim Meyering  <meyering@redhat.com>

	maint: don't use obsolete gnulib modules
	* bootstrap.conf (gnulib_modules): Use calloc-gnu, malloc-gnu
	and realloc-gnu modules, rather than calloc, malloc and realloc.
	The shorter-named modules are now deprecated.

	maint: describe policy on copyright year number ranges
	* README: Mention coreutils' long-standing policy on use of M-N
	ranges in copyright year lists.  Requested by Richard Stallman.

	build: update gnulib submodule to latest, and update bootstrap
	* bootstrap: update from gnulib

2010-08-23  Petr Uzel  <petr.uzel@suse.cz>

	build: suggest libuuid from util-linux-ng package
	* configure.ac: libuuid was moved from e2fsprogs to
	util-linux-ng-2.16.  Because distributions now often
	build e2fsprogs without libuuid support, suggest installing
	libuuid from util-linux-ng if it is missing, not from e2fsprogs.

2010-08-20  Colin Watson  <cjwatson@ubuntu.com>

	libparted: remove limits on loop labels
	There's no reason to impose any particular limit on loop labels, since
	they just represent a single large partition.  Sector counts over 2^32
	are needed for large RAID arrays.  Change the limit to 2^64 since that's
	the upper limit imposed by libparted and it saves us implementing the
	limit functions separately.  This bug appears to have been introduced
	by commit 2dbc645c.

	* libparted/labels/pt-limit.gperf: Change limits on "loop" to 2^64.
	* tests/t9021-maxima.sh: Update for the new loop limit.
	* NEWS (Bug fixes): Mention it.

2010-08-18  Jim Meyering  <meyering@redhat.com>

	avoid non-srcdir "make check" failure
	* tests/Makefile.am (EXTRA_DIST): Add init.cfg.
	The failure was introduced by commit 6f7c0f12.

	build and tests: update bootstrap and init.sh from gnulib
	* tests/init.sh: Update from gnulib.
	* bootstrap: Likewise.

	build: update gnulib submodule to latest

2010-07-20  Hans de Goede  <hdegoede@redhat.com>

	linux: recognize scsi disks with a high major number (128-135)
	* libparted/arch/linux.c (SCSI_BLK_MAJOR): Recognize high major number.

2010-07-17  Jim Meyering  <meyering@redhat.com>

	libparted: avoid regression when processing a whole-disk FAT partition
	Without this change, we would improperly classify a whole-disk partition
	containing a FAT file system as a DOS partition table with no partitions.
	Introduced by commit d732a2b7 on 2008-05-28.
	* libparted/labels/dos.c (maybe_FAT): New function.
	(msdos_probe): Use it.
	Reported by ChenMin in
	http://thread.gmane.org/gmane.comp.gnu.parted.bugs/10115
	* NEWS (Bug fixes): Mention it.
	* tests/t3400-whole-disk-FAT-partition.sh: New file.  Test for the bug.
	* tests/Makefile.am (TESTS): Add it.

2010-07-17  Jim Meyering  <meyering@redhat.com>

	tests: use init.cfg; required for init.sh-using tests
	* tests/init.cfg: New file.
	(require_512_byte_sector_size_): Slightly different function
	than the one in test-lib.sh.

	* tests/init.cfg: New file.

2010-07-17  Jim Meyering  <meyering@redhat.com>

	build: update gnulib submodule to latest

	maint: remove trailing blank
	* tests/t1101-busy-partition.sh: Remove trailing blank.

2010-06-30  Otavio Salvador  <otavio@ossystems.com.br>

	tests: update resize-fs to use wait_for_dev_to_appear_
	* t3000-resize-fs.sh: rely on wait_for_dev_to_appear_ to wait for the
	device to be crated.

	tests: rely on require_scsi_debug_module_ to modprobe scsi_debug module
	* t2310-dos-extended-2-sector-min-offset.sh: remove explicit modprobe
	since it is done by require_scsi_debug_module_.
	* t3200-type-change.sh: likewise.
	* t9020-alignment.sh: likewise.
	* t9030-align-check.sh: likewise.
	* t9040-many-partitions.sh: likewise.

2010-06-30  Otavio Salvador  <otavio@ossystems.com.br>

	tests: add one: try to remove a busy partition
	This test tries to reproduce the issue reported in Debian bug #582818[1].

	 1. http://bugs.debian.org/582818

	Basically it does:

	 * create two primary partitions
	 * mount the second one
	 * remove the first (must work)
	 * try to remove the second (must fail)

	* tests/t1101-busy-partition.sh: new file.
	* tests/Makefile.am (TESTS): add the new test in check target.

2010-06-26  Otavio Salvador  <otavio@ossystems.com.br>

	tests: skip loop-clobber-infloop if mkswap cannot be found
	* tests/t0400-loop-clobber-infloop.sh: Skip the test is case of mkswap
	cannot be found.

2010-06-26  Jim Meyering  <meyering@redhat.com>

	build: update gnulib submodule to latest
	* bootstrap: Update from gnulib.
	* tests/init.sh: Likewise.

2010-06-26  Colin Watson  <cjwatson@ubuntu.com>

	sun: revert "implement disk flag operations"
	This reverts the libparted/labels/sun.c part of
	723ea23c5df68cbe67d1f518ef484f4c77f516fa.  Sun disk labels do
	not appear to be able to handle non-cylinder alignment
	(http://bugs.debian.org/579948).
	* libparted/labels/sun.c: Revert.

2010-06-26  Jim Meyering  <meyering@redhat.com>

	tests: adjust sun-partition-creating test to conform
	* tests/t4000-sun-raid-type.sh: Adjust partition size so the
	end falls on a cylinder boundary.

2010-05-28  Jim Meyering  <meyering@redhat.com>

	maint: update README-release
	* README-release: Update to match the template used for diffutils,
	coreutils, etc.

	maint: add gettext to list of bootstrapped-with tools in announcement
	* cfg.mk (bootstrap-tools): Add gettext to the list.

	post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 2.3
	* NEWS: Record release date.

	doc: regenerate two files using gettext-0.18
	* doc/pt_BR/partprobe.8.pt_BR.po: Regenerate with gettext-0.18.
	* doc/C/po/partprobe.8.pot: Likewise.

	build: require gettext-0.18 after all, because
	since gnulib is pulling in m4/gettext.m4 from 0.18, and there's
	a cross-check between that file and po/Makefile.in.in, it's easiest
	simply to require 0.18 of those who run build tools.  Otherwise,
	requiring 0.17, build-from-git would fail due to the mismatch:
	0.17 in Makefile.in.in and 0.18 in m4/gettext.m4.
	* configure.ac (AM_GNU_GETTEXT_VERSION): Require gettext 0.18.

	build: update gnulib submodule to latest

	maint: use the do-release-commit-and-tag module from gnulib
	* bootstrap.conf (gnulib_modules): Add do-release-commit-and-tag.

2010-05-28  Petr Uzel  <petr.uzel@suse.cz>

	doc: fix a typo
	* doc/parted.texi: s/onstraints/constraints/

	parted: do_align_check returns always 1 in interactive mode
	* parted/parted.c (do_align_check): Always return 1 in interactive mode.

2010-05-28  Jim Meyering  <meyering@redhat.com>

	build: really use gettext-0.17
	* configure.ac: Correct previous change to use 0.17, not 0.18,
	since gettext-0.18 is new enough that it makes building from git
	a little too inconvenient.  Spotted by Petr Uzel.

2010-05-26  Petr Uzel  <petr.uzel@suse.cz>

	parted: make align-check work in interactive mode
	* parted/parted.c (do_align_check): rework the function so that
	it reports partition alignment in interactive mode as described in
	documentation.

	parted: initialize align_type to default value
	* parted/parted.c (do_align_check): Initialize align_type to
	default alignment; this prevents reading of uninitialized memory
	later in command_line_get_align_type()

	parted: plug memory leak
	* parted/parted.c (_done_messages): Free unit_msg.

2010-05-26  Jim Meyering  <meyering@redhat.com>

	tests: avoid spurious failure of the root-only many-partitions test
	* tests/t9040-many-partitions.sh: When creating a scsi_debug
	device, honor the block size suggested by the PARTED_SECTOR_SIZE
	environment variable, and thus required in expected output.

	build: update gnulib submodule to latest

	maint: remove useless definitions
	* libparted/fs/xfs/platform_defs.h [__sparc__] (O_DIRECT):
	Remove now-unneeded definition.
	* parted/table.c (wchar_t): Remove definition.
	* parted/strlist.c (wchar_t): Likewise.
	* .x-sc_prohibit_always-defined_macros: New file.
	Exempt two files from this syntax-check rule.
	* Makefile.am (EXTRA_DIST): Add it here.

	maint: update helper scripts
	* tests/help-version: Update from coreutils.
	* bootstrap: Update from gnulib.
	* tests/init.sh: Likewise.

	build: use gettext-0.17
	* configure.ac: Use gettext-0.17.
	* bootstrap.conf (gnulib_modules): Use gettext-h, not gettext.
	since the latter drags in a depedency on gettext 0.18.

2010-05-25  Jim Meyering  <meyering@redhat.com>

	fix typo in comment

2010-05-10  Jim Meyering  <meyering@redhat.com>

	libparted: fail (don't just warn) upon failure to inform kernel of...
	partition change(s).
	* libparted/arch/linux.c (_disk_sync_part_table): Throw an error, not
	merely a warning.  When this fails, it indicates that the kernel has
	not been informed, and that must translate to an error, since doing
	otherwise would violate the contract of ped_disk_commit_to_os.
	Suggested by Hans De Goede.

2010-05-06  Jim Meyering  <meyering@redhat.com>

	tests: make the new many-partitions test fail if it takes "too long"
	* tests/t9040-many-partitions.sh: Fail if creating 60 partitions
	takes more than a minute.

	maint: use latest bootstrap script from gnulib
	* bootstrap: Sync from gnulib.

2010-05-06  Hans de Goede  <hdegoede@redhat.com>

	gpt: recognize microsoft recovery GUID
	Microsoft advices creating recovery partitions with a GUID of
	de94bba4-06d1-4d40-a16a-bfd50179d6ac, see:
	http://technet.microsoft.com/en-us/library/dd744301%28WS.10%29.aspx

	This patch makes parted recognize this guid (using the DIAG flag).
	* libparted/labels/gpt.c (PARTITION_MSFT_RECOVERY, GPTPartitionData,
	_parse_part_entry, gpt_partition_new, gpt_partition_set_system,
	gpt_partition_set_flag, gpt_partition_get_flag,
	gpt_partition_is_flag_available): Support microsoft recovery GUID.
	* NEWS (New features): Add it.

2010-05-06  Hans de Goede  <hdegoede@redhat.com>

	msdos: recognize id 27 as a diagnostics (recovery) partition type
	msdos partitiontable partition id 27 is recommended by microsoft for
	use as id for recovery partitions, see:
	http://technet.microsoft.com/en-us/library/dd744364%28WS.10%29.aspx
	http://bugzilla.redhat.com/show_bug.cgi?id=534066

	* libparted/labels/dos.c (PARTITION_MSFT_RECOVERY): Define.
	(raw_part_parse): Recognize id 27
	(msdos_partition_set_system): Recognize id 27

2010-05-06  Jim Meyering  <meyering@redhat.com>

	tests: add one: create 60 partitions on a scsi device
	* tests/t9040-many-partitions.sh: New test.
	* tests/Makefile.am (TESTS): Add it.
	(TESTS_ENVIRONMENT): Export AWK to test scripts.
	Inspired by the report of a many-partition test
	taking far longer on RHEL5 than on RHEL4 in
	http://bugzilla.redhat.com/589117

2010-05-05  Jim Meyering  <meyering@redhat.com>

	doc: update NEWS
	* NEWS (Bug fixes): Mention the ext2 2TiB FS-creation bug.

	build: update gnulib submodule to latest

2010-05-05  Martin Poole  <mpoole@redhat.com>

	ext2: don't overflow when creating a partition of size 2TiB or larger
	Without this patch, mkpartfs would succeed in creating an ext2
	partition, but the resulting partition would fail a mkfs.ext2 -f check.
	* libparted/fs/ext2/parted_io.c (do_read): Avoid overflow 32-bit
	sector count overflow for a partition of size 2TiB or larger.
	(do_write): Likewise.
	See http://bugzilla.redhat.com/584057#c16 a reproducer.

2010-04-30  Hans de Goede  <hdegoede@redhat.com>

	_device_unregister: check for unregistering the same device twice
	_device_unregister() can get called 2 times for the same device if
	a libparted user explictly removes the device from the cache using
	ped_device_cache_remove(), it gets called and it then becomes the
	user's responsibility to free the PedDevice by calling
	ped_device_destroy(). ped_device_destroy() will then call
	_device_unregister() a second time with the same device, so if the
	device is not found in the list, do nothing.

	* libparted/device.c(_device_unregister): Check for unregistering
	the same device twice.
	Reported by Jan Stodola in <http://bugzilla.redhat.com/568346>.

2010-04-30  Jim Meyering  <meyering@redhat.com>

	tests: avoid root-only/XFS limit test failure on 32-bit system
	* tests/t4100-msdos-partition-limits.sh: Due to an inherent XFS
	limitation on 32-bit systems, this test would fail a set-up
	file creation step for simulated sector sizes of 4K and up.
	Skip this test in those cases.
	Upon dd failure, propagate its diagnostic to output, to make this
	sort of problem easier to diagnose.
	* tests/t4100-dvh-partition-limits.sh: Likewise.

2010-04-30  Jim Meyering  <meyering@redhat.com>

	libparted: avoid race in informing the kernel of partition table changes
	When sync'ing a partition table change using the latest
	code, sometimes we'd get an unwarranted failure like this:

	    Warning: Partition(s) 1 on /dev/sdd have been written, but we
	    have been unable to inform the kernel of the change, probably because
	    it/they are in use.  As a result, the old partition(s) will remain in
	    use.  You should reboot now before making further changes.

	To be precise, when running the partition-resizing root-only test
	in a loop:

	    for i in $(seq 240); do make -C tests check VERBOSE=yes \
	    TESTS=t3000-resize-fs.sh >& log.$i && printf . || echo $i $?; done

	I would typically see about 50% of them fail on a Fedora 13 system.
	It was obvious that this was due to a race condition when I found that
	modifying that tests' parted...resize invocation to go via strace changed
	the timing enough to make the test pass every time.

	The fix is to retry the partition-removal step upon any EBUSY failure,
	currently for up to 1 second (retrying up to 100 times, sleeping 10ms
	after each failure).

	* libparted/arch/linux.c (_disk_sync_part_table): Allocate "ok" using
	calloc, now that its initial values matter.
	Retry each removal upon EBUSY-failure.
	* bootstrap.conf (gnulib_modules): Use gnulib's usleep module.

2010-04-30  Jim Meyering  <meyering@redhat.com>

	libparted: variable renaming, minor "goto" reorg
	* libparted/arch/linux.c (_disk_sync_part_table): Rename local array:
	s/rets/ok/, for readability.
	Use only a single label, "cleanup:", rather than two: free_rets
	and free_errnums.

	libparted: remove now-worse-than-useless _kernel_reread_part_table
	Now that we're using BLKPG properly, there's no point in using the
	less-functional BLKRRPART ioctl to make the kernel reread the partition
	table.
	More importantly, this function would fail when any partition is in
	use, in spite of our having carefully vetted them via BLKPG ioctls.
	* libparted/arch/linux.c (_kernel_reread_part_table): Remove function.
	(linux_disk_commit): Don't call it.

2010-04-29  Jim Meyering  <meyering@redhat.com>

	tests: correct a root-only test
	* tests/t2310-dos-extended-2-sector-min-offset.sh: Don't hard-code
	"/dev/sdd5" in expected output.

	maint: avoid code duplication
	* libparted/labels/dos.c (clear_flags): New function.
	Factored (5 times) out of ...
	(msdos_partition_set_flag): ...here.  Use the new function.

2010-04-29  Hans de Goede  <hdegoede@redhat.com>

	dos: add a partition flag for diagnostics / recovery partitions
	msdos partition tables can contain diagnostics partitions (often used
	nowadays as system recovery partitions).  For some users of libparted
	(i.e., anaconda) it is useful to know if a dos partition is a regular
	partition or a diagnostic partition.  For example, see
	<http://bugzilla.redhat.com/534066>.

	* include/parted/disk.h(_PedPartitionFlag): Add PED_PARTITION_DIAG
	* libparted/disk.c(ped_partition_flag_get_name): Add PED_PARTITION_DIAG
	* libparted/labels/dos.c: Add support for PED_PARTITION_DIAG flag
	* doc/parted.texi (set): Document it.

2010-04-28  Jim Meyering  <meyering@redhat.com>

	tests: distribute new file, init.sh
	* tests/Makefile.am (EXTRA_DIST): Add init.sh.

	tests: add help-version test (from coreutils)
	* tests/help-version: New file
	* tests/Makefile.am (TESTS_ENVIRONMENT): Pass built_programs and VERSION
	to test scripts -- both are required by help-version.
	(TESTS): Add help-version.

	ui: make --help tell where to report bugs
	* parted/ui.c (help_msg): Tell where to report bugs.

	tests: use gnulib's init.sh
	* tests/init.sh: New file, from gnulib.

	tests: rename generated init.sh to old-init.sh
	* tests/Makefile.am (old-init.sh): Rename from init.sh.
	* libparted/tests/Makefile.am: Likewise.
	* tests/test-lib.sh: Rename sole use.
	* .gitignore: Rename here, too.

	build: update gnulib submodule to latest

	tests: improved portability
	* tests/test-lib.sh: Don't use test's -a option.

	maint: remove empty lines at end of file
	This lets one more "syntax-check" test pass.
	Run this command:
	  git ls-files|grep -v gnulib|xargs perl -pi -0777 -e 's/\n\n+$/\n/'

	maint: pass newer "make syntax-check" tests from gnulib
	* cfg.mk (local-checks-to-skip): Add these, to pass "make syntax-check"
	sc_error_message_uppercase, sc_error_message_period.
	* libparted/fs/ext2/ext2.h: Remove "#if HAVE_INTTYPES_H" guard.

	tests: test all boolean flags
	* tests/t3310-flags.sh: New test, suggested by Hans De Goede.
	* tests/Makefile.am (TESTS): Add it.

2010-04-27  Jim Meyering  <meyering@redhat.com>

	doc: use a valid http:.../AUTHORS URL
	* debug/clearfat/clearfat.c (AUTHORS): Point to the git repo.
	* parted/parted.c (AUTHORS): Likewise.
	* partprobe/partprobe.c (AUTHORS): Likewise.

	* parted/parted.c: Include "version.h".
	(_version): Use Version, not VERSION.

2010-04-27  Jim Meyering  <meyering@redhat.com>

	ui: get version number from a separately-compiled file
	* parted/Makefile.am (version.c, version.h): Generate.
	(parted_LDADD): Add libver.a.
	(noinst_LIBRARIES, nodist_libver_a_SOURCES): Define.
	(BUILT_SOURCES): Initialize and append.
	(MAINTAINERCLEANFILES): Update.
	* parted/parted.c: Include "version.h".
	(_version): Use the new global variable, Version, not VERSION.

2010-04-23  Jim Meyering  <meyering@redhat.com>

	libparted: _disk_sync_part_table: allow interactive ignore
	* libparted/arch/linux.c (_disk_sync_part_table): Change diagnostic
	so that it makes it clear what failed.  Let an interactive "ignore"
	cause the function to succeed.

	tests: remove partition explicitly before mklabel, to avoid new failure
	* tests/t3000-resize-fs.sh: Before, mklabel was sufficient to clear
	the partition table in preparation for the next iteration in this test.
	However, with recent BLKRRPART/BLKPG changes that "mklabel" would evoke
	a warning.  Remove the sole partition to avoid that.

	libparted: linux_disk_commit: don't ignore _disk_sync_part_table failure
	* libparted/arch/linux.c (linux_disk_commit):
	When calling _disk_sync_part_table, always return its result.

	libparted: _disk_sync_part_table: always return 0 upon failure
	* libparted/arch/linux.c (_disk_sync_part_table):
	Return 0 (not 1) upon failure.

2010-04-23  Colin Watson  <cjwatson@ubuntu.com>

	dos: always allow at least two sectors for extended boot record
	Unless specifically told otherwise, the Linux kernel considers extended
	boot records to be two sectors long, in order to "leave room for LILO".
	When using anything other than cylinder alignment, libparted was only
	allowing one sector in the minimum extended partition geometry, which in
	some situations (e.g. following Phillip Susi's patch to reintroduce
	BLKPG) could confuse the kernel into thinking that the EBR and the first
	logical partition overlapped.

	* libparted/labels/dos.c (_get_min_extended_part_geom): Allow at least
	two sectors for the extended boot record.

2010-04-23  Jim Meyering  <meyering@redhat.com>

	tests: test for new 2-sector minimum ext-logical-separation
	* tests/t2310-dos-extended-2-sector-min-offset.sh: New file.
	* tests/Makefile.am (TESTS): Add it.

	dos: accommodate very small devices (useful for testing)
	* libparted/labels/dos.c (_primary_constraint): Don't pass a negative
	"device_length" to ped_geometry_init when the underlying device
	has fewer sectors than a "cylinder".

	libparted: allocate storage for diagnostic only when needed
	* libparted/arch/linux.c (_disk_sync_part_table): Rename local:
	s/parts/bad_part_list/
	Allocate space for it only if needed.
	Use malloc rather than ped_malloc.
	Move decl of FD down to first use.

	libparted: adjust code formatting

	libparted: reword a diagnostic

2010-04-23  Phillip Susi  <psusi@cfl.rr.com>

	libparted: improve BLKPG error checking
	This patch cleans up the BLKPG code that the previous patch put back
	to perform proper error checking and in the event that some partitions
	are in use, they can not be modified in the running kernel using BLKPG.
	Warn the user that this is the case and advise them to reboot, just like
	we do when BLKRRPART fails for the same reason, unless the partition in
	question is unchanged.

	libparted: reenable use of BLKPG ioctls
	This patch effectively reverses commit 1d8f9bec which removed the code
	using the new BLKPG ioctls instead of the old BLKRRPART ioctl to update
	the in-kernel partition table.  The reason for this is because BLKRRPART
	fails if any partition on the disk is in use, but the BLKPG ioctls allow
	you to manipulate the other partitions on the disk without requiring a
	reboot.  Also BLKRRPART requires that the kernel understand the
	partition table on the disk, which may not always be the case.

2010-04-23  Hans de Goede  <hdegoede@redhat.com>

	linux: detect dm_task_run failure
	We were checking for a return value of < 0 for dm_task_run errors, but
	dm_task_run returns 0 on error (and 1 on success). Thanks to Joe Jin
	for spotting this, see Red Hat bug 582907.

	* libparted/arch/linux.c(_dm_remove_map_name, _dm_is_part,
	_dm_remove_parts, _dm_add_partition): dm_task_run returns 0 on error.

2010-04-21  Jim Meyering  <meyering@redhat.com>

	tests: test for palo and prep interaction
	* tests/t3300-palo-prep.sh: New file.
	* tests/Makefile.am (TESTS): Add it.

2010-04-21  Hans de Goede  <hdegoede@redhat.com>

	dos: fix prep / palo flag handling
	Setting the prep flag was not clearing the palo flag and vice versa
	* libparted/labels/dos.c (msdos_partition_set_flag): Fix prep / palo
	flag handling.

2010-04-21  Jim Meyering  <meyering@redhat.com>

	tests: remove unnecessary (duplicate) local var assignment
	* tests/t9021-maxima.sh: Remove duplicate ss=$sector_size_.

2010-04-21  Colin Watson  <cjwatson@ubuntu.com>

	maint: make PED_ASSERT and PED_DEBUG if-safe
	Constructions such as:

	  if (foo)
	    PED_DEBUG (0, "foo");
	  else
	    PED_DEBUG (0, "not foo");

	did not compile reliably, depending on the configuration.  Make this
	work.

	* include/parted/debug.h [DEBUG && __GNUC__ && !__JSFTRACE__]
	(PED_DEBUG): Remove trailing semicolon.
	[!DEBUG] (PED_ASSERT): Use do-while rather than while.
	[!DEBUG] (PED_DEBUG): Likewise.

2010-04-17  Jim Meyering  <meyering@redhat.com>

	doc: add HACKING
	* HACKING: New file.  Copied from coreutils, with s/coreutils/parted/
	and a few minor edits.

2010-04-16  Petr Uzel  <petr.uzel@suse.cz>

	.gitignore: ignore index files generated by ctags and cscope

2010-04-16  Petr Uzel  <petr.uzel@suse.cz>

	libparted: add support for Linux software RAID arrays (mdraid)
	Recognize MD devices, so "parted -s /dev/md0 print" now prints
	"Model: Linux Software RAID Array (md)" instead of
	"Model: Unknown (unknown)".

	* include/parted/device.h (PedDeviceType): Add PED_DEVICE_MD.
	* libparted/arch/linux.c (MD_MAJOR): New define.
	* libparted/arch/linux.c (_device_probe_type): Recognize MD array.
	* libparted/arch/linux.c (linux_new): Handle MD array.
	* parted/parted.c(do_print): Add "md" to the list of available
	transports.
	* NEWS (New features): Mention it.

2010-04-13  Jim Meyering  <meyering@redhat.com>

	tests: propagate recent improvements to copied-from code
	* tests/t1700-ext-probe.sh: Fix typo s/2>1/2>&1/ and use
	a tighter regexp also in the preceding loop.
	Noted by Colin Watson.

2010-04-13  Colin Watson  <cjwatson@ubuntu.com>

	maint: constify ped_device_get_constraint interface
	* include/parted/device.h (ped_device_get_constraint): Constify "dev"
	parameter.
	* libparted/device.c (ped_device_get_constraint): Likewise.

2010-04-13  Colin Watson  <cjwatson@ubuntu.com>

	libparted: uninit_bg and flex_bg features should indicate ext4
	According to tune2fs(8), the uninit_bg and flex_bg features are only
	supported by ext4, so libparted should treat their presence as
	indicating ext4.  Reported by C de-Avillez in
	https://bugs.launchpad.net/ubuntu/+source/parted/+bug/561599.

	* libparted/fs/ext2/ext2_fs.h: Define EXT4_FEATURE_RO_COMPAT_GDT_CSUM
	and EXT4_FEATURE_INCOMPAT_FLEX_BG.
	* libparted/fs/ext2/interface.c (_ext2_generic_probe): Test for
	EXT4_FEATURE_RO_COMPAT_GDT_CSUM and EXT4_FEATURE_INCOMPAT_FLEX_BG when
	probing for ext4.
	* tests/t1700-ext-probe.sh: Test for this.
	* NEWS (Bug fixes): Mention this.

2010-04-09  Colin Watson  <cjwatson@ubuntu.com>

	libparted: fix diagnostics about exceeding partition limits
	* libparted/labels/pt-tools.c (ptt_partition_max_start_len): Use the
	correct value in the diagnostics that print the upper bound on
	partition size and largest starting sector number.  Before, each
	would use UINT32_MAX.  Now each prints the partition-table-specific
	limit.

2010-04-06  Hans de Goede  <hdegoede@redhat.com>

	libparted: add test for /dev/mapper symlink issue
	Sometimes, libparted operates on device mapper files with a path of
	/dev/mapper/foo.  With newer lvm versions /dev/mapper/foo is a symlink
	to /dev/dm-#. However some storage administration programs (anaconda,
	for example) may do the following:
	1) Create a ped_device for /dev/mapper/foo
	2) ped_get_device resolves the symlink to /dev/dm-#, and the path
	   in the PedDevice struct points to /dev/dm-#
	3) The program does some things to lvm, causing the symlink to
	   point to a different /dev/dm-# node
	4) The program does something with the PedDevice, which results
	   in an operation on the wrong device

	Newer libparted versions do not suffer from this problem, as they
	do not canonicalize device names under /dev/mapper. This test checks
	for this bug.

	* libparted/tests/symlink.c: New test which tests for this issue.
	* libparted/tests/t3000-symlink.sh: New file.
	* libparted/tests/Makefile.am: Include the new files.  Run the new test.

2010-04-06  Hans de Goede  <hdegoede@redhat.com>

	libparted: don't canonicalize /dev/mapper paths
	Besides fixing the issue displayed by libparted/tests/symlink.c,
	this has the added advantage that the output of parted p on one of these
	devices now says:
	"Disk /dev/mapper/BigVol2-lv_iscsi_disk2: 34.4GB"

	Which is a lot more user friendly then the output before this patch:
	"Disk /dev/dm-6: 34.4GB"

	* libparted/device.c (ped_device_get): Don't canonicalize names
	that start with "/dev/mapper/".
	* NEWS (Bug fixes): Mention it.
	Thanks to Ales Kozumplik for the analysis.
	Details in <http://bugzilla.redhat.com/577824>.

2010-03-30  Colin Watson  <cjwatson@ubuntu.com>

	doc: add @dircategory to Info documentation
	The Texinfo documentation says that Info files should use @dircategory,
	and suggests consulting the Free Software Directory to select a category
	name.  The directory places Parted under "System administration".

	* doc/parted.texi: Add `@dircategory System administration'.

2010-03-30  Jim Meyering  <meyering@redhat.com>

	build: update gnulib submodule to latest

	tests: disable new texinfo-acronym syntax-check from gnulib
	* cfg.mk (local-checks-to-skip): Add new sc_texinfo_acronym, to skip it.

	maint: avoid using test's -o and -a operators: they are not portable
	* tests/lvm-utils.sh: Don't use test ... -o.
	* configure.ac: Don't use test ... -a.

	maint: remove unneeded #include
	* libparted/disk.c: Don't include "intprops.h".  It was unused.

	build: prepare for gnulib's updated lib-ignore
	* parted/Makefile.am (parted_LDFLAGS): Now that we're using
	gnulib's newer lib-ignore, add $(IGNORE_UNUSED_LIBRARIES_CFLAGS).

2010-03-30  Colin Watson  <cjwatson@ubuntu.com>

	tests: distribute a few more tests and documentation files
	* debug/test/Makefile.am (noinst_SCRIPTS): Add test_fs_hfs and
	test_fs_hfsplus.
	* libparted/fs/hfs/Makefile.am (EXTRA_DIST): Add DOC and HISTORY.
	* tests/Makefile.am (TESTS): Add t3200-type-change.sh.

2010-03-16  Jim Meyering  <meyering@redhat.com>

	build: avoid warning from bootstrap about obsolete strdup module
	* bootstrap.conf (gnulib_modules): Use the strdup-posix module,
	rather than the "strdup" one.

2010-03-11  Jim Meyering  <meyering@redhat.com>

	tests: reenable a "bsd" partition table test
	* libparted/tests/common.c (_implemented_disk_label): Remove "bsd" from
	the list of not-implemented-yet partition table types, since it appears
	to pass the tests.

	libparted: remove "HIGHLY EXPERIMENTAL" warning for >512B-sector devices
	* libparted/arch/linux.c (_device_set_sector_size): Remove the
	"HIGHLY EXPERIMENTAL" warning, now that support for >512-byte sectors
	seems to be usable.  Suggested by Colin Watson.
	* NEWS (Changes in behavior): Note this

2010-03-02  David Cantrell  <dcantrell@redhat.com>

	libparted: msdos_partition_is_flag_available: fix hidden on extended
	Since the hidden flag cannot be set on extended partitions,
	msdos_partition_is_flag_available() should return 0 for hidden on
	extended partitions. Also change msdos_partition_get_flag()
	to always return 0 for hidden on extended partitions.
	* libparted/labels/dos.c (msdos_partition_is_flag_available):
	Return 0 for hidden on extended partitions.
	* libparted/labels/dos.c (msdos_partition_get_flag):
	Always return 0 for hidden on extended partitions.
	* NEWS (Bug fixes): Mention it.
	Reported by Flóki Pálsson in http://bugzilla.redhat.com/567118
	Patch forwarded by Hans De Goede.

2010-03-02  Petr Uzel  <petr.uzel@suse.cz>

	tests: skip tests that require mkfs.hfs, when it is unavailable
	t3000-resize-fs.sh would fails if mkfs.hfs is not installed.
	* tests/t-lib.sh (require_hfs_): New function.
	* tests/t3000-resize-fs.sh: Use require_hfs_.

2010-02-28  Jim Meyering  <meyering@redhat.com>

	tests: convert more tests to the newer infrastructure
	* tests/t1700-ext-probe.sh: Convert from test-lib.sh to t-lib.sh.
	* tests/t2200-dos-label-recog.sh: Likewise.
	* tests/t2300-dos-label-extended-bootcode.sh: Likewise.

2010-02-26  Colin Watson  <cjwatson@ubuntu.com>

	libparted: don't export linux_get_*_alignment functions
	These functions are only used in libparted/arch/linux.c or via
	linux_dev_ops, so do not export them.

	* libparted/arch/linux.c (linux_get_minimum_alignment): Declare static.
	(linux_get_optimum_alignment): Likewise.

2010-02-26  Petr Uzel  <petr.uzel@suse.cz>

	Add support for ATA over Ethernet (AoE) devices
	Recognize AoE Devices, so "parted -s /dev/etherd/eX.Y" now
	prints "Model: ATA over Ethernet Device (aoe)" instead of
	"Model: Unknown (unknown)".

	* include/parted/device.h(PedDeviceType): Add PED_DEVICE_AOE.
	* libparted/arch/linux.c(AOE_MAJOR): New define.
	* libparted/arch/linux.c(_device_probe_type): Recognize AoE devices.
	* libparted/arch/linux.c(linux_new): Handle AoE devices.
	* parted/parted.c(do_print): Add "aoe" to the list of available
	transports.
	* NEWS (New features): Mention it.

2010-02-26  Jim Meyering  <meyering@redhat.com>

	post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 2.2
	* NEWS: Record release date.

2010-02-26  Curtis  Gedak  <gedakc@gmail.com>

	dos: set HFS/HFS+ partition identifier to proper value
	The correct value for an "hfs" partition identifier is 0xAF.
	Previously the partition identifier was incorrectly set to 0x83.
	* libparted/labels/dos.c (PARTITION_HFS): Define.
	(msdos_partition_set_system): Use it.

2010-02-26  Jim Meyering  <meyering@redhat.com>

	tests: exercise today's HFS partition type fix
	* tests/t2400-dos-hfs-partition-type.sh: New script.
	* tests/Makefile.am: Add it.
	* NEWS (Bug fixes): Mention it.

	tests: gpt-pmbr: don't ignore stdout comparison result
	* tests/t0202-gpt-pmbr.sh: Fail if we get unexpected output.

2010-02-25  Jim Meyering  <meyering@redhat.com>

	build: update gnulib submodule to latest
	* bootstrap: Copy from gnulib.

	tests: convert t4001 to use the new framework
	* tests/t4001-sun-vtoc.sh: Convert.
	* tests/Makefile.am (TESTS): Add it to the list.

2010-02-25  Karel Zak  <kzak@redhat.com>

	sun: initialize basic partition table fields
	libparted completely ignores basic fields (version, nparts and sanity)
	in the sun VTOC, then for example fdisk prints warnings for such
	partition table:

		# fdisk -lu /dev/sdb
		Detected sun disklabel with wrong version [0x00000000].
		Detected sun disklabel with wrong sanity [0x00000000].
		Detected sun disklabel with wrong num_partitions [0].

	It seems that the current libparted sun support follows old Linux
	kernel code, but the code was changed 3 years ago (see kernel commit
	3961bae0ac030a70ae2e0578270203889021f1a1).

	Note that the number of partitions (nparts) is optional for Linux
	kernel, but fdisk(8) strictly requires SUN_DISK_MAXPARTITIONS (=8)
	there. This patch sets nparts to SUN_DISK_MAXPARTITIONS rather then
	use a real number of partitions.

	* NEWS (Bug fixes): Mention it.
	* libparted/labels/sun.c: Update from kernel.
	* tests/t4001-sun-vtoc.sh: New file.  Test for this.

2010-02-25  Jim Meyering  <meyering@redhat.com>

	tests: wrap the dup-clobber test in a script, ...
	so that its artifacts are created in the usual temporary subdir
	* tests/Makefile.am (TESTS): Remove dup-clobber, and instead...
	Add t0500-dup-clobber.sh.
	* tests/t0500-dup-clobber.sh: New script.

2010-02-23  Jim Meyering  <meyering@redhat.com>

	build: update gnulib submodule to latest

	tests: test for the ped_disk_duplicate needs_clobber fix
	* tests/dup-clobber.c: New file.
	Exercise the fix in commit jabb411b, "libparted: copy the
	needs_clobber value in ped_disk_duplicate()".
	* tests/Makefile.am (TESTS, check_PROGRAMS): Add dup-clobber.

2010-02-22  Hans de Goede  <hdegoede@redhat.com>

	libparted: copy the needs_clobber value in ped_disk_duplicate()
	Most duplicate disk_ops use ped_disk_new_fresh, which sets needs_clobber
	to 1. This would lead to clobbering the disk when committing a duplicate
	disk even when the original disk was not made with ped_disk_new_fresh.
	* libparted/disk.c (ped_disk_duplicate): Copy the needs_clobber member.
	* NEWS (Bug fixes): Describe it.

2010-02-22  Curtis Gedak  <gedakc@gmail.com>

	linux: add wait time and retries to kernel partition reread
	Occasionally when using parted with newer GNU/Linux kernels (2.6.31)
	and udev (145), the kernel would fail to reread the partition table.
	This could lead to problems with subsequent actions such as formatting
	the partition.

	Basically this patch increases the retry_count, and adds one sleep(1)
	function call prior to the the last few ioctl() calls.

	This patch might not be a perfect solution to this problem of "failure
	to inform kernel of partition changes", but it does significantly
	reduce the likelihood of encountering the problem.

	Details on the testing results and procedures used can be found at
	the following link:
	https://bugzilla.gnome.org/show_bug.cgi?id=604298#c9

	* libparted/arch/linux.c (_kernel_reread_part_table): Sleep for a
	full second if retry_count makes it down to "3".  Start it at 9
	rather than at 5.
	* NEWS (Bug fixes):

2010-02-20  Jim Meyering  <meyering@redhat.com>

	maint: remove now-unused <partition_table_type>_clobber functions
	All of these functions were rendered unused by commit 376b143045,
	"ped_disk_clobber: change semantics" on 2009-11-13.
	Also, Update each <...>_disk_ops "clobber:" member to be NULL.
	* libparted/labels/aix.c (aix_clobber): Remove function.
	* libparted/labels/bsd.c (bsd_clobber): Likewise.
	* libparted/labels/dasd.c (dasd_clobber): Likewise.
	* libparted/labels/dos.c (msdos_clobber): Likewise.
	* libparted/labels/dvh.c (dvh_clobber): Likewise.
	* libparted/labels/gpt.c (gpt_clobber): Likewise.
	* libparted/labels/loop.c (loop_clobber): Likewise.
	* libparted/labels/mac.c (_clobber_part_map, mac_clobber): Likewise.
	* libparted/labels/pc98.c (pc98_clobber): Likewise.
	* libparted/labels/rdb.c (amiga_clobber): Likewise.
	* libparted/labels/sun.c (sun_clobber): Likewise.
	Suggested by Hans De Goede.

2010-02-13  Jim Meyering  <meyering@redhat.com>

	doc: update release procedure to account for soname version number
	* README-release: Add a step "0", and update step 3 to match reality.

	libparted: set the shared library version number manually
	* libparted/Makefile.am (CURRENT, REVISION, AGE): Define here.
	(libparted_la_LDFLAGS): Use them, rather than using the
	automatically-defined LT_-prefixed variables.
	Stop using the "-release" option.
	Hans De Goede pointed out that the build process was automatically
	changing the shared library name.

2010-02-12  Jim Meyering  <meyering@redhat.com>

	gpt: clean-up wrt write_back (no semantic change)
	* libparted/labels/gpt.c (gpt_read): Initialize write_back to 0
	once again, and set it to 1 on the sole path that requires that.

2010-02-10  Jim Meyering  <meyering@redhat.com>

	gpt: "read-only" operation could clobber the pMBR in another way
	A read-only operation like "parted $dev print" would overwrite $dev's
	pMBR when exactly one of the primary and backup tables was corrupt.
	* libparted/labels/gpt.c (gpt_read): Clear "write_back" in those
	two cases.  Hans De Goede spotted this bug by inspection.
	* NEWS (Bug fixes): Mention it.
	* tests/t0206-gpt-print-with-corrupt-primary-clobbers-pmbr.sh: New test.
	* tests/Makefile.am (TESTS): Add
	t0206-gpt-print-with-corrupt-primary-clobbers-pmbr.sh.

	tests: factor utility functions into "library"
	...since we're about to use them from a second test.
	* tests/t-local.sh (peek_, poke_, gpt1_pte_name_offset_): New functions.
	(gpt_corrupt_primary_table_, gpt_restore_primary_table_): New functions.
	* tests/t0280-gpt-corrupt.sh: Remove local copies of those functions.
	Use the new ones.

2010-02-10  Hans de Goede  <hdegoede@redhat.com>

	dasd: don't dereference a NULL pointer in dasd_read
	* libparted/labels/dasd.c (dasd_read): Avoid NULL pointer dereference.

	parted: change default alignment to "optimal"
	* NEWS (Changes in behavior): Mention it.
	* parted/parted.c: Change --align default value to optimal.
	* tests/t2100-mkswap.sh: Adjust for alignment changes where necessary.
	* tests/t0220-gpt-msftres.sh: Likewise.
	* tests/t0280-gpt-corrupt.sh: Likewise.
	* tests/t2200-dos-label-recog.sh: Likewise.
	* tests/t2300-dos-label-extended-bootcode.sh: Likewise.
	* tests/t3000-resize-fs.sh: Likewise.
	* tests/t4100-msdos-partition-limits.sh: Likewise.
	* tests/t4100-msdos-starting-sector.sh: Likewise.
	* tests/t5000-tags.sh: Likewise.
	* tests/t8000-loop.sh: Likewise.
	* tests/t9021-maxima.sh: Likewise.

2010-02-10  Hans de Goede  <hdegoede@redhat.com>

	parted: change warnings when initial constrained mkpart fails
	In do_mkpart we first try to create a partition using a constraint
	derived from the user input intersected with the devices alignment
	needs. And if that fails we try again without any constraint.

	However the warning given when this happens only takes into account
	the user not getting what he asked for, while the alignment might be
	a problem too (or even the only problem). So this patch adds a check
	to see if the user really did not get what he asked before giving that
	warning, and adds a new check + warning to see if the created partition
	is properly aligned.
	*parted/parted.c (do_mkpart,do_mkpartfs): change warnings when initial
	constrained mkpart fails.

2010-02-10  Hans de Goede  <hdegoede@redhat.com>

	parted: honor --align option also in mkpartfs, resize and print cmds
	* parted/parted.c (do_mkpartfs,do_print,do_resize): Honor --align.

	linux: handle incomplete topology information
	The topology information returned by libblkid is not always complete
	(as the kernel does not always have complete information).
	This patch makes the linux_get_*_alignment() alignment functions handle
	this. The algorithm used for linux_get_optimum_alignment is:
	1) Always use the reported aligment offset as offset
	2a)If optimal io size is present in the topology info use that as grain
	2b)If optimal io size is not present in topology info and aligment
	   offset is 0 and minimum io size is a power of 2, use the device.c
	   default optimal alignment (grain 1MiB).
	2c) If neither 2a and 2b, use the minimum io size, or if that is not
	   defined, use the physical sector size as grain (iow the minimum
	   alignment).
	The algorithm used for linux_get_minimum_alignment is:
	1) Always use the reported aligment offset as offset
	2) Use the minimum io size, or if that is not defined the physical
	   sector size as grain.
	* libparted/arch/linux.c (linux_get_*_alignment): Handle incomplete
	topology information.

	libparted: Give device_get_*_alignment sane defaults
	When the topology info is incomplete or non existent, return something
	more sensible than NULL (which ends up being interpreted as
	PedAlignmentAny in most cases). The default minimum alignment aligns to
	physical sector size, the default optimal alignment is 1 MiB, which is
	what vista and windows 7 do.
	* libparted/device.c (device_get_*_alignment): Add default aligments.
	* NEWS (New features): Mention it.

	linux: correct phys_sector_size setting
	1) Use the logical sector size as physical sector size instead of 512
	   when not compiled with libblkid support, this fixes problems
	   with logical sector size > physical sector size.
	2) blkid_topology_get_physical_sector_size() returns 0 when it fails
	   to determine the physical sector size, handle this.
	* libparted/arch/linux.c (_device_set_sector_size): Correct
	phys_sector_size setting.
	* NEWS (Bug fixes): Mention it.

2010-02-09  Jim Meyering  <meyering@redhat.com>

	build: update gnulib submodule to latest

	doc: NEWS: mention the install-related bug fix
	* NEWS (Bug fixes): Mention the fix.

	gpt: read-only operation could clobber MBR part of hybrid GPT+MBR table
	* libparted/labels/gpt.c (gpt_read): Fix a bug introduced by me in
	commit 7f753b1b, "gpt: rewrite GPT header-reading code".
	Set write_back=0 in one more code path.
	* tests/Makefile.am (TESTS): Add t0205-gpt-list-clobbers-pmbr.sh.
	* tests/t0205-gpt-list-clobbers-pmbr.sh: New test.
	* NEWS (Bug fixes): Mention this.
	Reported by aix27249 in
	http://parted.alioth.debian.org/cgi-bin/trac.cgi/ticket/250

2010-02-08  Peter Breitenlohner  <peb@mppmu.mpg.de>

	do not install the test programs disk and label

2010-02-04  Otavio Salvador  <otavio@ossystems.com.br>

	Fix minor spelling errors
	This fixes minor spelling errors in the source code. Basically:

	 s/informations/information/g
	 s/prefered/preferred/g

2010-02-04  Jim Meyering  <meyering@redhat.com>

	tests: avoid another spurious test failure with newer xfsprogs
	* tests/t4100-msdos-partition-limits.sh: Likewise.

	tests: avoid spurious test failure with newer xfsprogs
	* tests/t4100-dvh-partition-limits.sh: Use mkfs.xfs' -f (force)
	option.  It is required at least for xfsprogs-3.1.0.

2010-01-31  Hans de Goede  <hdegoede@redhat.com>

	build: fix check-other-sector_sizes
	"make check-other-sector_sizes" was running tests of 512-byte sectors
	four times, rather than simulating larger sector-sizes for the latter
	three iterations.
	* Makefile.am (ss-1024 ss-2048 ss-4096): Fix the typo (missing "subst").

2010-01-31  Jim Meyering  <meyering@redhat.com>

	tests: adjust t9021-maxima not to fail with 2048-byte sectors
	* tests/t9021-maxima.sh: At 10,000*512 bytes, the backing file
	was too small to support a test simulating a sector size of 2048 bytes.
	Use 10,000*$sector_size bytes instead.

	build: avoid -Wshadow warnings
	* parted/parted.c (do_print): Avoid two shadowing warnings.

2010-01-29  Hans de Goede  <hdegoede@redhat.com>

	linux: remove PED_DEVICE_FILE check from _device_set_sector_size
	_device_set_sector_size is never called for devices with a type of
	PED_DEVICE_FILE.
	* libparted/arch/linux.c (_device_set_sector_size): Remove
	PED_DEVICE_FILE check.

	linux: remove unused blkpg.h header file
	* libparted/arch/linux.c: Don't include blkpg.h.
	* libparted/arch/blkpg.h: Deleted.
	* libparted/Makefile.am (libparted_la_SOURCES): Remove arch/blkpg.h.

	linux: use blkid_topology_get_physical_sector_size
	The official 2.17 release of util-linux-ng, has added a function to
	get the physical sector size.  Use that instead of getting the
	minimum io size.
	* libparted/arch/linux.c (_device_set_sector_size): Use
	blkid_topology_get_physical_sector_size.

2010-01-18  Jim Meyering  <meyering@redhat.com>

	maint: remove unreachable code
	* parted/parted.c (do_print): Remove unreachable ped_disk_destroy call.

2010-01-15  Jim Meyering  <meyering@redhat.com>

	build: update gnulib submodule to latest

	dos: don't leak a constraint upon partition-add failure
	* libparted/labels/dos.c (read_table): Free constraint upon failure.

	gpt: don't leak a constraint upon partition-add failure
	* libparted/labels/gpt.c (gpt_read): Free constraint upon failure.

	gpt: do not leak a GPT header on an error path
	* libparted/labels/gpt.c (gpt_write): Avoid a leak by freeing the
	header buffer after pth_get_raw call where it's used, but before
	checking whether that pth_get_raw call succeeded.
	Avoid another leak in identical just 10 lines down.
	Add "FIXME: caution..." comments to warn about the duplication.

	libparted: remove unreachable code
	* libparted/labels/gpt.c (gpt_write): Remove dead code.
	* libparted/labels/bsd.c (bsd_partition_new): Likewise.
	* libparted/disk.c (_ped_disk_alloc): Likewise.

	libparted: avoid double-free on an OOM failure path
	* libparted/disk.c (ped_disk_check): Don't double-free "fs_size".

2010-01-08  Jim Meyering  <meyering@redhat.com>

	build: update gnulib submodule to latest

	maint: update old_NEWS_hash
	* cfg.mk (old_NEWS_hash): Update for GFDL license update.

	maint: update all GFDL licenses to version 1.3
	* NEWS: Use 1.3, not 1.2.
	* doc/API: Use 1.3, not 1.1.
	* doc/FAT: Likewise.
	* doc/USER.jp: Likewise.
	* doc/fdl.texi: Likewise.
	* doc/parted-pt_BR.texi: Likewise.
	* doc/parted.texi: Likewise.

	maint: update all FSF copyright year lists to include 2010
	Run this command: make update-copyright

	maint: record update-copyright options for this package
	* cfg.mk: Next time, just run "make update-copyright".

2009-12-31  Jim Meyering  <meyering@redhat.com>

	maint: newer gnulib; don't hard-code my GPG key ID
	* cfg.mk (gpg_key_ID): Remove definition, now that maint.mk automates it.
	* gnulib: Update to latest.

2009-12-20  Jim Meyering  <meyering@redhat.com>

	maint: make build-aux/gnu-web-doc-update work
	* cfg.mk (manual_title): Define.
	* doc/parted.texi (Concept index): Rename from "Index".
	Remove @ifnotplaintext..@end around its menu entry.

	post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 2.1
	* NEWS: Record release date.

	doc: NEWS: mention the flag-truncation fix
	* NEWS (Bug fixes): Mention it.

2009-12-19  Hans de Goede  <hdegoede@redhat.com>

	dos: honor cylinder alignment disk flag when allocating metadata
	* libparted/labels/dos.c (add_startend_metadata): Honor cylinder
	alignment flag.

2009-12-18  Hans de Goede  <hdegoede@redhat.com>

	libparted: push/pop update mode around ped_disk_set_flag
	Disk flags can change how the metadata gets allocated, so push/pop
	update mode around ops->disk_set_flag, so that the metadata gets
	re-allocated.
	* libparted/disk.c (ped_disk_set_flag): push/pop update mode.

	linux: fix use-after-free in devicemapper code
	* libparted/arch/linux.c (_dm_add_partition): Fix use of dm_task
	information after freeing it.

2009-12-18  Hans de Goede  <hdegoede@redhat.com>

	ui: Do not truncate flag names when printing
	The partition_print_flags() function was truncating the flag names,
	but these are translated strings, and thus can contain multibyte
	characters. Truncating multibyte chars in a non multibyte aware way
	is not good and was causing issues when printing tables in Russian:
	http://bugzilla.redhat.com/show_bug.cgi?id=543029

	Since the truncating does not seem to make sense at all this patch
	simply removes it (it was likely an attempt to stay within 80 chars
	when printing, but as one partition can have multiple flags set this
	won't work)

	* parted/parted.c (partition_print_flags): Don't truncate flag names.

2009-12-16  Jim Meyering  <meyering@redhat.com>

	libparted: plug a leak in mac_write
	* libparted/labels/mac.c (mac_write): Free mac_driverdata.

	maint: use "int", not "bool" for value returned by ped_device_write
	* libparted/labels/gpt.c (gpt_write): Correct type of local.
	* libparted/labels/mac.c (mac_clobber): Likewise.
	* libparted/labels/sun.c (sun_write): Likewise.

	libparted: plug a leak in mac's write_block_zero
	* libparted/labels/mac.c (write_block_zero): Don't leak a
	1-sector-sized buffer.

	dos: remove unreachable code
	* libparted/labels/dos.c (msdos_partition_new): Remove dead code.

	libparted: plug a leak in gpt_probe
	* libparted/labels/gpt.c (gpt_probe): Avoid a leak when dev->length
	is one sector or smaller.

2009-12-14  Jim Meyering  <meyering@redhat.com>

	maint: improve dist-check.mk rules
	* dist-check.mk (null_AM_MAKEFLAGS): Remove LIBTOOL.  Adding it was
	erroneous, since it is required when building from a distribution
	tarball of a libtool-using project.  Reported by Ralf Wildenhues.
	(my-distcheck): Reorganize to use a subshell and set -e, so that
	failures propagate "out".  Without this change, setting LIBTOOL=false
	would cause a failure that would then be ignored, probably due to a
	problem in $(install-transform-check).

	maint: dist-check.mk adapt to parted-specific details
	* dist-check.mk (built_programs): Use parted/, not src/.
	(install-transform-check): Search sbin/, not /bin.
	Expect man pages to be in man8/*.8.

2009-12-13  Jim Meyering  <meyering@redhat.com>

	maint: sync dist-check.mk from coreutils
	* dist-check.mk: Sync from coreutils.
	* gnulib: Update to latest.

	maint: sync dist-check.mk from coreutils
	* dist-check.mk: Sync from coreutils.
	* gnulib: Update to latest.

2009-12-12  Jim Meyering  <meyering@redhat.com>

	build: distribute gperf-generated file, pt-limit.c
	* libparted/labels/Makefile.am (EXTRA_DIST): Distribute the
	gperf-generated file, pt-limit.c, so that people don't need to
	run gperf at build-from-tarball time.

	ui: mkpart: avoid double free
	* parted/parted.c (do_mkpart): This function frees "part_name"
	immediately after the final use, but also upon e.g., ped_disk_commit
	failure.  Set part_name to NULL after the first free, to make
	the second a no-op after the first.

2009-12-11  Jim Meyering  <meyering@redhat.com>

	build: update spec: gperf is a new build-requirement
	* parted.spec.in (BuildRequires): Add gperf.
	Reported by Jeff Darcy.

	build: update gnulib submodule to latest

	tests: ensure that parted can partition a loop device
	* tests/t8000-loop.sh: Reverse sense of tests, now that
	partitioning a loop device succeeds again.
	* NEWS (Bug fixes): Mention it.

2009-12-11  Hans de Goede  <hdegoede@redhat.com>

	linux: treat loopback devices as files
	We cannot do partition related ioctl's on loopback devices,
	so treat them as files.
	* libparted/arch/linux.c (LOOP_MAJOR): Define.
	* libparted/arch/linux.c (_device_probe_type): Treat loopback
	devices as files.
	Reported by Josef Bacik in http://bugzilla.redhat.com/546622

2009-12-10  Hans de Goede  <hdegoede@redhat.com>

	libparted: missing pop update mode in ped_disk_delete_all error path
	* libparted/disk.c(ped_disk_delete_all): Add missing update mode pop
	call in error path.

	libparted: make pop/push update mode propagate sanity check errors
	Sanity check errors indicate something is really really wrong, still
	sometimes they happen, when they happen it helps a lot in debugging
	them when the libparted caller immediately errors out at the first
	moment, rather then slugging along until things crash somewere.
	* libparted/disk.c(_disk_push_update_mode,_disk_pop_update_mode):
	Change return value from void to int, and return 0 when the sanity
	check calls fail.
	* libparted/disk.c(*): Update all _disk_push_update_mode /
	_disk_pop_update_mode callers to propagate the return value.

2009-12-10  Joel Granados Moreno  <jgranado@redhat.com>

	libparted: add missing update mode pop in duplicate error path
	* libparted/disk.c(ped_disk_duplicate): Add missing update mode
	pop call in error path.

	gpt: Add support for appletv partitions
	* include/parted/disk.h(PedPartitionFlag): Add
	PED_PARTITION_APPLE_TV_RECOVERY.
	* libparted/disk.c(ped_partition_flag_get_name): Handle
	PED_PARTITION_APPLE_TV_RECOVERY.
	* libparted/labels/gpt.c(PARTITION_APPLE_TV_RECOVERY_GUID):
	New define.
	* libparted/labels/gpt.c(GPTPartitionData): Add atvrecv member.
	* libparted/labels/gpt.c(_parse_part_entry, gpt_partition_new,
	gpt_partition_set_system, gpt_partition_set_flag,
	gpt_partition_get_flag, gpt_partition_is_flag_available):
	Handle atvrecv / PARTITION_APPLE_TV_RECOVERY_GUID.

	build: don't install s390 dasd internal headers into /usr/include
	* include/parted/Makefile.am (partedinclude_HEADERS):
	Remove $(S390_HDRS).
	(noinst_HEADERS): Put them here instead.

2009-12-10  Hans de Goede  <hdegoede@redhat.com>

	ui: add --align command-line option to specify mkpart alignment
	The new --align command-line option can have the following values:
	none:     Use the minimum alignment allowed by the disk type
	cylinder: Align partitions to cylinders (the default)
	minimal: Use minimum alignment as given by the disk topology information
	optimal: Use optimum alignment as given by the disk topology information

	Note the "minimal" and "optimal" values will use layout information
	provided by the disk to align the logical partition table addresses
	to actual physical blocks on the disks.  The "minimal" value is the
	minimum aligment needed to align the partition properly to physical
	blocks, which avoids performance degradation.  Whereas the "optimum"
	alignment align's to a multiple of the physical block size in a way
	that guarantees optimal performance.

	The "minimal" and "optimal" values are useful only when parted is
	compiled with libblkid >= 2.17 and running on a kernel >= 2.6.31,
	otherwise they are equivalent to --align=none.

	* parted/parted.c (ALIGNMENT_ enum values): New enum.
	(options, options_help): Add --align option.
	(align_args, align_types, alignment): New global variables.
	(do_mkpart): Honor aligment variable.
	(_parse_options): handle --align option.
	* bootstrap.conf (gnulib_modules): Add argmatch.
	* NEWS: Mention the new --align option.
	* doc/parted.texi: Document --align option.
	* doc/C/parted.8: Likewise.

2009-12-10  Hans de Goede  <hdegoede@redhat.com>

	NEWS: update with libblkid and kernel requirements for alignment funcs
	* NEWS: Change the note for the align-check command to also reference
	libblkid, add a note to the libparted alignment functions NEWS entry
	about libblkid and kernel requirements.

	NEWS: Add new disk flag functions to NEWS
	* NEWS: Add new disk flag functions.

	msdos, sun: implement disk flag operations
	* libparted/labels/dos.c (DosDiskData): New struct.
	* libparted/labels/dos.c (msdos_alloc, msdos_duplicate, msdos_free):
	Handle per disk DosDiskData.
	* libparted/labels/dos.c (msdos_disk_set_flag, msdos_disk_get_flag,
	msdos_disk_is_flag_available): New functions.
	* libparted/labels/sun.c (sun_disk_set_flag, sun_disk_get_flag,
	sun_disk_is_flag_available): New functions.

2009-12-10  Hans de Goede  <hdegoede@redhat.com>

	libparted: add disk flag functions and PED_DISK_CYLINDER_ALIGNMENT flag
	Sometimes we want to be able to set flags at the disk level rather then
	at the parition level, to influence how new partitions will be created
	for example.  This patch adds functions to do this (modelled after the
	partition flag functions), and adds a PED_DISK_CYLINDER_ALIGNMENT flag.

	This flag (which defaults to true) controls if disk types for which
	cylinder alignment is optional do cylinder alignment when a new
	partition gets added. This flag is available for msdos and sun
	disklabels (for sun labels it only controls the aligning of the end of
	the partition).
	* include/parted/disk.h (PedDiskFlag): New type
	* include/parted/disk.h (ped_disk_set_flag, ped_disk_get_flag,
	ped_disk_is_flag_available): new functions and PedDiskOps members
	* include/parted/disk.h (ped_disk_flag_get_name,
	ped_disk_flag_get_by_name, ped_disk_flag_next): new functions
	* libparted/disk.c (ped_disk_set_flag, ped_disk_get_flag,
	ped_disk_is_flag_available, ped_disk_flag_get_name,
	ped_disk_flag_get_by_name, ped_disk_flag_next): new functions

2009-12-10  Hans de Goede  <hdegoede@redhat.com>

	dasd: fix leak in dasd_free
	* libparted/labels/dasd.c (dasd_free): Free disk_specific data.

2009-12-09  Jim Meyering  <meyering@redhat.com>

	build: update gnulib submodule to latest

	build: make it clear which sector size is in use upon test failure
	* Makefile.am (ss-1024 ss-2048 ss-4096): New targets.
	Before this, top-level "make check" would lead to four separate
	runs through all the regression tests, one for each of the following
	simulated sector sizes: 1024 2048 4096, and one more for the native
	(usually 512), and it was not easy to tell which sector size was
	in use for a failing test.  Now, we still perform exactly the same
	tests, but the sector size is now part of each target name.

2009-12-08  Jim Meyering  <meyering@redhat.com>

	tests: exercise the new interfaces
	* tests/print-max.c: New file.
	* tests/t9021-maxima.sh: New file.
	* tests/Makefile.am (TESTS): Add t9021-maxima.sh.
	(check_PROGRAMS): Add print-max.

	libparted: new interfaces: max start sector, max partition length
	* libparted/disk.c (ped_disk_max_partition_start_sector): New function.
	(ped_disk_max_partition_length): New function.
	* include/parted/disk.h: Declare them.
	* NEWS (New features): Mention them.

	libparted: factor out duplication, hook up new APIs
	* include/parted/disk.h [struct _PedDiskOps]:
	(max_length, max_start_sector): New members.
	* libparted/labels/pt-common.h: New file.
	* libparted/labels/Makefile.am (liblabels_la_SOURCES): Add it.
	* libparted/labels/dos.c: Include "pt-common.h".
	(msdos_partition_check): Remove function.
	(msdos_disk_ops): Remove factored out initializers.
	* libparted/labels/gpt.c: Likewise.
	* libparted/labels/dvh.c: Likewise.
	* libparted/labels/aix.c:
	(aix_disk_ops, aix_partition_check): Likewise.
	* libparted/labels/bsd.c:
	(bsd_disk_ops, bsd_partition_check): Likewise.
	* libparted/labels/dasd.c:
	(dasd_disk_ops, dasd_partition_check): Likewise.
	* libparted/labels/loop.c:
	(loop_disk_ops, loop_partition_check): Likewise.
	* libparted/labels/mac.c:
	(mac_disk_ops, mac_partition_check): Likewise.
	* libparted/labels/pc98.c:
	(pc98_disk_ops, pc98_partition_check): Likewise.
	* libparted/labels/rdb.c:
	(amiga_disk_ops, amiga_partition_check): Likewise.
	* libparted/labels/sun.c:
	(sun_disk_ops, sun_partition_check): Likewise.
	* libparted/labels/gpt.c (NULL_IF_DISCOVER_ONLY): Remove definition,
	now that it's in pt-common.h.

	libparted: use gperf-generated lookup function
	* libparted/labels/pt-tools.c (ptt_partition_max_start_len):
	Rewrite to use the gperf-generated look-up function.
	(ptt_partition_max_start_sector): New function.
	(ptt_partition_max_length): New function.
	* libparted/labels/pt-tools.h: Declare them.
	* libparted/labels/Makefile.am (GPERF, GPERF_OPTIONS): Define.
	(BUILT_SOURCES): Define.
	(liblabels_la_SOURCES): Append pt-limit.gperf.
	(pt-limit.c): New rule.
	(MAINTAINERCLEANFILES): Remove useless definition.
	(DISTCLEANFILES): Set to $(BUILT_SOURCES).
	* libparted/labels/pt-limit.gperf: New file.
	* cfg.mk (bootstrap-tools): Mention gperf.
	* bootstrap.conf (buildreq): Require gperf-3.0.3.

	pc98: avoid segfault with simulated large sectors
	The pc98 partition table is by no means ready for >512-byte sectors,
	but at least it now gets past mklabel.  E.g., this usage no longer
	provokes double-free and read-uninitialized errors:
	dd if=/dev/zero of=F bs=512 count=1 seek=10000
	PARTED_SECTOR_SIZE=4096 valgrind ../parted/parted -s F mklabel pc98
	* libparted/labels/pc98.c (pc98_write): Rewrite to avoid
	invalid access with >512-byte sectors.

	libparted: ptt_read_sectors: new function
	* libparted/labels/pt-tools.c (ptt_read_sectors): New function.
	(ptt_read_sector): Rewrite to use it.
	* libparted/labels/pt-tools.h: Declare it.

2009-12-03  Jim Meyering  <meyering@redhat.com>

	mac: hook up the partition_check function for this partition table type
	* libparted/labels/pt-tools.c (ptt_partition_max_start_len): Define
	for MAC partition tables.  They too have 32-bit-limited partition
	starting sector number and partition length (in sectors).
	* libparted/labels/mac.c (mac_partition_check): Use
	ptt_partition_max_start_len.

2009-11-30  Jim Meyering  <meyering@redhat.com>

	tests: exercise new align-check command
	* tests/t9030-align-check.sh: New file.
	* tests/Makefile.am (TESTS): Add it.

2009-11-30  Jim Meyering  <meyering@redhat.com>

	ui: new command: align-check TYPE N
	e.g.,
	  parted -s /dev/sda align-check min 1 && echo partition 1 is min-aligned
	  parted -s /dev/sda align-check opt 2 && echo partition 2 is opt-aligned

	* parted/parted.c:
	* parted/ui.c:
	* parted/ui.h:
	* NEWS (New features): Mention it.
	* doc/parted.texi (align-check): Describe it.

2009-11-30  Jim Meyering  <meyering@redhat.com>

	tests: correct a comment
	* tests/t9020-alignment.sh: Correct a comment.

2009-11-27  Jim Meyering  <meyering@redhat.com>

	libparted: ped_disk_clobber_exclude: remove now-unused function
	I see no utility in ped_disk_clobber_exclude (just a thin wrapper
	around ped_disk_clobber), so am removing the interface.
	* include/parted/disk.h (ped_disk_clobber_exclude): Remove prototype.
	* libparted/disk.c (ped_disk_clobber_exclude): Remove function.
	Now that all callers use NULL as 2nd argument, replace each call
	with one to ped_disk_clobber.
	* scripts/data/abi/baseline_symbols.txt: Remove it.

	Reviewed-by: Karel Zak <kzak@redhat.com>

2009-11-27  Jim Meyering  <meyering@redhat.com>

	ped_disk_clobber: change semantics
	Why?  Because if we're going to clobber a partition table,
	it is wasteful and error prone to try to interpret as a partition
	table whatever existing data there may be.  It may be corrupt, or
	a mix of two or more types.  It is far cleaner just to zero out
	the key sectors.

	The previous mechanism was like this:
	for each partition table type, T,
	    # See if the device has a partition of type T.
	    # If so, run the partition-table-specific code to clear it.
	    if t->ops->probe (dev)
	      t->ops->clobber (dev)
	Instead, simply zero out the first few and last few sectors.
	Except for GPT, for which we exempt the first sector (the pMBR).
	In order to zero out even the bits DASD uses for its identifying
	strings, we have to clobber at least the 8.5KiB at the beginning
	of the disk, so round up to 9KiB.
	* libparted/disk.c: Include "labels/pt-tools.h".
	(find_disk_type): New helper function.
	(ped_disk_clobber_exclude):

	Reviewed-by: Karel Zak <kzak@redhat.com>

2009-11-27  Jim Meyering  <meyering@redhat.com>

	dasd: allow the use of a *regular* backing file
	Before this change, dasd partition tables had to be associated with
	very specialized block devices available only on IBM s390 systems.
	This made testing especially hard.  Not only did you need access
	to one of those relatively uncommon systems, but you also needed
	access to a spare block device.  In addition, many of Parted's
	tests may be run as a non-privileged user, using regular files,
	and those tests would fail when run on an s390.

	This change makes it so you may now write a DASD partition table
	to a regular backing file, just as you may with any other supported
	partition table type.  However, note that even now, DASD support
	is conditionally compiled and hence enabled only when compiling
	for an s390 target.

	* libparted/arch/linux.c (_device_set_sector_size) [__s390__]:
	Allow operation on a device of type PED_DEVICE_FILE, as well as
	those of type PED_DEVICE_DASD.
	* libparted/labels/fdasd.c: Include <parted/device.h>.
	(fdasd_get_geometry): Add a new "dev" parameter, required for
	dev-phys-sector_size, which is needed in order to initialize
	the "anc" structure without using the device-specific ioctls.
	When file descriptor "f" refers to a regular file, initialize
	"anc", "dasd_info", etc. from other sources (fstat and dev->).
	Update all callers to reflect added parameter.
	(fdasd_check_api_version): Skip ioctl-calling tests when "f" is
	a regular file.
	* include/parted/fdasd.h: Update fdasd_get_geometry prototype.
	* libparted/labels/dasd.c (dasd_probe): Also allow PED_DEVICE_FILE.
	(dasd_alloc_metadata): Initialize arch_specific->real_sector_size,
	which is used in calculating vtoc_end.

	Reviewed-by: Karel Zak <kzak@redhat.com>

2009-11-27  Jim Meyering  <meyering@redhat.com>

	loop: simplify/correct loop_clobber
	Before, it would clear a sector only if it recognized its own
	signature.  In addition, it would continue clearing subsequent
	sectors as long as loop_probe succeeded.  Now we simply clear
	the first sector.
	* libparted/labels/loop.c (loop_clobber): Simplify.

	Reviewed-by: Karel Zak <kzak@redhat.com>

2009-11-26  Jim Meyering  <meyering@redhat.com>

	tests: indicate that we expect t3200-type-change to fail, for now
	* tests/Makefile.am (TESTS): Move t3200-type-change.sh to ...
	(XFAIL_TESTS): ...here.

2009-11-24  Jim Meyering  <meyering@redhat.com>

	tests: correct t3200-type-change.sh
	* tests/t3200-type-change.sh: The initial version was incomplete.

	tests: provide a new function: fail_
	* tests/t-lib.sh (fail_): New function.

	tests: t0001-tiny.sh: avoid spurious failure when run as root.
	* tests/t0001-tiny.sh: Control characters were getting in the way.
	Filter them out.

2009-11-23  Jim Meyering  <meyering@redhat.com>

	dasd: avoid NULL-dereference via disk->type->ops->partition_check
	Commit f387fee8 added the new ops->partition_check() function,
	and a <type>_partition_check function for each partition table
	format _except_ dasd.  This change adds one for dasd, too.
	* libparted/labels/dasd.c: Include "pt-tools.h".
	(dasd_partition_check): New function.
	* libparted/labels/pt-tools.c (ptt_partition_max_start_len): Add "dasd"
	to the list of partition table type names for which the 32-bit
	limits on starting sector and partition length apply.
	Correct a comment.
	Considering the 32-bit fields in "struct fdasd_hd_geometry",
	it is safe to assume that larger offset or size is not possible.

2009-11-18  Jim Meyering  <meyering@redhat.com>

	build: "make stable" emitted an invalid gnupload command
	* cfg.mk (gnu_ftp_host-stable): Rename from gnu_ftp_host-major.

2009-11-17  Jim Meyering  <meyering@redhat.com>

	test for partition-type-changing bug
	* tests/t3200-type-change.sh: New file.
	* tests/Makefile.am (TESTS): Add it.

2009-11-13  Jim Meyering  <meyering@redhat.com>

	gpt: greatly simply gpt_clobber; minor semantic change, too
	* libparted/labels/gpt.c (gpt_clobber): Don't bother to read and
	parse existing headers.  Instead, simply clear three sectors:
	the pMBR, the primary header (LBA1), and the last sector.
	There is no point in clearing what the primary header says is the
	AlternateLBA, since once the primary header and the last sector
	are cleared, there is no risk of any tool using it by mistake.

	tests: t0000-basic.sh: minor correction
	* tests/t0000-basic.sh: When zeroing out the first sector,
	use dd's conv=notrunc.  Otherwise, we'd also truncate the
	backing file size to 4KiB.

	linux_read: give a proper diagnostic for an "end of file" error
	Before today's gpt_probe bug fix, its test case would provoke
	an invalid diagnostic.  This makes the diagnostic useful.
	* libparted/arch/linux.c (linux_read): When hitting EOF while reading,
	diagnose it properly, rather than via strerror(0) (i.e., "Success").

	gpt_probe: don't attempt to read beyond end of a very small disk
	* libparted/labels/gpt.c (gpt_probe): Don't try to read the
	2nd sector if that's beyond the end of the disk.
	* tests/t0001-tiny.sh: New test, to expose the above boundary-case bug.
	Part of the msdos-partition-creation process involves probing for
	other types of partition tables.  Probing for gpt would evoke a
	nonsensical diagnostic.
	* tests/Makefile.am (TESTS): Add t0001-tiny.sh.

	dvh: replace open-coded dvh_clobber with equivalent, shorter code
	* libparted/labels/dvh.c (dvh_clobber): Simply use ptt_clear_sectors.

	tests: weaken t0202-gpt-pmbr to assume a preexisting GPT table
	* tests/t0202-gpt-pmbr.sh: Lay down an initial GPT table before
	writing to the MBR, so this test passes with the new semantics.

	tests: rewrite t0202 to use new framework
	* tests/t0202-gpt-pmbr.sh: Rewrite.

	ped_disk_type_get_next: fix a const-correctness bug
	* libparted/disk.c (ped_disk_type_get_next): Make param const.
	* include/parted/disk.h (ped_disk_type_get_next): Update prototype.

2009-11-12  Hans de Goede  <hdegoede@redhat.com>

	NEWS: mention recent changes

2009-11-12  Jim Meyering  <meyering@redhat.com>

	maint: more const-correctness fixes

2009-11-12  Hans de Goede  <hdegoede@redhat.com>

	dasd: fix ped_disk_new_fresh to not read old data from disk
	dasd_write(), was reading the volume label from the disk (trough
	fdasd_check_volume()) and later writing it back again, this is fine for
	existing dasd labels, but when creating a fresh label, this would
	also cause the old volume label to be re-used, and if the old label
	was corrupt, it would cause fdasd_check_volume() and thus dasd_write()
	to fail.  Reported here: http://bugzilla.redhat.com/533808

	* libparted/arch/linux.c: include fdasd.h.
	(init_dasd): Do BIODASDINFO ioctl, and store the dasd devno in
	arch_specific.
	(init_dasd): Remove dead (never reached) code.
	* libparted/arch/linux.h (struct _LinuxSpecific): Add devno member.
	* libparted/labels/dasd.c (DasdDiskSpecific): add vlabel member.
	(dasd_alloc): Init DasdDiskSpecific.vlabel for fresh disks
	(dasd_read): Store read vlabel in DasdDiskSpecific.vlabel.
	(dasd_write): Write DasdDiskSpecific.vlabel instead of on disk vlabel.

2009-11-10  Jim Meyering  <meyering@redhat.com>

	build: avoid s390-specific compilation failiure
	* libparted/labels/vtoc.c (vtoc_volume_label_init): Don't use
	strncpy to copy 84 bytes into a 4-byte field.  Instead, use
	memcpy to copy "sizeof *vlabel" bytes into the "vlabel".

	maint: fix s390-specific const correctness problems
	* libparted/labels/vtoc.c (vtoc_error, vtoc_ebcdic_enc):
	(vtoc_ebcdic_dec): Declare parameters to be const, as required.
	* libparted/labels/fdasd.c (fdasd_error): Likewise.
	* include/parted/vtoc.h (vtoc_ebcdic_enc, vtoc_ebcdic_enc): Update
	prototypes.

	gpt: fix a bug in the new PE-array CRC checks on big-endian systems
	* libparted/labels/gpt.c (check_PE_array_CRC, gpt_read): Always
	convert the PartitionEntryArrayCRC32 to CPU endianness before
	comparing with a just-computed CRC.

2009-11-08  Jim Meyering  <meyering@redhat.com>

	build: use gnulib's canonicalize-lgpl module
	Replace Parted's private version of canonicalize_file_name.
	* libparted/device.c: Include <stdlib.h>.
	(canonicalize_file_name) [!HAVE_CANONICALIZE_FILE_NAME]:
	Remove definition.
	* bootstrap.conf (gnulib_modules): Add canonicalize-lgpl.

2009-11-07  Jim Meyering  <meyering@redhat.com>

	libparted: linux: don't deref NULL upon failed malloc or realloc
	* libparted/arch/linux.c (_read_fd): Handle allocation failure.

	build: update gnulib submodule to latest

	maint: use EXIT_SUCCESS and EXIT_FAILURE, not 0 and 1 to exit
	Convert all uses automatically, via these two commands:
	git grep -l '\<exit *(1)'|xargs --no-run-if-empty \
	  perl -pi -e 's/\b(exit ?)\(1\)/$1(EXIT_FAILURE)/'
	git grep -l '\<exit *(0)'|xargs --no-run-if-empty \
	  perl -pi -e 's/\b(exit ?)\(0\)/$1(EXIT_SUCCESS)/'
	* libparted/fs/fat/table.c (fat_table_get): Use symbolic exit codes.
	* libparted/labels/vtoc.c (vtoc_update_format5_label_add): Likewise.
	(vtoc_update_format5_label_del): Likewise.
	(vtoc_update_format7_label_add): Likewise.
	(vtoc_update_format7_label_del): Likewise.
	* m4/parted.m4 (PARTED_CHECK_LIBPARTED): Likewise.
	* parted/parted.c (do_quit): Likewise.
	* parted/strlist.c (gettext_to_wchar, wchar_to_str): Likewise.
	* parted/ui.c (reset_env, help_msg, non_interactive_mode): Likewise.

2009-11-06  Hans de Goede  <hdegoede@redhat.com>

	dasd: fix unused variable warning
	* libparted/labels/dasd.c (dasd_get_partition_alignment): Fix unused
	variable warning.

	linux: use cached major minor instead of statting the device again
	* libparted/arch/linux.c (_dm_remove_parts): Use cached major/minor
	numbers.

2009-11-06  Hans de Goede  <hdegoede@redhat.com>

	linux: use devicemapper task name instead of device node name
	Use devicemapper task name instead of device node name as basename for
	devicemapper disk partitions.

	This is needed for upcoming lvm changes where the /dev/mapper/foobar
	files are becoming symlinks, so we will end up opening /dev/dm-#,
	and naming our partitions dm-#p1, dm-#p2, instead of foobarp1,
	foobarp2, etc.

2009-11-06  Hans de Goede  <hdegoede@redhat.com>

	linux: use major / minor to specify device mapper device in dm_task
	Use major / minor to specify device mapper device instead of
	dm_task_set_name. This is needed for upcoming lvm changes where the
	/dev/mapper/foobar files are becoming symlinks, so we will end up
	opening /dev/dm-#, and dm-# is not a valid dm_task name.

	This is only needed in this one place, as in the other places where we
	use dm_task_set_name, the name we use was returned by libdevicemapper
	itself in an earlier function call.

2009-11-06  Jim Meyering  <meyering@redhat.com>

	tests: enable the FS-resizing (tests only HFS and FAT)
	* tests/Makefile.am (TESTS): Add t3000-resize-fs.sh.

	maint: remove stray "types and" in the big FS-op warning
	* parted/parted.c (issue_fs_op_warning): Correct grammar in diagnostic.

	tests: convert more tests to new framework
	* tests/t0400-loop-clobber-infloop.sh: Convert.
	* tests/t0010-script-no-ctrl-chars.sh: Likewise.
	* tests/t3000-resize-fs.sh: Likewise, and convert it to use scsi_debug.
	* tests/t-local.sh (require_512_byte_sector_size_): Copy this
	function from test-lib.sh.

2009-11-04  Hans de Goede  <hdegoede@redhat.com>

	dasd: fix disk duplication
	Fix dasd_duplicate and add a dasd_partition_duplicate function.
	* libparted/labels/dasd.c(dasd_partition_duplicate): New function.
	(dasd_duplicate): Don't set the disk_specific pointer to NULL!
	(dasd_duplicate): Copy DasdDiskSpecific from old disk to new disk.

	dasd: set disk_specific->format_type in dasd_alloc
	Set disk_specific->format_type in dasd_alloc, so that the disk
	returned by ped_disk_new_fresh is a valid dasd disk.
	* libparted/labels/dasd.c (dasd_alloc): Set disk_specific->format_type.

2009-11-04  Hans de Goede  <hdegoede@redhat.com>

	dasd: cache real_sector_size in linux_probe
	dasd_alloc was doing an ioctl to get the real sector size for the dasd
	device (we are faking 512 bytes sectors), but when called directly
	from ped_disk_new_fresh(), the device is not open causing this to fail.

	This patch fixes things by caching the real_sector_size in the linux
	arch_specific data and making the dasd label handling use this.
	libparted/arch/linux.c(_device_set_sector_size): Cache real sector size.
	(_device_set_sector_size, init_dasd, linux_new): Only compile dasd code
	on s390 and s390x.

2009-11-04  Hans de Goede  <hdegoede@redhat.com>

	dasd: remove bogus part_info pointer from DasdPartitionData
	The part_info pointer in DasdPartitionData was only used to
	pass fdasd partition_info_t pointers from dasd_write to
	the dasd_write dasd_update_type utility function. Since these
	pointers are not valid outside the lifetime of dasd_write, they
	should not be stored in the longer lived DasdPartitionData.

	* libparted/labels/dasd.c(DasdPartitionData): Remove part_info member.
	(dasd_read): Stop setting DasdPartitionData part_info.
	(dasd_update_type): Add part_info argument to pass fdasd
	partition_info_t pointers from dasd_write.
	(dasd_write): Stop setting DasdPartitionData part_info, pass
	partition_info_t pointers to dasd_update_type as a separate argument.

2009-11-04  Hans de Goede  <hdegoede@redhat.com>

	dasd: clean up anchor handling
	The current dasd label code keeps an fdasd anchor struct in the
	DasdDiskSpecific struct, and fills this during dasd_read. However this
	anchor does not get updated with any future mods, until dasd_write,
	at which points it gets completely re-initialized.

	Since the contents of the anchor saved during read does not get used
	anywhere else, this patch switches to using local anchor structs in
	dasd_read and dasd_write. This will also allow writing a significantly
	simpler duplicate implementation, then the one which is currently
	added to the Fedora package with a patch from Joel Granados (The
	current master dasd_duplicate implementation is not functional).

	This patch also fixes several missing calls to fdasd_cleanup() fixing
	several memory leaks.

	* libparted/arch/linux.h (struct _LinuxSpecific): Drop anchor member.
	* libparted/labels/dasd.c (DasdDiskSpecific): Drop anchor member.
	(dasd_clobber): Add missing fdasd_cleanup().
	(dasd_read, dasd_write): Use local anchor struct instead of a
	dynamically allocated one in DasdDiskSpecific.
	(dasd_read): Don't leak a PedConstraint in 2 error paths.
	(dasd_update_type): Pass in the used anchor as argument.

2009-11-03  Jim Meyering  <meyering@redhat.com>

	tests: distribute new files, t-local.sh and t-lvm.sh
	* tests/Makefile.am (EXTRA_DIST): Add t-local.sh and t-lvm.sh.

	tests: appease "make syntax-check"
	* tests/print-align.c: Include "progname.h".  Call set_program_name.

	tests: t6000-dm.sh: update and adapt to changed LVM2
	* tests/t6000-dm.sh: Rewrite to use new test framework and
	to disable multipath testing, since LVM2 has changed in such
	a way that it no longer works with loop devices.

	tests: do not invoke scsi_debug_setup_ in a subshell
	* tests/t9010-big-sector.sh: Do not invoke scsi_debug_setup_ in
	a subshell, since it sets a variable that cleanup machinery expects
	to see.
	* tests/t9020-alignment.sh: Likewise.

	tests: tweak temporary dirname prefix
	* tests/t-lib.sh (t_): Use "pe-" as prefix, not "gz-".

	tests: update lvm-utils.sh from lvm2
	* tests/lvm-utils.sh: Merge in changes from lvm2.

	tests: adapt/update lvm-related infrasture, too
	* tests/t-local.sh: Source t-lvm.sh.
	* tests/t-lvm.sh: Clone and update of lvm-utils.sh,
	for when we retire that file in favor of this one.

	tests: adapt t8000-loop.sh
	* tests/t8000-loop.sh: Rewrite in new style, and adjust to
	expect new diagnostic.

	tests: print and check partition alignment info, too
	* tests/print-align.c: Print partition alignment info, too
	* tests/t9020-alignment.sh: Check partition alignment too.

	tests: serialize tests that use the scsi_debug module
	* tests/t-local.sh (scsi_debug_lock_file_): New global.
	(scsi_debug_acquire_lock_): New function.
	(scsi_debug_setup_): Call it, to acquire the lock.
	(scsi_debug_cleanup_): Release the lock.

	tests: test the new alignment functions
	* tests/t9020-alignment.sh: New test.
	* tests/Makefile.am (TESTS): Add it to the list.

	tests: factor out some more
	* tests/t-local.sh (require_scsi_debug_module_): New function.
	* tests/t9010-big-sector.sh: Use it.

	tests: perform scsi_debug cleanup automatically...
	...rather than requiring each test to do it.
	* tests/t-lib.sh ($cleanup_eval): New variable.  Initialize.
	(remove_tmp_): Use it.
	* tests/t-local.sh: Record whether modprobe succeeded.
	(cleanup_eval_): Append an invocation of scsi_debug_cleanup_
	so that it is always run.
	(scsi_debug_cleanup_): Run rmmod only if the modprobe succeeded.
	* tests/t9010-big-sector.sh (cleanup_): Remove.

2009-11-02  Jim Meyering  <meyering@redhat.com>

	tests: move scsi_debug framework into shared script
	* tests/t-local.sh (-scsi_debug_cleanup_, wait_for_dev_to_appear_):
	(print_sd_names_, scsi_debug_setup_): New functions, factored out of ...
	* tests/t9010-big-sector.sh: ...this file.

	tests: document and begin to factor out scsi_debug framework
	* tests/t9010-big-sector.sh: Add comments, fix a bug in
	"comm" usage, prepare to factor out scsi_debug framework.

	tests: add a helper program to print alignment info for a device
	* tests/print-align.c: New file.
	* tests/Makefile.am (check_PROGRAMS): Define.
	(AM_CPPFLAGS, LDADD): Define.
	(AM_CFLAGS): Enable warnings here, too, by adding
	$(WARN_CFLAGS) and $(WERROR_CFLAGS).

2009-11-01  Hans de Goede  <hdegoede@redhat.com>

	Implement get_partition_alignment DiskOp for all labels which need it
	Implement get_partition_alignment DiskOp for all labels which require
	an alignment with a grain_size != 1.

	libparted: add ped_disk_get_partition_alignment() function
	This functions get the alignment needed for partition boundaries on this disk.
	The returned alignment describes the alignment for the start sector of the
	partition, for all disklabel types which require alignment, except Sun
	disklabels, the end sector must be aligned too. To get the end sector
	alignment decrease the PedAlignment offset by 1.

2009-11-01  Hans de Goede  <hdegoede@redhat.com>

	libparted: add ped_device_get_xxx_aligned_constraint() functions
	Add ped_device_get_minimal_aligned_constraint() and
	ped_device_get_optimal_aligned_constraint() functions to libparted.

	These functions can be used to get a device constraint taking alignment into
	account.

2009-11-01  Hans de Goede  <hdegoede@redhat.com>

	ped_device_get_constraint: return constraint without alignment
	In libparted-1.9 ped_device_get_constraint() would always return a constraint
	without any start / end aligning (grain_size == 1). Now that we are starting to
	support disks with a physical sector size other then 512, the old
	ped_device_get_constraint() code may actually start returning constrains
	with alignment info with a grain_size != 1.

	Since this is a behavior change and since the old code does not take a possible
	alignment info into account, this patch removes the aligning code from
	ped_device_get_constraint(), so that its behavior is unchanged.

	This patch also updates the functions doxygen documentation to reflect what
	it has actually done all these years.

2009-11-01  Hans de Goede  <hdegoede@redhat.com>

	linux: add get_xxx_alignment() functions
	* libparted/arch/linux.c (get_minimum_alignment): New function.
	(get_optimum_alignment): New function.

	linux: save blkid topology in arch_specific data for later use
	This is a preparation patch for adding get_minimum_alignment
	and get_optimum_alignment functions to linux's _PedDeviceArchOps.
	* libparted/arch/linux.h (struct_LinuxSpecific) [probe, topology]:
	Add members.
	* libparted/arch/linux.c (linux_new): initialize
	arch_specific->probe and arch_specific->topology to NULL,
	(linux_destroy): Free arch_specific->probe.
	(get_minimum_io_size): Remove function.
	(get_blkid_topology): New function.
	(_device_set_sector_size): Call get_blkid_topology() instead of
	get_minimum_io_size() and retrieve minimum io size from the cached
	topology.

2009-11-01  Hans de Goede  <hdegoede@redhat.com>

	libparted: add ped_device_get_xxx_alignment() functions
	Add ped_device_get_minimum_alignment() and ped_device_get_optimum_alignment()
	functions to libparted.

	Note this is a resent of my previous patchset with a number of typos corrected:
	aligment -> alignment
	minimal_alignment -> minimum_aligment
	optimal_alignment -> optimum_aligment

	Sorry for the noise.

2009-10-29  Jim Meyering  <meyering@redhat.com>

	tests: protect t7000 from the environment
	* tests/t7000-scripting.sh: Initialize fail=0, so that an
	environment setting cannot perturb the test.

	tests: convert to new testing framework
	* tests/t0200-gpt.sh: Convert to new testing framework.
	* tests/t0201-gpt.sh: Likewise.
	* tests/t0300-dos-on-gpt.sh: Likewise.
	* tests/t0100-print.sh: Likewise.
	* tests/t0250-gpt.sh: Likewise.

	dvh: document an as-yet-unplugged (but not serious) leak
	* libparted/disk.c (ped_disk_add_partition): List some of the
	things I've tried to plug a leak exposed by a root-only test
	on dvh's partition-creation error path.  This leak is enough
	of a corner case that I may even leave it for now, and add a
	suppression for it, so that we're not distracted by it.

2009-10-28  Jim Meyering  <meyering@redhat.com>

	dvh: plug three constraint-sized leaks
	* libparted/labels/dvh.c (dvh_read, dvh_alloc_metadata):
	Free constraint upon failure, too.

	ui: plug multiple command_line_get_word leaks
	* parted/parted.c (do_mkpart, do_print):

	check: plug an even smaller (formatted "unit") leak
	* libparted/disk.c (ped_disk_check): Free fs_size also upon success.

	check: plug a geometry-sized leak
	* libparted/disk.c (ped_disk_check): Destroy "geom", when done with it.

	loop: don't leak a sector in loop_clobber
	* libparted/labels/loop.c (loop_clobber): Replace leaky open-coded
	version with a use of Use ptt_clear_sectors.

	tests: t7000: remove mkpartfs tests
	This test tested both mkpart and mkpartfs.
	* tests/t7000-scripting.sh: Remove the mkpartfs tests.

	tests: remove tests that are too FS-centric
	* tests/t1000-mkpartfs.sh: Remove file.
	* tests/t1500-small-ext2.sh: Likewise.
	* tests/t2000-mkfs.sh: Likewise.
	* tests/t3100-resize-ext2-partion.sh: Likewise.
	* tests/t3000-constraints.sh: Likewise.
	* tests/Makefile.am (TESTS): Remove them here, too.

2009-10-27  Jim Meyering  <meyering@redhat.com>

	ui: plug a constraint leak in do_mkpart
	* parted/parted.c (do_mkpart): Free constraint after using it to
	add partition.

	gpt: plug two gpt-header leaks in gpt_read_headers
	* libparted/labels/gpt.c (gpt_read_headers): Free locals pri and/or
	bak if they are not valid.

	gpt: plug a 1-sector leak in gpt_read_headers
	* libparted/labels/gpt.c (gpt_read_headers): Free a sector.

	ui: plug a leak (partition_print_flags)
	* parted/parted.c (do_print): Free flags, after printing.

	libparted: plug an FS-alias-related leak
	* libparted/filesys.c (ped_file_system_alias_unregister):
	Free the alias we've just unregistered.

2009-10-26  Jim Meyering  <meyering@redhat.com>

	doc: update NEWS
	* NEWS (Bug fixes): Describe two.

2009-10-23  Jim Meyering  <meyering@redhat.com>

	gpt: header validity: also consider whether a PE array crc matches
	* libparted/labels/gpt.c (check_PE_array_CRC): New function.
	(_header_is_valid): Use it to verify that partition entry array
	checksums match, too.
	Karel Zak noticed that this check was not being performed.
	* tests/t0280-gpt-corrupt.sh: Adapt to changed diagnostic.

	gpt: tweak interfaces to pass disk, not disk->dev
	* libparted/labels/gpt.c: required for upcoming CRC-checking function.

	gpt: don't ignore an improbable (1-in-2^32) failure
	pth_crc32 mapped failure to a crc32 value of 0.  If that happened
	to match the stored value, there would be no indication that there
	had been a malloc failure.
	* libparted/labels/gpt.c (pth_crc32): Change interface so we can
	distinguish failure from a CRC value of 0.
	Update all callers.
	(_generate_header): Now that we recognize pth_crc32 can fail,
	we must admit that its void-returning caller _generate_header
	may fail, too.  Return "int" and adjust *its* callers.

	gpt: factor out code that is about to be reused
	* libparted/labels/gpt.c: Include <errno.h>.
	(gpt_read_PE_array): New function, ...
	(gpt_read): ...factored out of this one.  Use it.

	gpt: don't dereference NULL upon OOM (pth_get_raw callers)
	Handle each case in which pth_get_raw may return NULL.
	* libparted/labels/gpt.c (pth_get_raw): Upon OOM error, return 0
	rather than dereferencing NULL.
	(gpt_write): Don't dereference NULL upon OOM error.
	(gpt_read): Yet another.

	gpt: don't dereference NULL upon OOM (in pth_get_raw)
	* libparted/labels/gpt.c (pth_get_raw): Don't dereference NULL
	on out of memory error.

	gpt: remove dead store
	* libparted/labels/gpt.c (pth_crc32): Remove useless initialization.

	gpt: make an internal function "const"-correct
	* libparted/labels/gpt.c (_parse_header): Make "gpt" const.

	tests: convert t0280 to new test style.
	* tests/t0280-gpt-corrupt.sh: Convert to new test style.
	* tests/t-lib.sh: Source t-local.sh.
	* tests/t-local.sh: New file.

	gpt: clean up
	* libparted/labels/gpt.c (gpt_probe): Remove now-useless test before
	pth_free.
	(gpt_read): Use ptt_clear_sectors in place of open-coded equivalent.
	* cfg.mk (useless_free_options): Add --name=pth_free.

2009-10-23  Jim Meyering  <meyering@redhat.com>

	gpt: make its header check a tiny bit more strict
	* libparted/labels/gpt.c (_header_is_valid): Declare a header
	to be invalid if its AlternateLBA is the same as MyLBA.

	2009-10-21  Jim Meyering  <meyering@redhat.com>

	complete most of gpt-CRC-related rewrite
	* libparted/labels/gpt.c (_read_header): Remove now-unused function.

2009-10-23  Jim Meyering  <meyering@redhat.com>

	t0280-gpt-corrupt.sh: adapt for new output, improve test

	gpt: rewrite GPT header-reading code
	* libparted/labels/gpt.c (read_header): Remove now-unused function.
	(gpt_read_headers): New function.
	(gpt_read): Rewrite to use gpt_read_headers.

	gpt: require that the backup table's AlternateLBA is 1
	* libparted/labels/gpt.c (_header_is_valid): When checking
	the backup header, ensure that its AlternateLBA is 1.

	tests: gpt: test for detection of corrupt backup partition header
	* tests/t0280-gpt-corrupt.sh: Corrupt the backup partition header's
	MyLBA, and require that an attempt to print the table fails.

	tests: hook up new GPT-crc-corrupting script
	* tests/Makefile.am (TESTS): Add t0280-gpt-corrupt.sh.
	* libparted/labels/gpt.c (gpt_read): Change diagnostic to say that
	the PTE CRC mismatch is in the primary table.
	* tests/t0280-gpt-corrupt.sh: Tweak diagnostic to match
	what the code now prints.

	gpt: also verify MyLBA when checking table validity
	* libparted/labels/gpt.c (_header_is_valid): Add parameter, my_lba.
	(_read_header): Update caller.
	(_parse_header): Comment out this use of _header_is_valid
	in an assertion.

	gpt: clean up formatting of static initializers
	* libparted/labels/gpt.c (NULL_IF_DISCOVER_ONLY): Define.
	(gpt_disk_ops): Use it to avoid in-decl #if directives.

2009-10-20  Jim Meyering  <meyering@redhat.com>

	gpt.c: filter through indent --no-tabs...
	and manual fix-up to shorten long lines.
	Also, manually format the static initializers in e.g., gpt_disk_ops,
	since GNU indent botches that.

2009-10-19  Jim Meyering  <meyering@redhat.com>

	gpt: add a comment
	* libparted/labels/gpt.c (_header_is_valid): Add a comment to explain
	the new partition entry size limitation of UINT32_MAX/16.

	build: update gnulib submodule to latest

	tests: use scsi_debug to test-for 4k-sector-specific bug
	* tests/t9010-big-sector.sh: New root-only test.
	Requires 2.6.31, and the scsi_debug module, /sys/block/... support
	and an upcoming version of libblkid.
	* tests/Makefile.am (TESTS): Add t9010-big-sector.sh.
	Thanks to Mike Snitzer for advice and for pointing me to similar
	code he wrote to test LVM.

	tests: begin the transition to coreutils' testing framework
	The existing testing framework makes it hard to diagnose test failures,
	so I'm switching to one that works better for me, from coreutils.
	* tests/t-lib.sh: New file.  Mostly from coreutils/tests/test-lib.sh.
	* tests/Makefile.am (TMPDIR): Update to pass more info to test scripts.
	(EXTRA_DIST): Add t-lib.sh.

	linux: use libblkid to determine ->phys_sector_size
	Before this change, creating a memory-mapped disk on a fedora-based
	system running 2.6.31.1-56.fc12.x86_64 using this command:
	modprobe scsi_debug dev_size_mb=1025 sector_size=4096
	and then running "parted -s /dev/sdd mklabel gpt print"
	would mistakenly print "Sector size (logical/physical): 4096B/512B"
	The "512B" is what's wrong.  It should be "4096B".
	* configure.ac: Test for a new-enough blkid library.
	* libparted/Makefile.am (libparted_la_LIBADD): Add $(LIB_BLKID).
	* libparted/arch/linux.c (get_minimum_io_size): New function.
	(_device_set_sector_size): Use it.

	libparted: weaken a diagnostic
